(* ::Package:: *)

Options[xvaPlot]={Background->GrayLevel[0.9`],PlotStyle->{RGBColor[0,0,0.6`],Thickness[0.01`]}};
xvaPlot[expr_,{t_,tMin_,tMax_},opts___]:=GraphicsGrid[{{Plot[expr,{t,tMin,tMax},opts,AxesLabel->{"\!\(\*
StyleBox[\"t\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)(s)","\!\(\*
StyleBox[\"x\",\nFontSlant->\"Italic\"]\) (m)"},Evaluate[Options[xvaPlot]]]},{Plot[Evaluate[\!\(
\*SubscriptBox[\(\[PartialD]\), \(t\)]expr\)],{t,tMin,tMax},opts,AxesLabel->{"\!\(\*
StyleBox[\"t\",\nFontSlant->\"Italic\"]\) (s)","\!\(\*
StyleBox[\"v\",\nFontSlant->\"Italic\"]\) (m/s)"},Evaluate[Options[xvaPlot]]]},{Plot[Evaluate[\!\(
\*SubscriptBox[\(\[PartialD]\), \(t, t\)]expr\)],{t,tMin,tMax},opts,AxesLabel->{"\!\(\*
StyleBox[\"t\",\nFontSlant->\"Italic\"]\) (s)","\!\(\*
StyleBox[\"a\",\nFontSlant->\"Italic\"]\) (m/\!\(\*SuperscriptBox[\"s\", \"2\"]\))"},Evaluate[Options[xvaPlot]]]}}]


MinPolynomial[x_,conditions__List]:=
With[
{ords=-1+Length/@{conditions}},
With[{deg=-1+Plus@@ords,
maxord=Max[ords]},
Module[
{a,poly},
(poly=\!\(
\*UnderoverscriptBox[\(\[Sum]\), \(p = 0\), \(deg\)]\(a[p]\ 
\*SuperscriptBox[\(x\), \(p\)]\)\))/.
Solve[((D[poly,{x,#[[-1]]-1}]/.x->#[[1]])==#[[2]])&/@Flatten[With[{alist=Rest[#]},With[{L=Length[alist]},{Table[First[#],{L}],alist,Range[L]}//Transpose]]&/@{conditions},1],Table[a[i],{i,0,deg}]]//First
]]]


Options[CurveLinePlot]=
{CurvePlotStyle->{RGBColor[0,0,.6],Thickness[.005]},
TangentPlotStyle->{RGBColor[0,.7,0],Thickness[.01]},
SecantPlotStyle->{RGBColor[.8,0,0],Thickness[.01]},
Background->GrayLevel[.9],AxesLabel->None,AdditionalPlotOptions->{}};


PositionLinePlot[{expr_,lines___},{\[Tau]_,\[Tau]Min_,\[Tau]Max_},opts___]:=CurveLinePlot[{t=.;expr,lines},{\[Tau],\[Tau]Min,\[Tau]Max},AxesLabel->{"t (s)","x (m)"},opts];VelocityLinePlot[{expr_,lines___},{\[Tau]_,\[Tau]Min_,\[Tau]Max_},opts___]:=CurveLinePlot[{t=.;\!\(
\*SubscriptBox[\(\[PartialD]\), \(t\)]expr\),lines},{\[Tau],\[Tau]Min,\[Tau]Max},AxesLabel->{"t (s)","v (m/s)"},opts];AccelerationLinePlot[{expr_,lines___},{\[Tau]_,\[Tau]Min_,\[Tau]Max_},opts___]:=CurveLinePlot[{t=.;\!\(
\*SubscriptBox[\(\[PartialD]\), \(t, t\)]expr\),lines},{\[Tau],\[Tau]Min,\[Tau]Max},AxesLabel->{"t (s)","a (m/s^2)"},opts];


CurveLinePlot[{expr_,lines___},{\[Tau]_,\[Tau]Min_,\[Tau]Max_},opts___]/;And@@((Head[#]===TangentLine\[Or]Head[#]===SecantLine)&)/@{lines}:=
Plot@@
With[
{BG=Background/.{opts}/.Options[CurveLinePlot],
AL=AxesLabel/.{opts}/.Options[CurveLinePlot],
APO=AdditionalPlotOptions/.{opts}/.Options[CurveLinePlot]},
Transpose[
{lines,{expr,CurvePlotStyle/.{opts}/.Options[CurveLinePlot]}}//.
{{x___,TangentLine[t0_List,OPTS___],y___}:>Join[{x},TangentLine[#,OPTS]&/@{t0},{y}],
{x___,SecantLine[t1_List,t2_,OPTS___],y___}:>Join[{x},SecantLine[#,t2,OPTS]&/@{t1},{y}],
{x___,SecantLine[t1_,t2_List,OPTS___],y___}:>Join[{x},SecantLine[t1,#,OPTS]&/@{t2},{y}]}/.
{TangentLine[t0_,OPTS___]:>{(\!\(
\*SubscriptBox[\(\[PartialD]\), \(t\)]expr\)/.t->t0) (t-t0)+(expr/.t->t0),If[{OPTS}==={},TangentPlotStyle/.Options[CurveLinePlot],{OPTS}]},
SecantLine[t1_,t2_,OPTS___]:>{((expr/.t->t2) -(expr/.t->t1))/(t2-t1) (t-t1)+(expr/.t->t1),If[{OPTS}==={},SecantPlotStyle/.Options[CurveLinePlot],{OPTS}]}}
]//({#[[1]],{\[Tau],\[Tau]Min,\[Tau]Max},PlotStyle->#[[2]],Background->BG,AxesLabel->AL,APO}&)]
