(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     26030,        795]
NotebookOptionsPosition[     24437,        745]
NotebookOutlinePosition[     24933,        765]
CellTagsIndexPosition[     24890,        762]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Field Plotting", "Subtitle",
 TextAlignment->Center,
 TextJustification->0],

Cell[TextData[{
 "We represent a vector ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[LeftAngleBracket]", 
    RowBox[{"a", ",", "b"}], "\[RightAngleBracket]"}], TraditionalForm]]],
 " in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " by using curly brackets ",
 Cell[BoxData[
  FormBox[
   RowBox[{"{", 
    RowBox[{"a", ",", "b"}], "}"}], TraditionalForm]]],
 ".  The magnitude, or norm, of a vector ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[LeftDoubleBracketingBar]", " ", 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{"a", ",", "b"}], "\[RightAngleBracket]"}], " ", 
    "\[RightDoubleBracketingBar]"}], TraditionalForm]]],
 " is given by ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["Norm",
     FontWeight->"Bold"], "[", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b"}], "}"}], "]"}], TraditionalForm]]],
 " in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ".  We will also define two functions: ",
 StyleBox["Unit",
  FontWeight->"Bold"],
 " gives a unit vector in direction of a vector and ",
 StyleBox["Invsq",
  FontWeight->"Bold"],
 " takes the vector ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["r", "\[RightVector]"], TraditionalForm]]],
 "  to  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     OverscriptBox["r", "^"], "/", 
     SuperscriptBox[
      RowBox[{"\[LeftDoubleBracketingBar]", 
       OverscriptBox["r", "\[RightVector]"], "\[RightDoubleBracketingBar]"}], 
      "2"]}], "=", 
    RowBox[{
     OverscriptBox["r", "\[RightVector]"], "/", 
     SuperscriptBox[
      RowBox[{"\[LeftDoubleBracketingBar]", 
       OverscriptBox["r", "\[RightVector]"], "\[RightDoubleBracketingBar]"}], 
      "3"]}]}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{
  3.398955174852724*^9, {3.398956031368341*^9, 3.398956064534443*^9}, {
   3.3989561357973824`*^9, 3.398956137398629*^9}}],

Cell[TextData[{
 "To evaluate ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " input place the cursor anywhere in the cell to input and hit Shift+Enter, \
\[ShiftKey]\[EnterKey] ."
}], "Text",
 CellChangeTimes->{{3.3989548962505617`*^9, 3.3989549551235723`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unit", "[", "v_", "]"}], ":=", 
  FractionBox["v", 
   RowBox[{"Norm", "[", "v", "]"}]]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"InvSq", "[", "v_", "]"}], ":=", 
  FractionBox["v", 
   SuperscriptBox[
    RowBox[{"Norm", "[", "v", "]"}], "3"]]}]}], "Input",
 CellChangeTimes->{{3.3989558867127438`*^9, 3.398955890064438*^9}, {
  3.3989559391473846`*^9, 3.39895594002561*^9}}],

Cell["\<\
Evaluate the following to show the behavior of these tree funcitons evaluate \
the following.\
\>", "Text",
 CellChangeTimes->{{3.398956097018221*^9, 3.398956111715575*^9}, {
  3.398956142140224*^9, 3.398956150763505*^9}}],

Cell[BoxData[
 RowBox[{"Norm", "[", 
  RowBox[{"{", 
   RowBox[{"a", ",", "b"}], "}"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"Unit", "[", 
  RowBox[{"{", 
   RowBox[{"a", ",", "b"}], "}"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"InvSq", "[", 
  RowBox[{"{", 
   RowBox[{"a", ",", "b"}], "}"}], "]"}]], "Input"],

Cell[TextData[{
 "The electric field for a point charge ",
 StyleBox["Q",
  FontSlant->"Italic"],
 " is  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    OverscriptBox["E", "\[RightVector]"], "=", 
    RowBox[{
     SubscriptBox["k", "e"], " ", "Q", " "}]}], TraditionalForm]]],
 Cell[BoxData[
  FormBox[
   FractionBox[
    OverscriptBox["r", "\[RightVector]"], 
    SuperscriptBox["r", "3"]], TraditionalForm]]],
 ".  Here we will take the charge to be integers and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["k", "e"], "=", "1"}], TraditionalForm]]],
 " for simplicity.  The electric field for a point charge of magnitude 1 at \
the origin becomes:"
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"e", "[", 
    RowBox[{"{", 
     RowBox[{"x_", ",", "y_"}], "}"}], "]"}], ":=", 
   RowBox[{"InvSq", "[", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.3989516223751383`*^9, 3.3989516317122707`*^9}, {
  3.398956166935926*^9, 3.398956171117388*^9}}],

Cell[TextData[{
 "The ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " function ",
 StyleBox["VectorFieldPlots",
  FontWeight->"Bold"],
 " plots the vector arrows for a vector field at each point in a grid.  Below \
is the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " code for plotting a point charge a the origin.  The ranges in the ",
 StyleBox["x",
  FontSlant->"Italic"],
 " and ",
 StyleBox["y",
  FontSlant->"Italic"],
 " directions are ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"-", "3"}], "\[LessEqual]", "x", "\[LessEqual]", "3"}], 
   TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"-", "3"}], "\[LessEqual]", "y", "\[LessEqual]", "3"}], 
   TraditionalForm]]],
 ".  The option  ",
 Cell[BoxData[
  FormBox[
   RowBox[{"PlotPoints", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"8", ",", "8"}], "}"}]}], TraditionalForm]]],
 " creates an ",
 Cell[BoxData[
  FormBox[
   RowBox[{"8", "\[Times]", "8"}], TraditionalForm]]],
 " grid of points."
}], "Text",
 CellChangeTimes->{3.397312725412024*^9}],

Cell[BoxData[
 RowBox[{"<<", "\"\<VectorFieldPlots`\>\""}]], "Input"],

Cell[BoxData[
 RowBox[{"VectorFieldPlot", "[", 
  RowBox[{
   RowBox[{"e", "[", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}], ",", 
   RowBox[{"PlotPoints", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"8", ",", "8"}], "}"}]}], ",", 
   RowBox[{"Frame", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.39731053745516*^9, 3.397310564305098*^9}, 
   3.397313636440823*^9, {3.398945581686367*^9, 3.3989455891404877`*^9}, {
   3.3989516485596943`*^9, 3.398951650909577*^9}, {3.3989561815684557`*^9, 
   3.398956184070006*^9}}],

Cell["\<\
The above plot is not that helpful.  The problem is the field approaches \
infinity as one approached the charge at the center.  To improve this we will \
just show the direction of the field by plotting the unit vector of the field \
only.\
\>", "Text"],

Cell[BoxData[
 RowBox[{"VectorFieldPlot", "[", 
  RowBox[{
   RowBox[{"Unit", "[", 
    RowBox[{"e", "[", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y"}], "}"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}], ",", 
   RowBox[{"PlotPoints", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"16", ",", "16"}], "}"}]}], ",", 
   RowBox[{"Frame", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.397310587019444*^9, 3.397310593564261*^9}, {
  3.397313646503023*^9, 3.3973136469898977`*^9}, {3.398945599174247*^9, 
  3.398945605588599*^9}, {3.398951662423871*^9, 3.398951664909667*^9}, {
  3.3989561966006603`*^9, 3.398956199350203*^9}}],

Cell[TextData[{
 "The voltage for a point charge is ",
 Cell[BoxData[
  FormBox[
   RowBox[{"V", "=", 
    RowBox[{
     SubscriptBox["k", "e"], 
     FractionBox["Q", "r"]}]}], TraditionalForm]]],
 ".  As before we will take ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["k", "e"], "=", "1"}], TraditionalForm]]],
 " and ",
 StyleBox["Q",
  FontSlant->"Italic"],
 " to be an integer."
}], "Text"],

Cell["For a point charge of charge 1 at the origin becomes:", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"V", "[", 
    RowBox[{"{", 
     RowBox[{"x_", ",", "y_"}], "}"}], "]"}], ":=", 
   RowBox[{"1", "/", 
    RowBox[{"Norm", "[", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y"}], "}"}], "]"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.3989516745668592`*^9, 3.398951685620739*^9}, {
  3.39895620888008*^9, 3.3989562119894876`*^9}}],

Cell[TextData[{
 "To plot the voltage we will use the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " ",
 StyleBox["ContourPlot",
  FontWeight->"Bold"],
 " function.  "
}], "Text"],

Cell[BoxData[
 RowBox[{"ContourPlot", "[", 
  RowBox[{
   RowBox[{"V", "[", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}], ",", 
   RowBox[{"ContourShading", "\[Rule]", "False"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.398945635806321*^9, 3.3989456507042837`*^9}, {
  3.3989516933673563`*^9, 3.398951695740889*^9}, {3.398956219056012*^9, 
  3.398956221349779*^9}}],

Cell[TextData[{
 "To show a particular equipotential line we can also use the ",
 StyleBox["ContourPlot",
  FontWeight->"Bold"],
 " function.  This is for the ",
 Cell[BoxData[
  FormBox[
   RowBox[{"V", "=", "0.5"}], TraditionalForm]]],
 " equipotential."
}], "Text",
 CellChangeTimes->{{3.3973127528765383`*^9, 3.397312790419177*^9}}],

Cell[BoxData[
 RowBox[{"ContourPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"V", "[", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y"}], "}"}], "]"}], "\[Equal]", "0.5"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.397310668936771*^9, 3.397312501033081*^9, 3.397312806828199*^9, {
   3.398951713467773*^9, 3.39895172430785*^9}, {3.398951813725613*^9, 
   3.398951823477172*^9}, {3.3989562330241003`*^9, 3.3989562355735617`*^9}}],

Cell[TextData[{
 "We can combine the above plots and also show the charge.  The function ",
 StyleBox["DymamicEandVPlot,",
  FontWeight->"Bold"],
 " defined below, does this.  The syntax is \n",
 StyleBox["DymamicEandVPlot",
  FontWeight->"Bold"],
 "[ ",
 Cell[BoxData[
  FormBox[
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["Q", "1"], ",", " ", 
     RowBox[{"{", 
      RowBox[{
       SubscriptBox["x", "1"], ",", " ", 
       SubscriptBox["y", "1"]}], "}"}]}], "}"}], TraditionalForm]]],
 ",  ",
 Cell[BoxData[
  FormBox[
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["Q", "2"], ",", " ", 
     RowBox[{"{", 
      RowBox[{
       SubscriptBox["x", "2"], ",", " ", 
       SubscriptBox["y", "2"]}], "}"}]}], "}"}], TraditionalForm]]],
 ", ... ]"
}], "Text",
 CellChangeTimes->{{3.398952016533865*^9, 3.398952040194965*^9}, {
   3.398956258062323*^9, 3.398956259531913*^9}, {3.399045458568447*^9, 
   3.399045656601615*^9}, 3.399045693690913*^9, {3.399046018976631*^9, 
   3.399046038220334*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"EandVPlot", "[", 
    RowBox[{"QR__List", ",", 
     RowBox[{"OptionsPattern", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"PlotRange", "\[Rule]", "4"}], ",", 
        RowBox[{"PlotPoints", "\[Rule]", "16"}], ",", 
        RowBox[{"ContourStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{"Red", ",", 
           RowBox[{"Thickness", "[", ".00125", "]"}]}], "]"}]}], ",", 
        RowBox[{"PointColor", "\[Rule]", "Blue"}], ",", 
        RowBox[{"PointSize", "\[Rule]", ".02"}]}], "}"}], "]"}]}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Graphics", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"ContourPlot", "[", 
         RowBox[{
          RowBox[{"DiscreteVoltage", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"x", ",", "y"}], "}"}], ",", "QR"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", 
            RowBox[{"-", 
             RowBox[{"OptionValue", "[", "PlotRange", "]"}]}], ",", 
            RowBox[{"OptionValue", "[", "PlotRange", "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", 
            RowBox[{"-", 
             RowBox[{"OptionValue", "[", "PlotRange", "]"}]}], ",", 
            RowBox[{"OptionValue", "[", "PlotRange", "]"}]}], "}"}], ",", 
          RowBox[{"ContourShading", "\[Rule]", "False"}], ",", 
          RowBox[{"ContourStyle", "\[Rule]", 
           RowBox[{"OptionValue", "[", "ContourStyle", "]"}]}]}], "]"}], "//",
         "First"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"VectorFieldPlot", "[", 
         RowBox[{
          RowBox[{"Unit", "[", 
           RowBox[{"DiscreteElectricField", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"x", ",", "y"}], "}"}], ",", "QR"}], "]"}], "]"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"x", ",", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"OptionValue", "[", "PlotRange", "]"}]}], "-", ".5"}], 
            ",", 
            RowBox[{
             RowBox[{"OptionValue", "[", "PlotRange", "]"}], "+", ".5"}]}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"OptionValue", "[", "PlotRange", "]"}]}], "-", ".5"}], 
            ",", 
            RowBox[{
             RowBox[{"OptionValue", "[", "PlotRange", "]"}], "+", ".5"}]}], 
           "}"}], ",", 
          RowBox[{"PlotPoints", "\[Rule]", 
           RowBox[{"OptionValue", "[", "PlotPoints", "]"}]}]}], "]"}], "//", 
        "First"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"OptionValue", "[", "PointColor", "]"}], ",", 
         RowBox[{"PointSize", "\[Rule]", 
          RowBox[{"OptionValue", "[", "PointSize", "]"}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"Point", "[", 
            RowBox[{
            "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
            "]"}], "&"}], "/@", 
          RowBox[{"{", "QR", "}"}]}]}], "}"}]}], "}"}], ",", 
     RowBox[{"Frame", "\[Rule]", "Automatic"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DynamicEandVPlot", "[", 
   RowBox[{"QR_List", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"PlotRange", "\[Rule]", "4"}], ",", 
        RowBox[{"PlotPoints", "\[Rule]", "16"}], ",", 
        RowBox[{"ContourStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{"Red", ",", 
           RowBox[{"Thickness", "[", ".00125", "]"}]}], "]"}]}], ",", 
        RowBox[{"PointColor", "\[Rule]", "Blue"}], ",", 
        RowBox[{"PointSize", "\[Rule]", ".02"}]}], "}"}], "]"}]}]}], "]"}], ":=",
   "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Q", ",", "p"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Manipulate", "[", 
     RowBox[{
      RowBox[{"EandVPlot", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Q", "[", "1", "]"}], ",", 
          RowBox[{"p", "[", "1", "]"}]}], "}"}], ",", "opts"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Q", "[", "1", "]"}], ",", 
          RowBox[{
          "QR", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
          SubscriptBox["\"\<Q\>\"", 
           RowBox[{"ToString", "[", "1", "]"}]]}], "}"}], ",", 
        RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"p", "[", "1", "]"}], ",", 
          RowBox[{
          "QR", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
         "}"}], ",", "Locator"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DiscreteElectricField", "[", 
   RowBox[{"r_List", ",", "QR___List"}], "]"}], ":=", 
  RowBox[{"Plus", "@@", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
       " ", 
       RowBox[{"InvSq", "[", 
        RowBox[{"r", "-", 
         RowBox[{
         "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
        "]"}]}], "&"}], ")"}], "/@", 
    RowBox[{"{", "QR", "}"}]}]}]}], "\n", 
 RowBox[{
  RowBox[{"DiscreteVoltage", "[", 
   RowBox[{"r_List", ",", "QR___List"}], "]"}], ":=", 
  RowBox[{"Plus", "@@", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
       RowBox[{"Norm", "[", 
        RowBox[{"r", "-", 
         RowBox[{
         "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
        "]"}]], "&"}], ")"}], "/@", 
    RowBox[{"{", "QR", "}"}]}]}]}], "\n", 
 RowBox[{
  RowBox[{"DynamicEandVPlot", "[", 
   RowBox[{"QR1_List", ",", "QR2_List", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"PlotRange", "\[Rule]", "4"}], ",", 
        RowBox[{"PlotPoints", "\[Rule]", "16"}], ",", 
        RowBox[{"ContourStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{"Red", ",", 
           RowBox[{"Thickness", "[", ".00125", "]"}]}], "]"}]}], ",", 
        RowBox[{"PointColor", "\[Rule]", "Blue"}], ",", 
        RowBox[{"PointSize", "\[Rule]", ".02"}]}], "}"}], "]"}]}]}], "]"}], ":=",
   "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Q", ",", "p"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Manipulate", "[", 
     RowBox[{
      RowBox[{"EandVPlot", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Q", "[", "1", "]"}], ",", 
          RowBox[{"p", "[", "1", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Q", "[", "2", "]"}], ",", 
          RowBox[{"p", "[", "2", "]"}]}], "}"}], ",", "opts"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Q", "[", "1", "]"}], ",", 
          RowBox[{
          "QR1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
          
          SubscriptBox["\"\<Q\>\"", 
           RowBox[{"ToString", "[", "1", "]"}]]}], "}"}], ",", 
        RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Q", "[", "2", "]"}], ",", 
          RowBox[{
          "QR2", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
          
          SubscriptBox["\"\<Q\>\"", 
           RowBox[{"ToString", "[", "2", "]"}]]}], "}"}], ",", 
        RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"p", "[", "1", "]"}], ",", 
          RowBox[{
          "QR1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
         "}"}], ",", "Locator"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"p", "[", "2", "]"}], ",", 
          RowBox[{
          "QR2", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
         "}"}], ",", "Locator"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.398945788829091*^9, 3.398945796859703*^9}, {
   3.398945846915338*^9, 3.398945879931481*^9}, {3.398950102593636*^9, 
   3.398950116124516*^9}, {3.3989501737406588`*^9, 3.398950193197052*^9}, {
   3.398950259463139*^9, 3.3989502662287197`*^9}, {3.398951000896419*^9, 
   3.398951058161962*^9}, {3.398960745268606*^9, 3.398960746129257*^9}, {
   3.39896213423241*^9, 3.398962162433301*^9}, {3.3989652763087673`*^9, 
   3.398965283882361*^9}, {3.3989653158022842`*^9, 3.398965321227313*^9}, {
   3.398965351285222*^9, 3.398965431124597*^9}, {3.3989654743866777`*^9, 
   3.3989655327307262`*^9}, {3.3989656014037*^9, 3.398965645022789*^9}, {
   3.39896584658642*^9, 3.398965902588416*^9}, {3.398966135574802*^9, 
   3.398966140228397*^9}, {3.3989664983045*^9, 3.3989665510086107`*^9}, {
   3.398966706025193*^9, 3.39896670689646*^9}, {3.398966743096547*^9, 
   3.39896678733035*^9}, {3.398966847297991*^9, 3.398966847622868*^9}, {
   3.398966926833362*^9, 3.398966956823403*^9}, {3.3989671409908123`*^9, 
   3.398967229151882*^9}, {3.398967302731155*^9, 3.398967367934976*^9}, {
   3.398967573546905*^9, 3.398967716929994*^9}, {3.398967905293066*^9, 
   3.398967923127613*^9}, {3.3989679616737137`*^9, 3.398967986772043*^9}, 
   3.398968027948044*^9, {3.398969649623331*^9, 3.398969685625993*^9}, {
   3.398969766869019*^9, 3.3989698576837597`*^9}, 3.3989701066399803`*^9, {
   3.3989904964768543`*^9, 3.398990554803172*^9}, 3.3990457459292297`*^9, {
   3.399045847717099*^9, 3.399045849597094*^9}, {3.399046107348761*^9, 
   3.399046108307802*^9}, {3.3990461874646893`*^9, 3.399046238673601*^9}, 
   3.39904632260295*^9, 3.3990469478547*^9, 3.399047088029828*^9}],

Cell[BoxData[
 RowBox[{"DynamicEandVPlot", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.399045440618452*^9, 3.3990454456560802`*^9}, {
  3.3990456989654284`*^9, 3.399045711464322*^9}, {3.3990460462891283`*^9, 
  3.399046047749593*^9}}],

Cell[BoxData[" "], "Input",
 CellFrame->{{0, 0}, {0.5, 0}}],

Cell[TextData[{
 "Below is a repeat of the code for the previous case.  Modify this to plot \
the electric field and voltage for a dipole, with a point charge of ",
 Cell[BoxData[
  FormBox[
   RowBox[{"Q", "=", 
    RowBox[{"-", "1"}]}], TraditionalForm]]],
 " at ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}]}], ")"}], TraditionalForm]]],
 " and a point charge of ",
 Cell[BoxData[
  FormBox[
   RowBox[{"Q", "=", "1"}], TraditionalForm]]],
 " at ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    RowBox[{"0", ",", "1"}], ")"}], TraditionalForm]]],
 " "
}], "Text",
 CellChangeTimes->{{3.399046449451975*^9, 3.399046521397314*^9}}],

Cell[BoxData[
 RowBox[{"DynamicEandVPlot", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.399045440618452*^9, 3.3990454456560802`*^9}, {
  3.3990456989654284`*^9, 3.399045711464322*^9}, {3.3990460462891283`*^9, 
  3.399046047749593*^9}}],

Cell[BoxData[" "], "Input",
 CellFrame->{{0, 0}, {0.5, 0}}],

Cell[TextData[{
 "Below is a repeat of the code for the first case.  Modify this to plot the \
electric field and voltage for a point charge of ",
 Cell[BoxData[
  FormBox[
   RowBox[{"Q", "=", "3"}], TraditionalForm]]],
 " at ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[LeftAngleBracket]", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}]}], "\[RightAngleBracket]"}], TraditionalForm]]],
 " and a point charge of ",
 Cell[BoxData[
  FormBox[
   RowBox[{"Q", "=", 
    RowBox[{"-", "2"}]}], TraditionalForm]]],
 " at ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[LeftAngleBracket]", 
    RowBox[{"0", ",", "1"}], "\[RightAngleBracket]"}], TraditionalForm]]]
}], "Text",
 CellChangeTimes->{{3.3990466146066513`*^9, 3.399046615316473*^9}}],

Cell[BoxData[
 RowBox[{"DynamicEandVPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"PlotPoints", "\[Rule]", "32"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "15"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.399045440618452*^9, 3.3990454456560802`*^9}, {
  3.3990456989654284`*^9, 3.399045711464322*^9}, {3.3990460462891283`*^9, 
  3.399046047749593*^9}, {3.399046703096332*^9, 3.399046742933181*^9}}]
}, Open  ]]
},
WindowToolbars->"EditBar",
WindowSize->{1052, 970},
WindowMargins->{{Automatic, 244}, {Automatic, 0}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
Magnification->1.25,
FrontEndVersion->"6.0 for Mac OS X x86 (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 81, 2, 57, "Subtitle"],
Cell[674, 27, 1843, 62, 60, "Text"],
Cell[2520, 91, 268, 7, 32, "Text"],
Cell[2791, 100, 418, 11, 103, "Input"],
Cell[3212, 113, 232, 5, 32, "Text"],
Cell[3447, 120, 104, 3, 33, "Input"],
Cell[3554, 125, 104, 3, 33, "Input"],
Cell[3661, 130, 105, 3, 33, "Input"],
Cell[3769, 135, 675, 23, 68, "Text"],
Cell[4447, 160, 353, 10, 33, "Input"],
Cell[4803, 172, 1063, 41, 70, "Text"],
Cell[5869, 215, 69, 1, 33, "Input"],
Cell[5941, 218, 736, 19, 33, "Input"],
Cell[6680, 239, 264, 5, 51, "Text"],
Cell[6947, 246, 793, 20, 33, "Input"],
Cell[7743, 268, 409, 17, 47, "Text"],
Cell[8155, 287, 69, 0, 32, "Text"],
Cell[8227, 289, 378, 11, 33, "Input"],
Cell[8608, 302, 187, 8, 32, "Text"],
Cell[8798, 312, 562, 15, 33, "Input"],
Cell[9363, 329, 336, 10, 32, "Text"],
Cell[9702, 341, 611, 16, 33, "Input"],
Cell[10316, 359, 1005, 32, 53, "Text"],
Cell[11324, 393, 10373, 259, 755, "Input"],
Cell[21700, 654, 337, 8, 33, "Input"],
Cell[22040, 664, 59, 1, 44, "Input"],
Cell[22102, 667, 680, 24, 51, "Text"],
Cell[22785, 693, 337, 8, 33, "Input"],
Cell[23125, 703, 59, 1, 44, "Input"],
Cell[23187, 706, 732, 23, 51, "Text"],
Cell[23922, 731, 499, 11, 33, "Input"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
