(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    102878,       2114]
NotebookOptionsPosition[     43659,        878]
NotebookOutlinePosition[    102094,       2086]
CellTagsIndexPosition[    102051,       2083]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Exercise"
}], "Title"],

Cell["Two Dimensional Kinematics", "Subtitle",
 CellChangeTimes->{{3.398419267523658*^9, 3.398419281043619*^9}}],

Cell["Phys 2425 - Blinn College", "Subsubtitle",
 CellChangeTimes->{{3.398418998688014*^9, 3.398418999797389*^9}}],

Cell[CellGroupData[{

Cell["Introduction", "Section"],

Cell["\<\
This is an exercise to help with the visualization of two-dimensional \
kinematics\
\>", "Text",
 CellChangeTimes->{{3.3984190155803223`*^9, 3.398419052699242*^9}},
 FontFamily->"Times"],

Cell["Load Package", "Subsubsection"],

Cell["\<\
To load the needed package evaluate the following input cell.   To evaluate \
input click \[ShiftKey]\[EnterKey] somewhere in the input cell.\
\>", "Text",
 FontFamily->"Times"],

Cell[BoxData[
 RowBox[{"<<", "Kinematics2D`"}]], "Input",
 CellChangeTimes->{{3.398419062477899*^9, 3.398419069412284*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Define Position Function", "Section",
 CellChangeTimes->{{3.398419189686737*^9, 3.398419209579279*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tFinal", "=", 
   RowBox[{"Make2DTrajectory", "[", 
    RowBox[{"0", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1.25"}]}], "}"}], ",", 
     RowBox[{"StraightPath", "[", 
      RowBox[{"1", ",", 
       RowBox[{"-", ".5"}]}], "]"}], ",", 
     RowBox[{"StraightPath", "[", 
      RowBox[{"1", ",", ".5"}], "]"}], ",", 
     RowBox[{"CircularPath", "[", 
      RowBox[{"2.5", ",", 
       RowBox[{"120", "\[Degree]"}], ",", 
       RowBox[{"-", ".1"}]}], "]"}], ",", 
     RowBox[{"StraightPath", "[", 
      RowBox[{"1", ",", ".1"}], "]"}], ",", 
     RowBox[{"CircularPath", "[", 
      RowBox[{"2.5", ",", 
       RowBox[{"150", "\[Degree]"}], ",", ".3"}], "]"}], ",", 
     RowBox[{"StraightPath", "[", 
      RowBox[{"3", ",", 
       RowBox[{"-", ".2"}]}], "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{"ParametricPlot", "[", 
  RowBox[{
   RowBox[{"PositionVector", "[", "t", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tFinal"}], "}"}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.398358252833778*^9, 3.3983582884568872`*^9}, {
   3.398358454226708*^9, 3.398358475573765*^9}, {3.398359729621479*^9, 
   3.398359731883432*^9}, {3.398359917027337*^9, 3.39835992791535*^9}, {
   3.3983615523558893`*^9, 3.398361574753829*^9}, {3.398361643251728*^9, 
   3.3983617116265717`*^9}, {3.398361787900407*^9, 3.398361844850234*^9}, 
   3.3983618910685863`*^9, 3.398365235377088*^9, {3.398366186263671*^9, 
   3.398366197314788*^9}, {3.39837238828718*^9, 3.398372389132958*^9}, {
   3.3983725322713747`*^9, 3.398372533957005*^9}, {3.398372647086513*^9, 
   3.398372657692782*^9}, {3.398373836182639*^9, 3.398373836860733*^9}, {
   3.398381253248859*^9, 3.398381255624043*^9}, {3.398381543864244*^9, 
   3.398381592142694*^9}, {3.39838173460843*^9, 3.3983817665204067`*^9}, {
   3.398381854032332*^9, 3.398381896758339*^9}, {3.3983819783442574`*^9, 
   3.39838198431874*^9}, 3.401218092064631*^9, {3.401218130991693*^9, 
   3.401218156526938*^9}, {3.401218740558585*^9, 3.40121874125618*^9}, {
   3.401218787734556*^9, 3.401218794920249*^9}, 3.401218838272438*^9, {
   3.401218886338225*^9, 3.4012190110538387`*^9}, {3.4012190666306067`*^9, 
   3.4012190669531593`*^9}, {3.401219098468581*^9, 3.4012190988162203`*^9}, 
   3.4012192427106457`*^9}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], 
     LineBox[{{-2., 2.99513999761997}, {-2., 2.99513999761997}, {-2., 
      2.66535803533764}, {-2., 2.3480705579689802`}, {-2., 
      2.094546736433626}, {-2., 2.0029260494178796`}}], 
     LineBox[{{-2., 1.873181786509602}, {-2., 1.596162052269531}, {-2., 
      1.2955188764324412`}, {-2., 1.207065706355651}, {-2., 
      1.115628192218558}, {-2., 1.0687903061273982`}, {-2., 
      1.0212063340211628`}, {-2., 1.0152058783349485`}, {-2., 
      1.0091937650547484`}, {-2., 1.0057582898349975`}}], 
     LineBox[CompressedData["
1:eJwV13k8VO37B3CVEJ5IhWztkUTZ2uQSQuUrFVKWKOJBhWxZilKpFEnliaKI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      "]], 
     LineBox[{{1.7785123920578534`, -1.1486018722312548`}, {
      1.9735094623769562`, -1.0360202611913323`}, {
      2.1627579306445437`, -0.9267576070933166}, {
      2.3758026711253732`, -0.8037561688272754}, {
      2.592987121801052, -0.6783646677658713}, {
      2.596211131641673, -0.676503284816519}, {
      2.599436831094838, -0.674640926368909}, {
      2.6058932988387986`, -0.6709132829789195}, {
      2.6126491018619076`, -0.6670128182849354}}], LineBox[CompressedData["
1:eJwVl3k4lN0bx2fGMjPMPNNrS0hIimRLpcK5W8RL2duoX6jXkpI3WkiSRCiV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      "]], 
     LineBox[{{1.3560929277656872`, 3.9999999999999996`}, {
      1.3404029820479617`, 3.9999999999999996`}, {1.3197595995143532`, 
      3.9999999999999996`}, {1.0135904675894047`, 3.9999999999999996`}, {
      0.7115306032804383, 3.9999999999999996`}, {0.13121432975797753`, 
      3.9999999999999996`}, {-0.48053097727573224`, 
      3.9999999999999996`}, {-1.0345959275965693`, 
      3.9999999999999996`}, {-1.616864827028302, 
      3.9999999999999996`}, {-1.6254218355951506`, 
      3.9999999999999996`}, {-1.633974596215562, 
      3.9999999999999996`}}]}, {}}, {{}, {}, {}}},
  Axes->True,
  AxesLabel->{
    FormBox["x", TraditionalForm], 
    FormBox["y", TraditionalForm]},
  AxesOrigin->{0, 0},
  ImageSize->{301., Automatic},
  PlotRange->{{-2., 3.866023284920221}, {-1.4999994926276567`, 
   3.9999999999999996`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.401282322428281*^9, 3.401282375014928*^9, 
  3.401282958292142*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Position Graphs", "Section",
 CellChangeTimes->{{3.398419189686737*^9, 3.398419209579279*^9}, {
  3.3984192398852863`*^9, 3.3984192445153923`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ManipulateTrajectory", "[", 
  RowBox[{"PositionVector", ",", "0", ",", "tFinal", ",", 
   RowBox[{"VelocityVectorScale", "\[Rule]", "1"}], ",", 
   RowBox[{"AccelerationVectorScale", "\[Rule]", "2.5"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "3.5"}], ",", "5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "2.5"}], ",", "5"}], "}"}]}], "}"}]}]}], "]"}]], "Input",\

 CellChangeTimes->{{3.398417579223734*^9, 3.398417579997304*^9}, {
   3.401218219703635*^9, 3.4012182200513477`*^9}, 3.40121832055764*^9}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`ShowAccelerationVector$$ = 
    True, $CellContext`ShowComponentTimeGraphs$$ = 
    False, $CellContext`ShowPoint$$ = 
    True, $CellContext`ShowPositionVector$$ = 
    True, $CellContext`ShowVelocityVector$$ = True, $CellContext`t$$ = 
    6.761319130998898, Typeset`show$$ = True, Typeset`bookmarkList$$ = {}, 
    Typeset`bookmarkMode$$ = "Menu", Typeset`animator$$, Typeset`animvar$$ = 
    1, Typeset`name$$ = "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`ShowPoint$$], True, 
       Style["Show Position?", 
        GrayLevel[0], Bold]}, {True, False}}, {{
       Hold[$CellContext`ShowComponentTimeGraphs$$], False, 
       Style["Show x vs. t and y vs. t Graphs?", Bold]}, {True, False}}, {{
       Hold[$CellContext`ShowPositionVector$$], False, 
       Style["Show Position Vector?", 
        RGBColor[1, 0, 0], Bold]}, {True, False}}, {{
       Hold[$CellContext`ShowVelocityVector$$], False, 
       Style["Show Velocity Vector?", 
        RGBColor[0, 0, 1], Bold]}, {True, False}}, {{
       Hold[$CellContext`ShowAccelerationVector$$], False, 
       Style["Show Acceleration Vector?", 
        RGBColor[0, 0.6, 0], Bold]}, {True, False}}, {
      Hold[$CellContext`t$$], 0.001, 14.458731968252255`}}, Typeset`size$$ = {
    540., {236., 246.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = True, $CellContext`ShowPoint$363$$ = 
    False, $CellContext`ShowComponentTimeGraphs$364$$ = 
    False, $CellContext`ShowPositionVector$365$$ = 
    False, $CellContext`ShowVelocityVector$366$$ = 
    False, $CellContext`ShowAccelerationVector$367$$ = 
    False, $CellContext`t$368$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`ShowAccelerationVector$$ = 
        False, $CellContext`ShowComponentTimeGraphs$$ = 
        False, $CellContext`ShowPoint$$ = 
        True, $CellContext`ShowPositionVector$$ = 
        False, $CellContext`ShowVelocityVector$$ = False, $CellContext`t$$ = 
        0.001}, "ControllerVariables" :> {
        Hold[$CellContext`ShowPoint$$, $CellContext`ShowPoint$363$$, False], 
        Hold[$CellContext`ShowComponentTimeGraphs$$, \
$CellContext`ShowComponentTimeGraphs$364$$, False], 
        Hold[$CellContext`ShowPositionVector$$, \
$CellContext`ShowPositionVector$365$$, False], 
        Hold[$CellContext`ShowVelocityVector$$, \
$CellContext`ShowVelocityVector$366$$, False], 
        Hold[$CellContext`ShowAccelerationVector$$, \
$CellContext`ShowAccelerationVector$367$$, False], 
        Hold[$CellContext`t$$, $CellContext`t$368$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> 
      With[{$CellContext`MainGraph$ = Graphics[{
            First[
             ParametricPlot[
              $CellContext`PositionVector[$CellContext`t$$], \
{$CellContext`t$$, 0, $CellContext`tFinal}, AxesOrigin -> {0, 0}, 
              AxesLabel -> {$CellContext`x, $CellContext`y}]], 
            If[$CellContext`ShowPositionVector$$, {
              
              OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                   5}}}, $CellContext`PositionVectorColor], 
              Arrowheads[
              0.05 OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                  2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                    5}}}, $CellContext`ArrowheadsScale]], 
              Thickness[
              0.01 OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                  2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                    5}}}, $CellContext`ArrowThicknessScale]], 
              Arrow[{{0, 0}, 
                $CellContext`PositionVector[$CellContext`t$$]}]}, {}], 
            If[$CellContext`ShowVelocityVector$$, {
              
              OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                   5}}}, $CellContext`VelocityVectorColor], 
              Arrowheads[
              0.05 OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                  2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                    5}}}, $CellContext`ArrowheadsScale]], 
              Thickness[
              0.01 OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                  2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                    5}}}, $CellContext`ArrowThicknessScale]], 
              Arrow[{
                $CellContext`PositionVector[$CellContext`t$$], \
$CellContext`PositionVector[$CellContext`t$$] + 
                OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                    2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                    5}}}, $CellContext`VelocityVectorScale] 
                 Derivative[
                  1][$CellContext`PositionVector][$CellContext`t$$]}]}, {}], 
            If[$CellContext`ShowAccelerationVector$$, {
              
              OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                   5}}}, $CellContext`AccelerationVectorColor], 
              Arrowheads[
              0.05 OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                  2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                    5}}}, $CellContext`ArrowheadsScale]], 
              Thickness[
              0.01 OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                  2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                    5}}}, $CellContext`ArrowThicknessScale]], 
              Arrow[{
                $CellContext`PositionVector[$CellContext`t$$], \
$CellContext`PositionVector[$CellContext`t$$] + 
                OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                    2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                    5}}}, $CellContext`AccelerationVectorScale] 
                 Derivative[
                  2][$CellContext`PositionVector][$CellContext`t$$]}]}, {}], 
            If[$CellContext`ShowPoint$$, {
              
              OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                   5}}}, $CellContext`PositionPointColor], 
              PointSize[
               
               OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                 2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                    5}}}, $CellContext`PositionPointSize]], 
              Point[
               $CellContext`PositionVector[$CellContext`t$$]]}, {}]}, Axes -> 
           True, AxesLabel -> {$CellContext`x, $CellContext`y}, PlotRange -> 
           OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
              2.5, PlotRange -> {{-3.5, 5}, {-2.5, 5}}}, PlotRange]]}, 
        If[$CellContext`ShowComponentTimeGraphs$$, 
         GraphicsColumn[{$CellContext`MainGraph$, 
           GraphicsColumn[{
             Plot[
              Part[
               $CellContext`PositionVector[$CellContext`t$$], 
               1], {$CellContext`t$$, 0, 14.459731968252255`}, Epilog -> {
                
                OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                  2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                    5}}}, $CellContext`PositionPointColor], 
                PointSize[
                 
                 OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                   2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                    5}}}, $CellContext`PositionPointSize]], 
                Point[{$CellContext`t$$, 
                  Part[
                   $CellContext`PositionVector[$CellContext`t$$], 1]}]}, 
              AxesLabel -> {"t", "x"}, AspectRatio -> 0.3], 
             Plot[
              Part[
               $CellContext`PositionVector[$CellContext`t$$], 
               2], {$CellContext`t$$, 0, 14.459731968252255`}, Epilog -> {
                
                OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                  2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                    5}}}, $CellContext`PositionPointColor], 
                PointSize[
                 
                 OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 1, $CellContext`AccelerationVectorScale -> 
                   2.5, PlotRange -> {{-3.5, 5}, {-2.5, 
                    5}}}, $CellContext`PositionPointSize]], 
                Point[{$CellContext`t$$, 
                  Part[
                   $CellContext`PositionVector[$CellContext`t$$], 2]}]}, 
              AxesLabel -> {"t", "y"}, AspectRatio -> 
              0.3]}]}], $CellContext`MainGraph$]], 
      "Specifications" :> {{{$CellContext`ShowPoint$$, True, 
          Style["Show Position?", 
           GrayLevel[0], Bold]}, {
         True, False}}, {{$CellContext`ShowComponentTimeGraphs$$, False, 
          Style["Show x vs. t and y vs. t Graphs?", Bold]}, {
         True, False}}, {{$CellContext`ShowPositionVector$$, False, 
          Style["Show Position Vector?", 
           RGBColor[1, 0, 0], Bold]}, {
         True, False}}, {{$CellContext`ShowVelocityVector$$, False, 
          Style["Show Velocity Vector?", 
           RGBColor[0, 0, 1], Bold]}, {
         True, False}}, {{$CellContext`ShowAccelerationVector$$, False, 
          Style["Show Acceleration Vector?", 
           RGBColor[0, 0.6, 0], Bold]}, {True, False}}, {$CellContext`t$$, 
         0.001, 14.458731968252255`}}, "Options" :> {}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{587., {389.5625, 397.4375}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{
  3.4012823831299267`*^9, 3.4012829612152243`*^9, {3.401286866293103*^9, 
   3.401286877484243*^9}, 3.4012922911998987`*^9, 3.401292347627316*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Average Velocity", "Section",
 CellChangeTimes->{{3.398419189686737*^9, 3.398419209579279*^9}, {
  3.398419250580524*^9, 3.398419255444482*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ManipulateAverageVelocity", "[", 
  RowBox[{"PositionVector", ",", "0", ",", "tFinal", ",", 
   RowBox[{"VelocityVectorScale", "\[Rule]", "2"}], ",", 
   RowBox[{"AccelerationVectorScale", "\[Rule]", "5"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "3.5"}], ",", "5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "2.5"}], ",", "5"}], "}"}]}], "}"}]}]}], "]"}]], "Input"],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`ShowAverageVelocityVector$$ = 
    True, $CellContext`ShowDeltaPositionVector$$ = 
    True, $CellContext`ShowPoints$$ = 
    True, $CellContext`ShowPositionVectors$$ = 
    True, $CellContext`ShowVelocityVector$$ = True, $CellContext`t$$ = 
    4.33, $CellContext`t2$$ = 3.9099999999999997`, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`ShowPoints$$], True, 
       Style["Show Positions?", 
        GrayLevel[0], Bold]}, {True, False}}, {{
       Hold[$CellContext`ShowPositionVectors$$], False, 
       Style["Show Both Position Vectors?", 
        RGBColor[1, 0, 0], Bold]}, {True, False}}, {{
       Hold[$CellContext`ShowDeltaPositionVector$$], False, 
       Style[
       "Show \[CapitalDelta]\[VeryThinSpace]\!\(\*OverscriptBox[\"r\", \"\
\[RightVector]\"]\) Vector?", 
        RGBColor[0, 0.6, 0], Bold]}, {True, False}}, {{
       Hold[$CellContext`ShowAverageVelocityVector$$], False, 
       Style["Show Average Velocity Vector?", 
        GrayLevel[0], Bold]}, {True, False}}, {{
       Hold[$CellContext`ShowVelocityVector$$], False, 
       Style["Show Velocity Vector at t?", 
        RGBColor[0, 0, 1], Bold]}, {True, False}}, {{
       Hold[$CellContext`t$$], 4.819910656084085}, 0.001, 
      14.458731968252255`}, {{
       Hold[$CellContext`t2$$], 9.63982131216817, "t+\[CapitalDelta]t"}, 
      0.001, 14.458731968252255`}}, Typeset`size$$ = {540., {236., 246.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`ShowPoints$598$$ = 
    False, $CellContext`ShowPositionVectors$599$$ = 
    False, $CellContext`ShowDeltaPositionVector$600$$ = 
    False, $CellContext`ShowAverageVelocityVector$601$$ = 
    False, $CellContext`ShowVelocityVector$602$$ = 
    False, $CellContext`t$603$$ = 0, $CellContext`t2$604$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`ShowAverageVelocityVector$$ = 
        False, $CellContext`ShowDeltaPositionVector$$ = 
        False, $CellContext`ShowPoints$$ = 
        True, $CellContext`ShowPositionVectors$$ = 
        False, $CellContext`ShowVelocityVector$$ = False, $CellContext`t$$ = 
        4.819910656084085, $CellContext`t2$$ = 9.63982131216817}, 
      "ControllerVariables" :> {
        Hold[$CellContext`ShowPoints$$, $CellContext`ShowPoints$598$$, False],
         
        Hold[$CellContext`ShowPositionVectors$$, \
$CellContext`ShowPositionVectors$599$$, False], 
        Hold[$CellContext`ShowDeltaPositionVector$$, \
$CellContext`ShowDeltaPositionVector$600$$, False], 
        Hold[$CellContext`ShowAverageVelocityVector$$, \
$CellContext`ShowAverageVelocityVector$601$$, False], 
        Hold[$CellContext`ShowVelocityVector$$, \
$CellContext`ShowVelocityVector$602$$, False], 
        Hold[$CellContext`t$$, $CellContext`t$603$$, 0], 
        Hold[$CellContext`t2$$, $CellContext`t2$604$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Graphics[{
         First[
          ParametricPlot[
           $CellContext`PositionVector[$CellContext`t$$], {$CellContext`t$$, 
            0, $CellContext`tFinal}, AxesOrigin -> {0, 0}, 
           AxesLabel -> {$CellContext`x, $CellContext`y}]], 
         If[$CellContext`ShowPositionVectors$$, {
           
           OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
             5, PlotRange -> {{-3.5, 5}, {-2.5, 
                5}}}, $CellContext`PositionVectorColor], 
           Arrowheads[
           0.05 OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
               5, PlotRange -> {{-3.5, 5}, {-2.5, 
                  5}}}, $CellContext`ArrowheadsScale]], 
           Thickness[
           0.01 OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
               5, PlotRange -> {{-3.5, 5}, {-2.5, 
                  5}}}, $CellContext`ArrowThicknessScale]], 
           Arrow[{{0, 0}, 
             $CellContext`PositionVector[$CellContext`t$$]}], 
           Arrow[{{0, 0}, 
             $CellContext`PositionVector[$CellContext`t2$$]}]}, {}], 
         If[$CellContext`ShowDeltaPositionVector$$, {
           
           OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
             5, PlotRange -> {{-3.5, 5}, {-2.5, 
                5}}}, $CellContext`DeltaPositionVectorColor], 
           Arrowheads[
           0.05 OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
               5, PlotRange -> {{-3.5, 5}, {-2.5, 
                  5}}}, $CellContext`ArrowheadsScale]], 
           Thickness[
           0.01 OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
               5, PlotRange -> {{-3.5, 5}, {-2.5, 
                  5}}}, $CellContext`ArrowThicknessScale]], 
           Arrow[{
             $CellContext`PositionVector[$CellContext`t$$], 
             $CellContext`PositionVector[$CellContext`t2$$]}]}, {}], 
         If[$CellContext`ShowAverageVelocityVector$$, {
           
           OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
             5, PlotRange -> {{-3.5, 5}, {-2.5, 
                5}}}, $CellContext`AverageVelocityVectorColor], 
           Arrowheads[
           0.05 OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
               5, PlotRange -> {{-3.5, 5}, {-2.5, 
                  5}}}, $CellContext`ArrowheadsScale]], 
           Thickness[
           0.01 OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
               5, PlotRange -> {{-3.5, 5}, {-2.5, 
                  5}}}, $CellContext`ArrowThicknessScale]], 
           If[$CellContext`t2$$ == $CellContext`t$$, 
            Arrow[{
              $CellContext`PositionVector[$CellContext`t$$], \
$CellContext`PositionVector[$CellContext`t$$] + 
              OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
                  5, PlotRange -> {{-3.5, 5}, {-2.5, 
                    5}}}, $CellContext`VelocityVectorScale] 
               Derivative[1][$CellContext`PositionVector][$CellContext`t$$]}],
             
            Arrow[{
              $CellContext`PositionVector[$CellContext`t$$], \
$CellContext`PositionVector[$CellContext`t$$] + 
              OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
                  5, PlotRange -> {{-3.5, 5}, {-2.5, 
                    5}}}, $CellContext`VelocityVectorScale] \
($CellContext`PositionVector[$CellContext`t2$$] - \
$CellContext`PositionVector[$CellContext`t$$])/($CellContext`t2$$ - \
$CellContext`t$$)}]]}, {}], 
         If[$CellContext`ShowVelocityVector$$, {
           
           OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
             5, PlotRange -> {{-3.5, 5}, {-2.5, 
                5}}}, $CellContext`VelocityVectorColor], 
           Arrowheads[
           0.05 OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
               5, PlotRange -> {{-3.5, 5}, {-2.5, 
                  5}}}, $CellContext`ArrowheadsScale]], 
           Thickness[
           0.01 OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
               5, PlotRange -> {{-3.5, 5}, {-2.5, 
                  5}}}, $CellContext`ArrowThicknessScale]], 
           Arrow[{
             $CellContext`PositionVector[$CellContext`t$$], \
$CellContext`PositionVector[$CellContext`t$$] + 
             OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
                 5, PlotRange -> {{-3.5, 5}, {-2.5, 
                    5}}}, $CellContext`VelocityVectorScale] 
              Derivative[
               1][$CellContext`PositionVector][$CellContext`t$$]}]}, {}], 
         If[$CellContext`ShowPoints$$, {
           
           OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
             5, PlotRange -> {{-3.5, 5}, {-2.5, 
                5}}}, $CellContext`PositionPointColor], 
           PointSize[
            
            OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
              5, PlotRange -> {{-3.5, 5}, {-2.5, 
                 5}}}, $CellContext`PositionPointSize]], 
           Point[
            $CellContext`PositionVector[$CellContext`t$$]], 
           Point[
            $CellContext`PositionVector[$CellContext`t2$$]]}, {}]}, Axes -> 
        True, AxesLabel -> {$CellContext`x, $CellContext`y}, PlotRange -> 
        OptionValue[$CellContext`Kinematics2D, \
{$CellContext`VelocityVectorScale -> 2, $CellContext`AccelerationVectorScale -> 
           5, PlotRange -> {{-3.5, 5}, {-2.5, 5}}}, PlotRange]], 
      "Specifications" :> {{{$CellContext`ShowPoints$$, True, 
          Style["Show Positions?", 
           GrayLevel[0], Bold]}, {
         True, False}}, {{$CellContext`ShowPositionVectors$$, False, 
          Style["Show Both Position Vectors?", 
           RGBColor[1, 0, 0], Bold]}, {
         True, False}}, {{$CellContext`ShowDeltaPositionVector$$, False, 
          Style[
          "Show \[CapitalDelta]\[VeryThinSpace]\!\(\*OverscriptBox[\"r\", \"\
\[RightVector]\"]\) Vector?", 
           RGBColor[0, 0.6, 0], Bold]}, {
         True, False}}, {{$CellContext`ShowAverageVelocityVector$$, False, 
          Style["Show Average Velocity Vector?", 
           GrayLevel[0], Bold]}, {
         True, False}}, {{$CellContext`ShowVelocityVector$$, False, 
          Style["Show Velocity Vector at t?", 
           RGBColor[0, 0, 1], Bold]}, {
         True, False}}, {{$CellContext`t$$, 4.819910656084085}, 0.001, 
         14.458731968252255`}, {{$CellContext`t2$$, 9.63982131216817, 
          "t+\[CapitalDelta]t"}, 0.001, 14.458731968252255`}}, 
      "Options" :> {}, "DefaultOptions" :> {}],
     ImageSizeCache->{587., {398.0625, 405.9375}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{3.401282427345825*^9, 3.40128296623149*^9}]
}, Open  ]]
}, Open  ]]
},
WindowToolbars->{},
WindowSize->{968, 723},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingCopies->45,
PrintingPageRange->{1, Automatic},
ShowSelection->True,
DefaultNewCellStyle->"Input",
FontFamily->"Times",
Magnification->1.5,
FrontEndVersion->"6.0 for Mac OS X x86 (32-bit) (June 19, 2007)",
StyleDefinitions->Notebook[{
   Cell[
    CellGroupData[{
      Cell["Style Definitions", "Title"], 
      Cell[
      "Modify the definitions below to change the default appearance of all \
cells in a given style.  Make modifications to any definition using commands \
in the Format menu.", "Text"], 
      Cell[
       CellGroupData[{
         Cell["Style Environment Names", "Section"], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, ScriptMinSize -> 
          9], 
         Cell[
          StyleData[All, "Presentation"], PageWidth -> WindowWidth, 
          ScriptMinSize -> 9], 
         Cell[
          StyleData[All, "SlideShow"], PageWidth -> WindowWidth, 
          ScrollingOptions -> {
           "PagewiseDisplay" -> True, "VerticalScrollRange" -> Fit}, 
          ShowCellBracket -> False, ScriptMinSize -> 9], 
         Cell[
          StyleData[All, "Printout"], PageWidth -> PaperWidth, ScriptMinSize -> 
          7, FontSize -> 10, 
          PrivateFontOptions -> {"FontType" -> "Outline"}]}, Open]], 
      Cell[
       CellGroupData[{
         Cell["Notebook Options", "Section"], 
         Cell[
         "The options defined for the style below will be used at the \
Notebook level.", "Text"], 
         Cell[
          StyleData["Notebook"], PageHeaders -> {{
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"], None, 
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"]}, {
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"], None, 
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"]}}, 
          PrintingOptions -> {
           "FirstPageFace" -> Right, "FirstPageHeader" -> False}, 
          StyleMenuListing -> None, Background -> 
          RGBColor[0.900008, 0.863996, 0.809995]]}, Open]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headings", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Title"], ShowCellBracket -> False, 
             CellMargins -> {{0, 0}, {0, 0}}, PageBreakBelow -> False, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, TextAlignment -> Center, TextJustification -> 0, 
             LineSpacing -> {1, 13}, 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}}, FontFamily -> "Helvetica", FontSize -> 34, 
             FontWeight -> "Bold", FontColor -> GrayLevel[1], Background -> 
             RGBColor[0.0500038, 0.100008, 0.2]], 
            Cell[
             StyleData["Title", "Presentation"], 
             CellFrameMargins -> {{14, 10}, {15, 15}}, FontSize -> 51], 
            Cell[
             StyleData["Title", "Printout"], CellMargins -> {{0, 0}, {0, 0}}, 
             FontSize -> 24, Background -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subtitle"], ShowCellBracket -> False, 
             CellMargins -> {{0, 0}, {0, 0}}, PageBreakBelow -> False, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, TextAlignment -> Center, TextJustification -> 0, 
             LineSpacing -> {1, 3}, ParagraphIndent -> -96, 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}}, FontFamily -> "Helvetica", FontSize -> 24, 
             FontColor -> GrayLevel[1], Background -> 
             RGBColor[0.250004, 0.400015, 0.6]], 
            Cell[
             StyleData["Subtitle", "Presentation"], 
             CellFrameMargins -> {{14, 10}, {14, 14}}, FontSize -> 27], 
            Cell[
             StyleData["Subtitle", "Printout"], 
             CellMargins -> {{0, 0}, {0, 0}}, ParagraphIndent -> -85, 
             FontSize -> 16]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubtitle"], ShowCellBracket -> False, 
             CellMargins -> {{0, 0}, {0, 0}}, PageBreakBelow -> False, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, TextAlignment -> Right, TextJustification -> 0, 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}}, FontFamily -> "Helvetica", FontSize -> 16, 
             FontSlant -> "Italic", Background -> 
             RGBColor[0.624994, 0.700008, 0.8]], 
            Cell[
             StyleData["Subsubtitle", "Presentation"], 
             CellMargins -> {{0, 0}, {0, 0}}, FontSize -> 24], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{0, 0}, {0, 0}}, FontSize -> 16]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellFrame -> {{0, 0}, {0, 1.5}}, 
             CellDingbat -> None, CellMargins -> {{12, Inherited}, {4, 24}}, 
             CellGroupingRules -> {"SectionGrouping", 30}, PageBreakBelow -> 
             False, CellFrameMargins -> {{0, 4}, {6, 2}}, CellFrameColor -> 
             RGBColor[0.0500038, 0.100008, 0.2], CellFrameLabelMargins -> 2, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, CounterIncrements -> "Section", 
             CounterAssignments -> {{"Subsection", 0}, {"Subsubsection", 0}}, 
             FontFamily -> "Helvetica", FontSize -> 18, FontWeight -> "Bold", 
             FontColor -> RGBColor[0.0500038, 0.100008, 0.2]], 
            Cell[
             StyleData["Section", "Presentation"], 
             CellFrame -> {{0, 0}, {0, 2}}, 
             CellMargins -> {{14, 10}, {6, 24}}, FontSize -> 27], 
            Cell[
             StyleData["Section", "Printout"], 
             CellMargins -> {{9, 0}, {2, 50}}, FontSize -> 14, FontTracking -> 
             "Plain", FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellMargins -> {{12, 10}, {25, 0}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, LineSpacing -> {1, 3}, ParagraphSpacing -> {0, 12},
              FontFamily -> "Helvetica"], 
            Cell[
             StyleData["Subsection", "Presentation"], 
             CellMargins -> {{14, 10}, {45, 4}}, FontSize -> 18], 
            Cell[
             StyleData["Subsection", "Printout"], 
             CellMargins -> {{9, 0}, {4, 40}}, FontSize -> 12]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsection"], CellMargins -> {{12, 10}, {5, 20}}, 
             CellFrameMargins -> {{0, 0}, {0, 2}}, CellFrameColor -> 
             RGBColor[0.100008, 0.2, 0.4], 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, LineSpacing -> {1, 0}, ParagraphSpacing -> {0, 12},
              FontFamily -> "Helvetica", FontSize -> 14, FontWeight -> "Bold",
              FontSlant -> "Italic", FontColor -> 
             RGBColor[0.100008, 0.2, 0.4]], 
            Cell[
             StyleData["Subsubsection", "Presentation"], 
             CellMargins -> {{14, 10}, {8, 20}}, 
             CellFrameMargins -> {{0, 0}, {0, 4}}, FontSize -> 22], 
            Cell[
             StyleData["Subsubsection", "Printout"], 
             CellMargins -> {{19, 0}, {4, 20}}, FontSize -> 13]}, Open]]}, 
        Open]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Body Text", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Text"], CellMargins -> {{12, 10}, {5, 5}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, LineSpacing -> {1, 3}, ParagraphSpacing -> {0, 12},
              FontFamily -> "Times"], 
            Cell[
             StyleData["Text", "Presentation"], 
             CellMargins -> {{14, 10}, {8, 10}}, FontSize -> 18], 
            Cell[
             StyleData["Text", "Printout"], CellMargins -> {{9, 0}, {4, 4}}, 
             Hyphenation -> True, ParagraphSpacing -> {0, 6}, FontSize -> 
             10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Commentary"], CellMargins -> {{52, 10}, {0, 10}}, 
             PageBreakBelow -> False, CellFrameMargins -> {{0, 0}, {0, 2}}, 
             CellFrameColor -> GrayLevel[1], LineSpacing -> {1, 0}, 
             ParagraphSpacing -> {0, 12}, FontFamily -> "Helvetica", FontSize -> 
             10, FontWeight -> "Plain", FontSlant -> "Plain"], 
            Cell[
             StyleData["Commentary", "Presentation"], 
             CellMargins -> {{72, 10}, {4, 14}}, FontSize -> 15], 
            Cell[
             StyleData["Commentary", "Printout"], 
             CellMargins -> {{9, 0}, {4, 4}}, Hyphenation -> True, 
             ParagraphSpacing -> {0, 6}, FontSize -> 10]}, Closed]]}, Open]], 
      
      Cell[
       CellGroupData[{
         Cell["Inline Formatting", "Section"], 
         Cell[
         "These styles are for modifying individual words or letters in a \
cell exclusive of the cell tag.", "Text"], 
         Cell[
          StyleData["RM"], StyleMenuListing -> None, FontWeight -> "Plain", 
          FontSlant -> "Plain"], 
         Cell[
          StyleData["BF"], StyleMenuListing -> None, FontWeight -> "Bold"], 
         Cell[
          StyleData["IT"], StyleMenuListing -> None, FontSlant -> "Italic"], 
         Cell[
          StyleData["TR"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["TI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["TB"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["TBI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["MR"], "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["MO"], "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["MB"], "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["MBO"], "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["SR"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["SO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["SB"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["SBO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SO10"], StyleMenuListing -> None, FontFamily -> 
             "Helvetica", FontSize -> 10, FontWeight -> "Plain", FontSlant -> 
             "Italic"], 
            Cell[
             StyleData["SO10", "Printout"], StyleMenuListing -> None, 
             FontFamily -> "Helvetica", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Inert"], StyleMenuListing -> None, Background -> 
             RGBColor[0.870588, 0.905882, 0.972549]], 
            Cell[
             StyleData["Inert", "Printout"], StyleMenuListing -> None, 
             Background -> GrayLevel[1]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Input/Output", "Section"], 
         Cell[
         "The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Input"], CellFrame -> 4, 
             CellMargins -> {{62, 10}, {0, 2}}, Evaluatable -> True, 
             CellGroupingRules -> "InputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             CellFrameColor -> RGBColor[0.8, 0.700008, 0.6], 
             DefaultFormatType -> DefaultInputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", FormatType -> InputForm, ShowStringCharacters -> True,
              NumberMarks -> True, 
             LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, FontWeight -> 
             "Bold", Background -> GrayLevel[1]], 
            Cell[
             StyleData["Input", "Presentation"], 
             CellFrame -> {{6, 6}, {0, 6}}, CellMargins -> {{72, 10}, {0, 2}},
              CellFrameMargins -> 12, FontSize -> 18], 
            Cell[
             StyleData["Input", "Printout"], CellMargins -> {{37, 0}, {6, 6}},
              LinebreakAdjustments -> {0.85, 2, 10, 1, 1}]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["InlineInput"], Evaluatable -> True, CellGroupingRules -> 
             "InputGrouping", CellHorizontalScrolling -> True, 
             PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             DefaultFormatType -> DefaultInputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, FormatType -> InputForm, 
             ShowStringCharacters -> True, NumberMarks -> True, 
             CounterIncrements -> "Input", FontWeight -> "Bold"], 
            Cell[
             StyleData["InlineInput", "Presentation"], 
             CellMargins -> {{10, 10}, {4, 4}}, FontSize -> 18]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Output"], CellFrame -> {{4, 4}, {4, 0}}, 
             CellMargins -> {{62, 10}, {12, 0}}, CellEditDuplicate -> True, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             CellFrameColor -> RGBColor[0.8, 0.700008, 0.6], 
             DefaultFormatType -> DefaultOutputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", FormatType -> InputForm, Background -> GrayLevel[1]], 
            
            Cell[
             StyleData["Output", "Presentation"], 
             CellFrame -> {{6, 6}, {6, 0}}, 
             CellMargins -> {{72, 10}, {20, 2}}, CellFrameMargins -> 12, 
             FontSize -> 18], 
            Cell[
             StyleData["Output", "Printout"], 
             CellMargins -> {{37, 0}, {6, 2}}]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["InputOnly"], CellFrame -> 4, 
             CellMargins -> {{62, 10}, {4, 2}}, Evaluatable -> True, 
             CellGroupingRules -> "NormalGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             CellFrameColor -> RGBColor[0.8, 0.700008, 0.6], 
             DefaultFormatType -> DefaultInputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", FormatType -> InputForm, ShowStringCharacters -> True,
              NumberMarks -> True, 
             LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, FontWeight -> 
             "Bold", Background -> GrayLevel[1]], 
            Cell[
             StyleData["InputOnly", "Presentation"], CellFrame -> 6, 
             CellMargins -> {{72, 10}, {5, 2}}, CellFrameMargins -> 12, 
             FontSize -> 18], 
            Cell[
             StyleData["InputOnly", "Printout"], 
             LinebreakAdjustments -> {0.85, 2, 10, 1, 1}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["OutputOnly"], CellFrame -> 4, 
             CellMargins -> {{62, 10}, {4, 2}}, CellEditDuplicate -> True, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             CellFrameColor -> RGBColor[0.8, 0.700008, 0.6], 
             DefaultFormatType -> DefaultOutputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", FormatType -> InputForm, Background -> GrayLevel[1]], 
            
            Cell[
             StyleData["OutputOnly", "Presentation"], CellFrame -> 6, 
             CellMargins -> {{72, 10}, {4, 4}}, CellFrameMargins -> 12, 
             FontSize -> 18], 
            Cell[
             StyleData["OutputOnly", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SymbolicExpression"], CellFrame -> 1, 
             CellMargins -> {{62, 10}, {4, 2}}, CellEditDuplicate -> True, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             CellFrameColor -> GrayLevel[0], DefaultFormatType -> 
             DefaultOutputFormatType, "TwoByteSyntaxCharacterAutoReplacement" -> 
             True, HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, FormatType -> 
             InputForm, FontFamily -> "Courier", FontWeight -> "Plain", 
             FontSlant -> "Plain", FontTracking -> "Plain", 
             FontVariations -> {
              "Outline" -> False, "Shadow" -> False, "Underline" -> False}, 
             Background -> GrayLevel[1]], 
            Cell[
             StyleData["SymbolicExpression", "Presentation"], CellFrame -> 2, 
             CellMargins -> {{72, 10}, {4, 4}}, CellFrameMargins -> 12, 
             FontSize -> 18], 
            Cell[
             StyleData["SymbolicExpression", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Message"], 
             CellMargins -> {{52, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             DefaultFormatType -> DefaultOutputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, FormatType -> 
             InputForm, StyleMenuListing -> None, FontColor -> 
             RGBColor[1, 0, 0]], 
            Cell[
             StyleData["Message", "Presentation"], 
             CellMargins -> {{72, 10}, {6, 6}}, FontSize -> 18], 
            Cell[
             StyleData["Message", "Printout"], 
             CellMargins -> {{30, Inherited}, {Inherited, Inherited}}, 
             FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Print"], 
             CellMargins -> {{52, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, ShowCellLabel -> 
             False, CellLabelMargins -> {{21, Inherited}, {
               Inherited, Inherited}}, DefaultFormatType -> 
             DefaultOutputFormatType, "TwoByteSyntaxCharacterAutoReplacement" -> 
             True, HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, FormatType -> 
             InputForm, StyleMenuListing -> None], 
            Cell[
             StyleData["Print", "Presentation"], 
             CellMargins -> {{72, 10}, {6, 6}}, FontSize -> 18], 
            Cell[
             StyleData["Print", "Printout"], 
             CellMargins -> {{30, Inherited}, {Inherited, Inherited}}]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Info"], 
             CellMargins -> {{52, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, ShowCellLabel -> 
             False, CellLabelMargins -> {{21, Inherited}, {
               Inherited, Inherited}}, DefaultFormatType -> 
             DefaultOutputFormatType, "TwoByteSyntaxCharacterAutoReplacement" -> 
             True, HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, FormatType -> 
             InputForm, StyleMenuListing -> None], 
            Cell[
             StyleData["Info", "Presentation"], 
             CellMargins -> {{72, 10}, {6, 6}}, FontSize -> 18], 
            Cell[
             StyleData["Info", "Printout"], 
             CellMargins -> {{30, Inherited}, {Inherited, Inherited}}]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Graphics"], CellFrame -> {{4, 4}, {4, 0}}, 
             CellMargins -> {{62, 10}, {0, 0}}, CellGroupingRules -> 
             "GraphicsGrouping", CellHorizontalScrolling -> True, 
             PageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             CellFrameColor -> RGBColor[0.8, 0.700008, 0.6], 
             DefaultFormatType -> DefaultOutputFormatType, FormatType -> 
             InputForm, ImageMargins -> {{43, Inherited}, {Inherited, 0}}, 
             StyleMenuListing -> None, Background -> GrayLevel[1]], 
            Cell[
             StyleData["Graphics", "Presentation"], 
             CellFrame -> {{6, 6}, {0, 0}}, CellMargins -> {{72, 10}, {0, 0}},
              CellFrameMargins -> 12, FontSize -> 18], 
            Cell[
             StyleData["Graphics", "Printout"], ImageSize -> {250, 250}, 
             ImageMargins -> {{28, Inherited}, {Inherited, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["ImportPict"], CellMargins -> {{52, 10}, {0, 0}}, 
             CellGroupingRules -> "GraphicsGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GeneratedCell -> True, 
             DefaultFormatType -> DefaultOutputFormatType, FormatType -> 
             InputForm, StyleMenuListing -> "ImportPict", Background -> None],
             
            Cell[
             StyleData["ImportPict", "Presentation"], 
             CellMargins -> {{72, 10}, {0, 0}}, FontSize -> 18], 
            Cell[
             StyleData["ImportPict", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["CellLabel"], StyleMenuListing -> None, FontFamily -> 
             "Helvetica", FontSize -> 10, FontWeight -> "Plain", FontSlant -> 
             "Italic", FontColor -> RGBColor[0.2, 0.2, 0.700008]], 
            Cell[
             StyleData["CellLabel", "Presentation"], FontSize -> 15], 
            Cell[
             StyleData["CellLabel", "Printout"], FontFamily -> "Courier", 
             FontSize -> 8, FontSlant -> "Italic", FontColor -> 
             GrayLevel[0]]}, Open]]}, Open]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Unique Items", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PullQuote"], CellFrame -> {{0, 0}, {0, 3}}, 
             CellMargins -> {{0, 250}, {15, 5}}, 
             CellFrameMargins -> {{20, 4}, {8, 6}}, LineSpacing -> {1, 1}, 
             ParagraphSpacing -> {0, 12}, FontFamily -> "Helvetica", FontSize -> 
             12, FontWeight -> "Bold", FontColor -> GrayLevel[1], Background -> 
             RGBColor[0.6, 0, 0.8]], 
            Cell[
             StyleData["PullQuote", "Presentation"], 
             CellFrame -> {{0, 0}, {0, 5}}, 
             CellMargins -> {{0, 250}, {25, 8}}, 
             CellFrameMargins -> {{30, 10}, {10, 10}}, FontSize -> 18], 
            Cell[
             StyleData["PullQuote", "Printout"], 
             CellMargins -> {{9, 0}, {4, 4}}, ParagraphSpacing -> {0, 6}, 
             FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["GrayBox"], CellFrame -> {{0, 0}, {0, 3}}, 
             CellMargins -> {{62, 36}, {10, 5}}, 
             CellFrameMargins -> {{8, 4}, {8, 4}}, LineSpacing -> {1, 3}, 
             ParagraphSpacing -> {0, 12}, FontFamily -> "Helvetica", FontSize -> 
             10, FontWeight -> "Plain", FontColor -> GrayLevel[0], Background -> 
             RGBColor[0.8, 0.700008, 0.6]], 
            Cell[
             StyleData["GrayBox", "Presentation"], 
             CellFrame -> {{0, 0}, {0, 5}}, 
             CellMargins -> {{90, 55}, {16, 5}}, 
             CellFrameMargins -> {{10, 10}, {12, 6}}, FontSize -> 15], 
            Cell[
             StyleData["GrayBox", "Printout"], 
             CellMargins -> {{62, 36}, {10, 5}}, Background -> 
             GrayLevel[0.8]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Picture"], CellFrame -> 4, 
             CellMargins -> {{52, 10}, {0, 0}}, CellGroupingRules -> 
             "GraphicsGrouping", CellHorizontalScrolling -> True, 
             PageBreakWithin -> False, CellFrameColor -> 
             RGBColor[0.8, 0.700008, 0.6], DefaultFormatType -> 
             DefaultOutputFormatType, FormatType -> InputForm, 
             StyleMenuListing -> None, Background -> GrayLevel[1]], 
            Cell[
             StyleData["Picture", "Presentation"], CellFrame -> 6, 
             CellMargins -> {{72, 10}, {0, 6}}, CellFrameMargins -> 12, 
             FontSize -> 18], 
            Cell[
             StyleData["Picture", "Printout"], ImageSize -> {250, 250}, 
             ImageMargins -> {{28, Inherited}, {Inherited, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PictureGroup"], CellFrame -> {{4, 4}, {0, 0}}, 
             CellMargins -> {{52, Inherited}, {0, 0}}, CellGroupingRules -> 
             "GraphicsGrouping", CellHorizontalScrolling -> True, 
             PageBreakWithin -> False, ShowCellLabel -> False, CellFrameColor -> 
             RGBColor[0.8, 0.700008, 0.6], 
             ImageMargins -> {{43, Inherited}, {Inherited, 0}}, 
             StyleMenuListing -> None, Background -> GrayLevel[1]], 
            Cell[
             StyleData["PictureGroup", "Presentation"], 
             CellFrame -> {{6, 6}, {0, 0}}, CellMargins -> {{72, 10}, {0, 0}},
              CellFrameMargins -> 12, FontSize -> 18], 
            Cell[
             StyleData["PictureGroup", "Printout"], ImageSize -> {250, 250}, 
             ImageMargins -> {{28, Inherited}, {Inherited, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["LineSpace"], CellMargins -> {{0, 0}, {0, 0}}, 
             CellElementSpacings -> {"CellMinHeight" -> 2}, FontSize -> 9], 
            Cell[
             StyleData["LineSpace", "Presentation"], 
             CellMargins -> {{0, 4}, {0, 0}}, FontSize -> 14]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Hyperlink Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Hyperlink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
               ButtonData}], 
            Cell[
             StyleData["Hyperlink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["Hyperlink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["Hyperlink", "SlideShow"]], 
            Cell[
             StyleData["Hyperlink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
         "The following styles are for linking automatically to the on-line \
help system.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["MainBookLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["MainBook", #]}]& )}], 
            Cell[
             StyleData["MainBookLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["MainBookLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["MainBookLink", "SlideShow"]], 
            Cell[
             StyleData["MainBookLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["AddOnsLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontColor -> RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["AddOns", #]}]& )}], 
            Cell[
             StyleData["AddOnsLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["AddOnsLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["AddOnsLink", "SlideShow"]], 
            Cell[
             StyleData["AddOnsLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["RefGuideLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontColor -> RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["RefGuide", #]}]& )}], 
            Cell[
             StyleData["RefGuideLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["RefGuideLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["RefGuideLink", "SlideShow"]], 
            Cell[
             StyleData["RefGuideLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["RefGuideLinkText"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["RefGuide", #]}]& )}], 
            Cell[
             StyleData["RefGuideLinkText", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["RefGuideLinkText", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["RefGuideLinkText", "SlideShow"]], 
            Cell[
             StyleData["RefGuideLinkText", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["GettingStartedLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["GettingStarted", #]}]& )}], 
            Cell[
             StyleData["GettingStartedLink", "Presentation"], FontSize -> 16],
             
            Cell[
             StyleData["GettingStartedLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["GettingStartedLink", "SlideShow"]], 
            Cell[
             StyleData["GettingStartedLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["DemosLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["Demos", #]}]& )}], 
            Cell[
             StyleData["DemosLink", "SlideShow"]], 
            Cell[
             StyleData["DemosLink", "Printout"], 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["TourLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["Tour", #]}]& )}], 
            Cell[
             StyleData["TourLink", "SlideShow"]], 
            Cell[
             StyleData["TourLink", "Printout"], 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["OtherInformationLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["OtherInformation", #]}]& )}], 
            Cell[
             StyleData["OtherInformationLink", "Presentation"], FontSize -> 
             16], 
            Cell[
             StyleData["OtherInformationLink", "Condensed"], FontSize -> 11], 
            
            Cell[
             StyleData["OtherInformationLink", "SlideShow"]], 
            Cell[
             StyleData["OtherInformationLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["MasterIndexLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["MasterIndex", #]}]& )}], 
            Cell[
             StyleData["MasterIndexLink", "SlideShow"]], 
            Cell[
             StyleData["MasterIndexLink", "Printout"], 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Palette Styles", "Section"], 
         Cell[
         "The cells below define styles that define standard ButtonFunctions, \
for use in palette buttons.", "Text"], 
         Cell[
          StyleData["Paste"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, After]}]& )}], 
         Cell[
          StyleData["Evaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["EvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionMove[
                FrontEnd`InputNotebook[], All, Cell, 1], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Slide Show Styles", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideShowNavigationBar"], Editable -> False, 
             CellFrame -> True, CellMargins -> {{0, 0}, {3, 3}}, 
             CellElementSpacings -> {"CellMinHeight" -> 0.8125}, 
             CellGroupingRules -> {"SectionGrouping", 30}, CellFrameMargins -> 
             False, CellFrameColor -> GrayLevel[1], CellFrameLabelMargins -> 
             False, TextAlignment -> Center, CounterIncrements -> 
             "SlideShowNavigationBar", StyleMenuListing -> None, FontSize -> 
             10, Magnification -> 1, Background -> GrayLevel[0.8], 
             GridBoxOptions -> {
              BaselinePosition -> Center, 
               GridBoxAlignment -> {
                "Columns" -> {
                  Center, Center, Center, Center, Center, Center, Right, {
                   Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
                 "RowsIndexed" -> {}}, 
               GridBoxItemSize -> {
                "Columns" -> {3.5, 3.5, 3.5, 3.5, 13, 5, {4}}, 
                 "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
                 "RowsIndexed" -> {}}, GridBoxSpacings -> {"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}}], 
            Cell[
             StyleData["SlideShowNavigationBar", "SlideShow"], Deletable -> 
             False, ShowCellBracket -> False, 
             CellMargins -> {{-1, -1}, {-1, -1}}, PageBreakAbove -> True, 
             CellFrameMargins -> {{1, 1}, {0, 0}}], 
            Cell[
             StyleData["SlideShowNavigationBar", "Printout"], 
             CellMargins -> {{18, 4}, {4, 4}}, LineSpacing -> {1, 3}, 
             FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideShowSection"], CellFrame -> {{0, 0}, {0, 0.5}}, 
             CellMargins -> {{0, 0}, {10, 0}}, 
             CellGroupingRules -> {"SectionGrouping", 40}, PageBreakBelow -> 
             False, CellFrameMargins -> {{12, 4}, {6, 12}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, CounterIncrements -> "Section", 
             CounterAssignments -> {{"Subsection", 0}, {"Subsubsection", 0}}, 
             StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 
             18, FontWeight -> "Plain", FontColor -> GrayLevel[1], Background -> 
             RGBColor[0.408011, 0.440726, 0.8]], 
            Cell[
             StyleData["SlideShowSection", "Presentation"], 
             CellFrameMargins -> {{18, 10}, {10, 18}}, FontSize -> 27], 
            Cell[
             StyleData["SlideShowSection", "SlideShow"], ShowCellBracket -> 
             False, PageBreakAbove -> True], 
            Cell[
             StyleData["SlideShowSection", "Printout"], 
             CellMargins -> {{18, 30}, {0, 30}}, CellFrameMargins -> 5, 
             FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideHyperlink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontSize -> 26, FontColor -> 
             GrayLevel[0.400015], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonMargins -> 0.5, 
               ButtonMinHeight -> 0.85, ButtonNote -> None}], 
            Cell[
             StyleData["SlideHyperlink", "Presentation"], 
             CellMargins -> {{10, 10}, {8, 12}}, FontSize -> 36], 
            Cell[
             StyleData["SlideHyperlink", "SlideShow"]], 
            Cell[
             StyleData["SlideHyperlink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideTOCLink"], 
             CellMargins -> {{24, Inherited}, {Inherited, Inherited}}, 
             StyleMenuListing -> None, ButtonStyleMenuListing -> Automatic, 
             FontFamily -> "Helvetica", 
             ButtonBoxOptions -> {
              Active -> True, ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonMargins -> 1.5, 
               ButtonNote -> ButtonData}], 
            Cell[
             StyleData["SlideTOCLink", "Presentation"], 
             CellMargins -> {{35, 10}, {6, 4}}, FontSize -> 18], 
            Cell[
             StyleData["SlideTOCLink", "SlideShow"]], 
            Cell[
             StyleData["SlideTOCLink", "Printout"], 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideTOC"], CellDingbat -> "\[Bullet]", 
             CellMargins -> {{18, Inherited}, {Inherited, Inherited}}, 
             StyleMenuListing -> None, FontFamily -> "Helvetica"], 
            Cell[
             StyleData["SlideTOC", "Presentation"], 
             CellMargins -> {{25, 10}, {6, 6}}, FontSize -> 18], 
            Cell[
             StyleData["SlideTOC", "SlideShow"], FontSize -> 14], 
            Cell[
             StyleData["SlideTOC", "Printout"], FontSize -> 10, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Open]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headers and Footers", "Section"], 
         Cell[
          StyleData["Header"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 9, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["Footer"], CellMargins -> {{0, 0}, {0, 4}}, 
          StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 6],
          
         Cell[
          StyleData["PageNumber"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 9, 
          FontWeight -> "Bold"]}, Open]], 
      Cell[
       CellGroupData[{
         Cell["FormatType Styles", "Section"], 
         Cell[
         "The cells below define styles that are mixed in with the styles of \
most cells.  If a cell's FormatType matches the name of one of the styles \
defined below, then that style is applied between the cell's style and its \
own options.", "Text"], 
         Cell[
          StyleData["CellExpression"], CellFrame -> 1, 
          CellMargins -> {{52, 10}, {4, 2}}, ShowCellLabel -> False, 
          CellLabelMargins -> {{23, Inherited}, {Inherited, Inherited}}, 
          ShowSpecialCharacters -> False, AllowInlineCells -> False, 
          StyleMenuListing -> None, FontFamily -> "Courier", FontSize -> 10, 
          FontColor -> GrayLevel[0], Background -> GrayLevel[1]]}, Open]]}, 
     Open]]}, Visible -> False, FrontEndVersion -> 
  "6.0 for Mac OS X x86 (32-bit) (June 19, 2007)", StyleDefinitions -> 
  "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 90, 4, 75, "Title"],
Cell[661, 27, 112, 1, 60, "Subtitle"],
Cell[776, 30, 114, 1, 48, "Subsubtitle"],
Cell[CellGroupData[{
Cell[915, 35, 31, 0, 74, "Section"],
Cell[949, 37, 196, 5, 33, "Text"],
Cell[1148, 44, 37, 0, 58, "Subsubsection"],
Cell[1188, 46, 187, 4, 33, "Text"],
Cell[1378, 52, 123, 2, 57, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1538, 59, 109, 1, 74, "Section"],
Cell[CellGroupData[{
Cell[1672, 64, 2601, 56, 173, "Input"],
Cell[4276, 122, 14786, 255, 473, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19111, 383, 153, 2, 74, "Section"],
Cell[CellGroupData[{
Cell[19289, 389, 648, 16, 81, "Input"],
Cell[19940, 407, 11463, 218, 838, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[31452, 631, 150, 2, 74, "Section"],
Cell[CellGroupData[{
Cell[31627, 637, 510, 13, 104, "Input"],
Cell[32140, 652, 11491, 222, 855, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
