(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    254099,       7996]
NotebookOptionsPosition[    194026,       6740]
NotebookOutlinePosition[    252460,       7948]
CellTagsIndexPosition[    252417,       7945]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Exercise"
}], "Title"],

Cell["DC CIrcuits", "Subtitle"],

Cell["Phys 2426 - Blinn College", "Subsubtitle"],

Cell[CellGroupData[{

Cell["Introduction", "Section"],

Cell["\<\
This is an exercise to find the equivalent resistance of a resistor network.  \
A node is defined as a point in a circuit of constant voltage.  Since a wire \
in a circuit diagram is implied to be a perfect conductor, throughout a wire \
the voltage is constant.  A junction is some point in a circuit where three \
or more wires meet.  A node, then, is a junction and as far as one can move \
from the junction along ideal conductors.\
\>", "Text",
 FontFamily->"Times"],

Cell["Load Package", "Subsubsection"],

Cell["\<\
To load the needed package evaluate the following input cell.   To evaluate \
input click \[ShiftKey]\[EnterKey] somewhere in the input cell.\
\>", "Text",
 FontFamily->"Times"],

Cell[BoxData[
 RowBox[{"<<", "EquivalentNetwork`"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Series and Parallel Resistor Networks", "Section"],

Cell[TextData[{
 "The function ",
 StyleBox["EquivalentNetwork",
  FontWeight->"Bold"],
 " has the input format:"
}], "Text"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["EquivalentNetwork",
     FontWeight->"Bold"], 
    StyleBox["[",
     FontWeight->"Plain"], 
    StyleBox[
     RowBox[{
      StyleBox["externalnodelist",
       FontSlant->"Italic"], ",", 
      StyleBox["connectionlist",
       FontSlant->"Italic"]}],
     FontWeight->"Plain"], 
    StyleBox["]",
     FontWeight->"Plain"]}], TraditionalForm]]],
 " "
}], "Text",
 TextAlignment->Center,
 TextJustification->0],

Cell[TextData[{
 "where we will usually take ",
 StyleBox["externalnodelist",
  FontSlant->"Italic"],
 " to be a list containing the two nodes of a network that will remain after \
the simplification process.  The point is to find the equivalent capacitance \
between those two nodes."
}], "Text",
 CellChangeTimes->{{3.400239749383506*^9, 3.4002397555435743`*^9}}],

Cell[BoxData[
 RowBox[{"EquivalentNetwork", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Resistance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "3"}], "}"}], ",", "R1"}], "]"}], ",", 
     RowBox[{"Resistance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2", ",", "3"}], "}"}], ",", "R2"}], "]"}]}], "}"}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"EquivalentNetwork", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Resistance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], ",", "R1"}], "]"}], ",", 
     RowBox[{"Resistance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], ",", "R2"}], "]"}]}], "}"}]}], 
  "]"}]], "Input"],

Cell[TextData[{
 "Consider the following  network.  Use the above syntax to input this into \
",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ".  Also solve this by hand."
}], "Text"],

Cell[TextData[Cell[BoxData[
 FormBox[Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .16807 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.471989 0.112045 0.0146725 0.112045 [
[.2479 .05202 -9.59375 -6.53125 ]
[.2479 .05202 9.59375 6.53125 ]
[.69608 .05202 -9.59375 -6.53125 ]
[.69608 .05202 9.59375 6.53125 ]
[.58403 .16407 -9.59375 -6.59375 ]
[.58403 .16407 9.59375 6.59375 ]
[.80812 .16407 -9.59375 -6.53125 ]
[.80812 .16407 9.59375 6.53125 ]
[ 0 0 0 0 ]
[ 1 .16807 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.015 w
.02381 .01467 Mdot
.97619 .01467 Mdot
.5 Mabswid
[ ] 0 setdash
.02381 .01467 m
.13585 .01467 L
s
.13585 .01467 m
.1732 .01467 L
.18387 .02534 L
.20522 .004 L
.22656 .02534 L
.2479 .004 L
.26924 .02534 L
.29058 .004 L
.31192 .02534 L
.3226 .01467 L
.35994 .01467 L
s
gsave
.2479 .05202 -70.5938 -10.5312 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.0625 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(R) show
71.625 16.062 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.812 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
78.188 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.35994 .01467 m
.47199 .01467 L
s
.47199 .01467 m
.58403 .01467 L
s
.58403 .01467 m
.62138 .01467 L
.63205 .02534 L
.65339 .004 L
.67474 .02534 L
.69608 .004 L
.71742 .02534 L
.73876 .004 L
.7601 .02534 L
.77077 .01467 L
.80812 .01467 L
s
gsave
.69608 .05202 -70.5938 -10.5312 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.0625 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(R) show
71.625 16.062 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.812 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
78.188 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.80812 .01467 m
.92017 .01467 L
s
.47199 .12672 m
.47199 .12672 L
s
.47199 .12672 m
.50934 .12672 L
.52001 .13739 L
.54135 .11605 L
.56269 .13739 L
.58403 .11605 L
.60538 .13739 L
.62672 .11605 L
.64806 .13739 L
.65873 .12672 L
.69608 .12672 L
s
gsave
.58403 .16407 -70.5938 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(R) show
71.625 16.062 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.812 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
78.188 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.69608 .12672 m
.69608 .12672 L
s
.69608 .12672 m
.73343 .12672 L
.7441 .13739 L
.76544 .11605 L
.78678 .13739 L
.80812 .11605 L
.82947 .13739 L
.85081 .11605 L
.87215 .13739 L
.88282 .12672 L
.92017 .12672 L
s
gsave
.80812 .16407 -70.5938 -10.5312 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.0625 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(R) show
71.625 16.062 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.812 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
78.188 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.92017 .12672 m
.92017 .12672 L
s
.47199 .12672 m
.47199 .01467 L
s
.92017 .01467 m
.97619 .01467 L
s
.92017 .01467 m
.92017 .12672 L
s
0 0 m
1 0 L
1 .16807 L
0 .16807 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
   GeneratedCell->False,
   CellAutoOverwrite->False,
   ImageSize->{396.375, 66.5},
   ImageMargins->0,
   ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"],
   ImageRangeCache->{{{0, 791.75}, {132, 0}} -> {-4.62907, -0.130959, 
   0.0246495, 0.0246495}}], TraditionalForm]]]], "Text",
 CellChangeTimes->{{3.401283054119385*^9, 3.401283070357773*^9}},
 TextAlignment->Center,
 TextJustification->0],

Cell[TextData[{
 "Now consider the following ",
 StyleBox["very",
  FontSlant->"Italic"],
 " ugly network.  Input this into ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " to solve.  Also solve by hand."
}], "Text"],

Cell[TextData[Cell[BoxData[
 FormBox[Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .79077 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.307692 -0.165788 0.307692 [
[.26923 .09062 -11.5 -6 ]
[.26923 .09062 11.5 6 ]
[.73077 .09062 -11.5 -6 ]
[.73077 .09062 11.5 6 ]
[.08974 .29575 -11.5 -6 ]
[.08974 .29575 11.5 6 ]
[.55128 .29575 -11.5 -6 ]
[.55128 .29575 11.5 6 ]
[.91026 .29575 -11.5 -6 ]
[.91026 .29575 11.5 6 ]
[.26923 .50088 -11.5 -6 ]
[.26923 .50088 11.5 6 ]
[.08974 .60344 -11.5 -6 ]
[.08974 .60344 11.5 6 ]
[.44872 .60344 -11.5 -6 ]
[.44872 .60344 11.5 6 ]
[.24078 .64611 -11.5 -6 ]
[.24078 .64611 11.5 6 ]
[.70232 .56077 -11.5 -6 ]
[.70232 .56077 11.5 6 ]
[.73077 .70601 -11.5 -6 ]
[.73077 .70601 11.5 6 ]
[ 0 0 0 0 ]
[ 1 .79077 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.03846 .01883 m
.03846 .1419 L
s
.96154 .1419 m
.96154 .01883 L
s
.5 .1419 m
.42308 .1419 L
s
.42308 .1419 m
.37179 .1419 L
.35714 .12725 L
.32784 .15656 L
.29853 .12725 L
.26923 .15656 L
.23993 .12725 L
.21062 .15656 L
.18132 .12725 L
.16667 .1419 L
.11538 .1419 L
s
gsave
.26923 .09062 -72.5 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(18) show
73.000 13.000 moveto
1.562 0.000 rmoveto
74.562 13.000 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
82.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.11538 .1419 m
.03846 .1419 L
s
.96154 .1419 m
.88462 .1419 L
s
.88462 .1419 m
.83333 .1419 L
.81868 .12725 L
.78938 .15656 L
.76007 .12725 L
.73077 .15656 L
.70147 .12725 L
.67216 .15656 L
.64286 .12725 L
.62821 .1419 L
.57692 .1419 L
s
gsave
.73077 .09062 -72.5 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(45) show
73.000 13.000 moveto
1.562 0.000 rmoveto
74.562 13.000 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
82.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.57692 .1419 m
.5 .1419 L
s
.03846 .4496 m
.03846 .4496 L
s
.03846 .4496 m
.03846 .39832 L
.05311 .38366 L
.02381 .35436 L
.05311 .32505 L
.02381 .29575 L
.05311 .26645 L
.02381 .23714 L
.05311 .20784 L
.03846 .19319 L
.03846 .1419 L
s
gsave
.08974 .29575 -72.5 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
73.000 13.000 moveto
1.562 0.000 rmoveto
74.562 13.000 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
82.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.03846 .1419 m
.03846 .1419 L
s
.5 .4496 m
.5 .4496 L
s
.5 .4496 m
.5 .39832 L
.51465 .38366 L
.48535 .35436 L
.51465 .32505 L
.48535 .29575 L
.51465 .26645 L
.48535 .23714 L
.51465 .20784 L
.5 .19319 L
.5 .1419 L
s
gsave
.55128 .29575 -72.5 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(15) show
73.000 13.000 moveto
1.562 0.000 rmoveto
74.562 13.000 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
82.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.5 .1419 m
.5 .1419 L
s
.96154 .1419 m
.96154 .1419 L
s
.96154 .1419 m
.96154 .19319 L
.94689 .20784 L
.97619 .23714 L
.94689 .26645 L
.97619 .29575 L
.94689 .32505 L
.97619 .35436 L
.94689 .38366 L
.96154 .39832 L
.96154 .4496 L
s
gsave
.91026 .29575 -72.5 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(20) show
73.000 13.000 moveto
1.562 0.000 rmoveto
74.562 13.000 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
82.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.96154 .4496 m
.96154 .4496 L
s
.5 .1419 m
.03846 .4496 L
s
.03846 .4496 m
.11538 .4496 L
s
.11538 .4496 m
.16667 .4496 L
.18132 .46425 L
.21062 .43495 L
.23993 .46425 L
.26923 .43495 L
.29853 .46425 L
.32784 .43495 L
.35714 .46425 L
.37179 .4496 L
.42308 .4496 L
s
gsave
.26923 .50088 -72.5 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(20) show
73.000 13.000 moveto
1.562 0.000 rmoveto
74.562 13.000 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
82.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.42308 .4496 m
.5 .4496 L
s
.5 .4496 m
.96154 .4496 L
s
.03846 .75729 m
.03846 .75729 L
s
.03846 .75729 m
.03846 .70601 L
.05311 .69136 L
.02381 .66205 L
.05311 .63275 L
.02381 .60344 L
.05311 .57414 L
.02381 .54484 L
.05311 .51553 L
.03846 .50088 L
.03846 .4496 L
s
gsave
.08974 .60344 -72.5 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(36) show
73.000 13.000 moveto
1.562 0.000 rmoveto
74.562 13.000 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
82.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.03846 .4496 m
.03846 .4496 L
s
.5 .4496 m
.5 .4496 L
s
.5 .4496 m
.5 .50088 L
.48535 .51553 L
.51465 .54484 L
.48535 .57414 L
.51465 .60344 L
.48535 .63275 L
.51465 .66205 L
.48535 .69136 L
.5 .70601 L
.5 .75729 L
s
gsave
.44872 .60344 -72.5 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(24) show
73.000 13.000 moveto
1.562 0.000 rmoveto
74.562 13.000 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
82.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.5 .75729 m
.5 .75729 L
s
.03846 .4496 m
.14122 .5181 L
s
.14122 .5181 m
.18389 .54655 L
.18796 .56687 L
.22859 .55874 L
.23672 .59938 L
.27736 .59125 L
.28549 .63189 L
.32612 .62376 L
.33425 .6644 L
.35457 .66034 L
.39724 .68878 L
s
gsave
.24078 .64611 -72.5 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(30) show
73.000 13.000 moveto
1.562 0.000 rmoveto
74.562 13.000 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
82.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.39724 .68878 m
.5 .75729 L
s
.96154 .4496 m
.85878 .5181 L
s
.85878 .5181 m
.81611 .54655 L
.79579 .54249 L
.78766 .58312 L
.74702 .575 L
.7389 .61563 L
.69826 .60751 L
.69013 .64814 L
.64949 .64002 L
.64543 .66034 L
.60276 .68878 L
s
gsave
.70232 .56077 -72.5 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(20) show
73.000 13.000 moveto
1.562 0.000 rmoveto
74.562 13.000 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
82.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.60276 .68878 m
.5 .75729 L
s
.96154 .75729 m
.96154 .4496 L
s
.03846 .75729 m
.5 .75729 L
s
.96154 .75729 m
.88462 .75729 L
s
.88462 .75729 m
.83333 .75729 L
.81868 .74264 L
.78938 .77194 L
.76007 .74264 L
.73077 .77194 L
.70147 .74264 L
.67216 .77194 L
.64286 .74264 L
.62821 .75729 L
.57692 .75729 L
s
gsave
.73077 .70601 -72.5 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(18) show
73.000 13.000 moveto
1.562 0.000 rmoveto
74.562 13.000 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
82.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.57692 .75729 m
.5 .75729 L
s
.02 w
.03846 .01883 Mdot
.96154 .01883 Mdot
0 0 m
1 0 L
1 .79077 L
0 .79077 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
   GeneratedCell->False,
   CellAutoOverwrite->False,
   ImageSize->{294.125, 232.5625},
   ImageMargins->0,
   ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"],
   ImageRangeCache->{{{0, 587.25}, {464.125, 0}} -> {-1.62591, 0.538799, 
   0.0110747, 0.0110747}}], TraditionalForm]]]], "Text",
 CellChangeTimes->{{3.4012830775427103`*^9, 3.401283077542839*^9}},
 TextAlignment->Center,
 TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EquivalentNetwork", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Resistance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "3"}], "}"}], ",", "18"}], "]"}], ",", 
     RowBox[{"Resistance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "3"}], "}"}], ",", "12"}], "]"}], ",", 
     RowBox[{"Resistance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"3", ",", "2"}], "}"}], ",", "45"}], "]"}], ",", 
     RowBox[{"Resistance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"3", ",", "4"}], "}"}], ",", "15"}], "]"}], ",", 
     RowBox[{"Resistance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"3", ",", "4"}], "}"}], ",", "20"}], "]"}], ",", 
     RowBox[{"Resistance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2", ",", "4"}], "}"}], ",", "20"}], "]"}], ",", 
     RowBox[{"Resistance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"3", ",", "5"}], "}"}], ",", "36"}], "]"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.4012742564435673`*^9, 3.401274317617951*^9}, {
  3.401274349481903*^9, 3.401274395074604*^9}, {3.401274435290551*^9, 
  3.401274458666888*^9}, {3.401274512916851*^9, 3.401274529531493*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"Resistance", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], ",", 
    FractionBox["12708", "515"]}], "]"}], "}"}]], "Output",
 CellChangeTimes->{{3.401283084738865*^9, 3.401283102131562*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Node Reduction Example", "Section"],

Cell[TextData[{
 "Consider the following network.  Use the above syntax to input this into ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ".  Also solve this by hand."
}], "Text"],

Cell[TextData[Cell[BoxData[
 FormBox[Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .64 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.380952 0.32 0.380952 [
[.26471 .1116 -9.46875 -6.0625 ]
[.26471 .1116 9.46875 6.0625 ]
[.73529 .5284 -9.46875 -6.0625 ]
[.73529 .5284 9.46875 6.0625 ]
[.26471 .5284 -12.4688 -6.0625 ]
[.26471 .5284 12.4688 6.0625 ]
[.42826 .32 -12.4688 -6.0625 ]
[.42826 .32 12.4688 6.0625 ]
[.73529 .1116 -12.4688 -6.0625 ]
[.73529 .1116 12.4688 6.0625 ]
[.02381 .26261 -2 -6 ]
[.02381 .26261 2 6 ]
[.97619 .26261 -2 -6 ]
[.97619 .26261 2 6 ]
[ 0 0 0 0 ]
[ 1 .64 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.02381 .32 m
.11905 .32 L
s
.88095 .32 m
.97619 .32 L
s
.5 .01524 m
.47759 .03317 L
s
.47759 .03317 m
.47759 .03317 L
s
.47759 .03317 m
.42157 .07798 L
.39276 .07478 L
.38635 .1324 L
.32873 .126 L
.32233 .18363 L
.26471 .17722 L
.2583 .23485 L
.20068 .22844 L
.19748 .25725 L
.14146 .30207 L
s
gsave
.26471 .1116 -70.4688 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
69.000 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
77.938 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.14146 .30207 m
.11905 .32 L
s
.11905 .32 m
.11905 .32 L
s
.5 .62476 m
.52241 .60683 L
s
.52241 .60683 m
.52241 .60683 L
s
.52241 .60683 m
.57843 .56202 L
.60724 .56522 L
.61365 .5076 L
.67127 .514 L
.67767 .45637 L
.73529 .46278 L
.7417 .40515 L
.79932 .41156 L
.80252 .38275 L
.85854 .33793 L
s
gsave
.73529 .5284 -70.4688 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
69.000 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
77.938 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.85854 .33793 m
.88095 .32 L
s
.88095 .32 m
.88095 .32 L
s
.11905 .32 m
.14146 .33793 L
s
.14146 .33793 m
.14146 .33793 L
s
.14146 .33793 m
.19748 .38275 L
.20068 .41156 L
.2583 .40515 L
.26471 .46278 L
.32233 .45637 L
.32873 .514 L
.38635 .5076 L
.39276 .56522 L
.42157 .56202 L
.47759 .60683 L
s
gsave
.26471 .5284 -73.4688 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
75.000 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
83.938 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.47759 .60683 m
.5 .62476 L
s
.5 .62476 m
.5 .62476 L
s
.5 .01524 m
.5 .04394 L
s
.5 .04394 m
.5 .10477 L
s
.5 .10477 m
.5 .17651 L
.4795 .19701 L
.5205 .23801 L
.4795 .279 L
.5205 .32 L
.4795 .361 L
.5205 .40199 L
.4795 .44299 L
.5 .46349 L
.5 .53523 L
s
gsave
.42826 .32 -73.4688 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(24) show
75.000 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
83.938 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.5 .53523 m
.5 .56393 L
s
.5 .56393 m
.5 .62476 L
s
.88095 .32 m
.85854 .30207 L
s
.85854 .30207 m
.85854 .30207 L
s
.85854 .30207 m
.80252 .25725 L
.79932 .22844 L
.7417 .23485 L
.73529 .17722 L
.67767 .18363 L
.67127 .126 L
.61365 .1324 L
.60724 .07478 L
.57843 .07798 L
.52241 .03317 L
s
gsave
.73529 .1116 -73.4688 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
75.000 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
83.938 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.52241 .03317 m
.5 .01524 L
s
.5 .01524 m
.5 .01524 L
s
.02 w
.02381 .32 Mdot
gsave
.02381 .26261 -63 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.97619 .32 Mdot
gsave
.97619 .26261 -63 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .64 L
0 .64 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
   GeneratedCell->False,
   CellAutoOverwrite->False,
   ImageSize->{219.0625, 140.25},
   ImageMargins->0,
   ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"],
   ImageRangeCache->{{{0, 437.125}, {279.5, 0}} -> {-1.31374, -0.840009, 
   0.0120216, 0.0120216}}], TraditionalForm]]]], "Text",
 CellChangeTimes->{{3.401283106469493*^9, 3.4012831121204567`*^9}},
 TextAlignment->Center,
 TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell["Series and Parallel Capacitor Networks", "Section"],

Cell[TextData[{
 "The function ",
 StyleBox["EquivalentNetwork",
  FontWeight->"Bold"],
 " can also give the equivalent capacitance.  Below are the series and \
parallel cases."
}], "Text",
 CellChangeTimes->{{3.400240993292327*^9, 3.4002410313803177`*^9}}],

Cell[BoxData[
 RowBox[{"EquivalentNetwork", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Capacitance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "3"}], "}"}], ",", "C1"}], "]"}], ",", 
     RowBox[{"Capacitance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2", ",", "3"}], "}"}], ",", "C2"}], "]"}]}], "}"}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"EquivalentNetwork", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Capacitance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], ",", "C1"}], "]"}], ",", 
     RowBox[{"Capacitance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], ",", "C2"}], "]"}]}], "}"}]}], 
  "]"}]], "Input"],

Cell[TextData[{
 "Consider the following capacitor network.  Use the above syntax to input \
this into ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ".  Also solve it by hand."
}], "Text"],

Cell[TextData[Cell[BoxData[
 FormBox[Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .77282 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.761905 0.094591 0.761905 [
[.28164 .52858 -12.375 -6.3125 ]
[.28164 .52858 12.375 6.3125 ]
[.47197 .22797 -15.375 -6.3125 ]
[.47197 .22797 15.375 6.3125 ]
[.57619 .17078 -12.375 -6.3125 ]
[.57619 .17078 12.375 6.3125 ]
[.56095 .51924 -12.375 -6.3125 ]
[.56095 .51924 12.375 6.3125 ]
[.71836 .52858 -15.375 -6.3125 ]
[.71836 .52858 15.375 6.3125 ]
[.02381 .03364 -2 -6 ]
[.02381 .03364 2 6 ]
[.97619 .03364 -2 -6 ]
[.97619 .03364 2 6 ]
[ 0 0 0 0 ]
[ 1 .77282 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.02381 .09459 m
.11905 .09459 L
s
.88095 .09459 m
.97619 .09459 L
s
.11905 .09459 m
.27143 .35852 L
s
.27143 .35852 m
.27143 .35852 L
s
.27143 .35852 m
.3 .40801 L
s
.23402 .4461 m
.36598 .36991 L
s
.25306 .4791 m
.38503 .40291 L
s
.34762 .49049 m
.31905 .441 L
s
gsave
.28164 .52858 -73.375 -10.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.625 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
69.625 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(m) show
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(F) show
83.750 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.34762 .49049 m
.5 .75442 L
s
.5 .75442 m
.5 .75442 L
s
.11905 .09459 m
.25101 .17078 L
s
.25101 .17078 m
.30952 .20456 L
s
.30952 .20456 m
.35901 .23313 L
s
.32092 .29912 m
.39711 .16715 L
s
.35391 .31816 m
.4301 .1862 L
s
.44149 .28075 m
.392 .25218 L
s
gsave
.47197 .22797 -76.375 -10.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.625 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
75.625 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(m) show
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(F) show
89.750 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.44149 .28075 m
.5 .31453 L
s
.5 .31453 m
.88095 .09459 L
s
.11905 .09459 m
.27143 .09459 L
s
.27143 .09459 m
.42381 .09459 L
s
.42381 .09459 m
.48095 .09459 L
s
.48095 .17078 m
.48095 .0184 L
s
.51905 .17078 m
.51905 .0184 L
s
.57619 .09459 m
.51905 .09459 L
s
gsave
.57619 .17078 -73.375 -10.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.625 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(9) show
69.625 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(m) show
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(F) show
83.750 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.57619 .09459 m
.72857 .09459 L
s
.72857 .09459 m
.88095 .09459 L
s
.5 .75442 m
.5 .60204 L
s
.5 .60204 m
.5 .53448 L
s
.5 .53448 m
.5 .47733 L
s
.57619 .47733 m
.42381 .47733 L
s
.57619 .43924 m
.42381 .43924 L
s
.5 .3821 m
.5 .43924 L
s
gsave
.56095 .51924 -73.375 -10.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.625 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
69.625 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(m) show
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(F) show
83.750 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.5 .3821 m
.5 .31453 L
s
.5 .75442 m
.57619 .62245 L
s
.57619 .62245 m
.65238 .49049 L
s
.65238 .49049 m
.68095 .441 L
s
.74694 .4791 m
.61497 .40291 L
s
.76598 .4461 m
.63402 .36991 L
s
.72857 .35852 m
.7 .40801 L
s
gsave
.71836 .52858 -76.375 -10.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.625 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
75.625 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(m) show
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(F) show
89.750 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.72857 .35852 m
.80476 .22656 L
s
.80476 .22656 m
.88095 .09459 L
s
.02 w
.02381 .09459 Mdot
gsave
.02381 .03364 -63 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.97619 .09459 Mdot
gsave
.97619 .03364 -63 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .77282 L
0 .77282 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
   GeneratedCell->False,
   CellAutoOverwrite->False,
   ImageSize->{219.5, 169.625},
   ImageMargins->0,
   ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"],
   ImageRangeCache->{{{0, 438}, {338.25, 0}} -> {-0.656732, -0.124156, 
   0.00599755, 0.00599755}}], TraditionalForm]]]], "Text",
 CellChangeTimes->{{3.401283121530224*^9, 3.401283121530352*^9}},
 TextAlignment->Center,
 TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell["Kirchhoff's Rules", "Section"],

Cell[TextData[{
 " ",
 Cell[BoxData[Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .76979 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.453917 0.508309 0.0672043 0.508309 [
[.02381 .29529 -9.46875 -6.0625 ]
[.02381 .29529 9.46875 6.0625 ]
[.02381 .54782 -9.3125 -6.0625 ]
[.02381 .54782 9.3125 6.0625 ]
[.40504 .5804 -9.3125 -6.0625 ]
[.40504 .5804 9.3125 6.0625 ]
[.50279 .36046 -9.46875 -6.0625 ]
[.50279 .36046 9.46875 6.0625 ]
[.40504 .18939 -7.59375 -6.59375 ]
[.40504 .18939 7.59375 6.59375 ]
[.91335 .3849 -9.46875 -6.0625 ]
[.91335 .3849 9.46875 6.0625 ]
[.2633 .75147 -7.59375 -6.53125 ]
[.2633 .75147 7.59375 6.53125 ]
[.53375 .75147 -7.59375 -6.53125 ]
[.53375 .75147 7.59375 6.53125 ]
[.76021 .65371 -9.46875 -6.0625 ]
[.76021 .65371 9.46875 6.0625 ]
[.57448 .01833 -9.3125 -6.0625 ]
[.57448 .01833 9.3125 6.0625 ]
[.81723 .01833 -7.59375 -6.53125 ]
[.81723 .01833 7.59375 6.53125 ]
[.8106 .43482 -9.46875 -6.0625 ]
[.8106 .43482 9.46875 6.0625 ]
[.60554 .1785 -7.59375 -6.53125 ]
[.60554 .1785 7.59375 6.53125 ]
[ 0 0 0 0 ]
[ 1 .76979 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.07269 .0672 m
.07269 .14866 L
s
.07269 .14866 m
.07269 .19754 L
.05872 .2115 L
.08665 .23943 L
.05872 .26736 L
.08665 .29529 L
.05872 .32322 L
.08665 .35115 L
.05872 .37908 L
.07269 .39304 L
.07269 .44192 L
s
gsave
.02381 .29529 -70.4688 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.000 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
77.938 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.07269 .44192 m
.07269 .52338 L
s
.07269 .52338 m
.07269 .56004 L
s
.05639 .56004 m
.08898 .56004 L
s
.02381 .58447 m
.12156 .58447 L
s
.07269 .62113 m
.07269 .58447 L
s
gsave
.02381 .54782 -70.3125 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.125 moveto
(V) show
77.625 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.07269 .62113 m
.07269 .70259 L
s
.45392 .70259 m
.45392 .60484 L
s
.45392 .60484 m
.45392 .60484 L
s
.45392 .60484 m
.45392 .56818 L
s
.47021 .56818 m
.43763 .56818 L
s
.50279 .54374 m
.40504 .54374 L
s
.45392 .50709 m
.45392 .54374 L
s
gsave
.40504 .5804 -70.3125 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
69.000 13.125 moveto
(V) show
77.625 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.45392 .50709 m
.45392 .50709 L
s
.45392 .50709 m
.45392 .45821 L
.46788 .44425 L
.43995 .41632 L
.46788 .38839 L
.43995 .36046 L
.46788 .33253 L
.43995 .3046 L
.46788 .27667 L
.45392 .26271 L
.45392 .21383 L
s
gsave
.50279 .36046 -70.4688 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
77.938 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.45392 .21383 m
.45392 .21383 L
s
.45392 .21383 m
.45392 .16496 L
s
.46614 .20161 m
.45392 .17717 L
.4417 .20161 L
s
gsave
.40504 .18939 -68.5938 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(I) show
67.625 16.062 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.812 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
74.188 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.45392 .16496 m
.45392 .0672 L
s
.45392 .0672 m
.45392 .0672 L
s
.96223 .0672 m
.96223 .23827 L
s
.96223 .23827 m
.96223 .28715 L
.94826 .30111 L
.97619 .32904 L
.94826 .35697 L
.97619 .3849 L
.94826 .41283 L
.97619 .44076 L
.94826 .46868 L
.96223 .48265 L
.96223 .53152 L
s
gsave
.91335 .3849 -70.4688 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
69.000 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
77.938 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.96223 .53152 m
.96223 .70259 L
s
.07269 .0672 m
.45392 .0672 L
s
.07269 .70259 m
.23886 .70259 L
s
.23886 .70259 m
.28774 .70259 L
s
.25108 .71481 m
.27552 .70259 L
.25108 .69037 L
s
gsave
.2633 .75147 -68.5938 -10.5312 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.0625 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(I) show
67.625 16.062 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.812 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
74.188 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.28774 .70259 m
.45392 .70259 L
s
.45392 .70259 m
.50931 .70259 L
s
.50931 .70259 m
.55819 .70259 L
s
.52153 .71481 m
.54597 .70259 L
.52153 .69037 L
s
gsave
.53375 .75147 -68.5938 -10.5312 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.0625 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(I) show
67.625 16.062 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.812 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
74.188 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.55819 .70259 m
.61358 .70259 L
s
.61358 .70259 m
.66245 .70259 L
.67642 .71655 L
.70435 .68863 L
.73228 .71655 L
.76021 .68863 L
.78813 .71655 L
.81606 .68863 L
.84399 .71655 L
.85796 .70259 L
.90683 .70259 L
s
gsave
.76021 .65371 -70.4688 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
77.938 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.90683 .70259 m
.96223 .70259 L
s
.45392 .0672 m
.57448 .0672 L
s
.57448 .0672 m
.61113 .0672 L
s
.61113 .0835 m
.61113 .05091 L
s
.63557 .11608 m
.63557 .01833 L
s
.67223 .0672 m
.63557 .0672 L
s
gsave
.57448 .01833 -70.3125 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
69.000 13.125 moveto
(V) show
77.625 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.67223 .0672 m
.79279 .0672 L
s
.79279 .0672 m
.84167 .0672 L
s
.80501 .07942 m
.82945 .0672 L
.80501 .05499 L
s
gsave
.81723 .01833 -68.5938 -10.5312 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.0625 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(I) show
67.625 16.062 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.812 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
74.188 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.84167 .0672 m
.96223 .0672 L
s
.96223 .70259 m
.86403 .57985 L
s
.86403 .57985 m
.8335 .54168 L
.83568 .52205 L
.79642 .51769 L
.80079 .47844 L
.76153 .47407 L
.76589 .43482 L
.72664 .43046 L
.731 .3912 L
.71137 .38902 L
.68084 .35085 L
s
gsave
.8106 .43482 -70.4688 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
69.000 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
77.938 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.68084 .35085 m
.58264 .22811 L
s
.58264 .22811 m
.55211 .18995 L
s
.58455 .21094 m
.55974 .19949 L
.56547 .2262 L
s
gsave
.60554 .1785 -68.5938 -10.5312 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.0625 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(I) show
67.625 15.938 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.812 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
74.188 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.55211 .18995 m
.45392 .0672 L
s
0 0 m
1 0 L
1 .76979 L
0 .76979 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
   GeneratedCell->False,
   CellAutoOverwrite->False,
   ImageSize->{247.875, 190.75},
   ImageMargins->0,
   ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"],
   ImageRangeCache->{{{0, 494.75}, {380.5, 0}} -> {-0.931288, -0.149323, 
   0.00814011, 0.00814011}}]],
  ImageSize->{244, 187.75},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}], "Text",
 CellChangeTimes->{{3.401283130519388*^9, 3.401283135840939*^9}},
 TextAlignment->Center,
 TextJustification->0],

Cell["For the junction rule omit one of the following.", "Text"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["I", "1"], "=", 
    RowBox[{
     SubscriptBox["I", "2"], "+", 
     SubscriptBox["I", "3"]}]}], TraditionalForm]]],
 "\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["I", "3"], "+", 
     SubscriptBox["I", "5"]}], "=", 
    RowBox[{
     SubscriptBox["I", "1"], "+", 
     SubscriptBox["I", "4"]}]}], TraditionalForm]]],
 "\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["I", "2"], "+", 
     SubscriptBox["I", "4"]}], "=", 
    SubscriptBox["I", "5"]}], TraditionalForm]]]
}], "Text",
 TextAlignment->Center,
 TextJustification->0],

Cell["The loop rule gives three independent equations", "Text"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{"0", "=", 
    RowBox[{
     RowBox[{"2", " ", 
      SubscriptBox["I", "3"]}], "-", "3", "-", "2", "+", 
     RowBox[{"5", " ", 
      SubscriptBox["I", "1"]}]}]}], TraditionalForm]]],
 "\n",
 Cell[BoxData[
  FormBox[
   RowBox[{"0", "=", 
    RowBox[{"3", "-", 
     RowBox[{"2", " ", 
      SubscriptBox["I", "3"]}], "+", 
     RowBox[{"7", " ", 
      SubscriptBox["I", "5"]}], "+", 
     RowBox[{"2", " ", 
      SubscriptBox["I", "2"]}]}]}], TraditionalForm]]],
 "\n",
 Cell[BoxData[
  FormBox[
   RowBox[{"0", "=", 
    RowBox[{"6", "-", 
     RowBox[{"4", " ", 
      SubscriptBox["I", "4"]}], "-", 
     RowBox[{"7", " ", 
      SubscriptBox["I", "5"]}]}]}], TraditionalForm]]]
}], "Text",
 TextAlignment->Center,
 TextJustification->0],

Cell["To solve this use the following syntax.", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Solve", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"I1", "\[Equal]", 
       RowBox[{"I2", "+", "I3"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"I3", "+", "I5"}], "\[Equal]", 
       RowBox[{"I1", "+", "I4"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"0", "\[Equal]", 
       RowBox[{
        RowBox[{"2", " ", "I3"}], "-", "3", "-", "2", "+", 
        RowBox[{"5", " ", "I1"}]}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"0", "\[Equal]", 
       RowBox[{"3", "-", 
        RowBox[{"2", " ", "I3"}], "+", 
        RowBox[{"7", " ", "I5"}], "+", 
        RowBox[{"2", " ", "I2"}]}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"0", "\[Equal]", 
       RowBox[{"6", "-", 
        RowBox[{"4", " ", "I4"}], "-", 
        RowBox[{"7", " ", "I5"}]}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"I1", ",", "I2", ",", "I3", ",", "I4", ",", "I5"}], "}"}]}], 
   "]"}], "//", "N"}]], "Input"],

Cell[TextData[{
 "Find the appropriate set of linear equations to solve for the currents.  \
Use the above syntax to solve this in ",
 StyleBox["Mathematica.",
  FontSlant->"Italic"]
}], "Text"],

Cell[TextData[Cell[BoxData[
 FormBox[Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .72218 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0378461 0.294768 0.0663228 0.294768 [
[.77477 .11545 -9.46875 -6.0625 ]
[.77477 .11545 9.46875 6.0625 ]
[.77477 .70499 -9.46875 -6.0625 ]
[.77477 .70499 9.46875 6.0625 ]
[.08697 .42659 -9.46875 -6.0625 ]
[.08697 .42659 9.46875 6.0625 ]
[.08697 .17277 -7.59375 -6.53125 ]
[.08697 .17277 7.59375 6.53125 ]
[.28349 .11545 -9.3125 -6.0625 ]
[.28349 .11545 9.3125 6.0625 ]
[.52342 .10081 -9.3125 -6 ]
[.52342 .10081 9.3125 6 ]
[.36735 .25687 -7.59375 -6.53125 ]
[.36735 .25687 7.59375 6.53125 ]
[.24602 .51716 -9.46875 -6.0625 ]
[.24602 .51716 9.46875 6.0625 ]
[.59054 .70499 -9.3125 -6.0625 ]
[.59054 .70499 9.3125 6.0625 ]
[.43087 .70499 -7.59375 -6.53125 ]
[.43087 .70499 7.59375 6.53125 ]
[.22208 .70499 -9.46875 -6.0625 ]
[.22208 .70499 9.46875 6.0625 ]
[.68634 .25055 -9.46875 -6.0625 ]
[.68634 .25055 9.46875 6.0625 ]
[.67651 .43478 -9.3125 -6.0625 ]
[.67651 .43478 9.3125 6.0625 ]
[.67651 .59445 -7.59375 -6.59375 ]
[.67651 .59445 7.59375 6.59375 ]
[.97619 .21371 -9.3125 -6 ]
[.97619 .21371 9.3125 6 ]
[.97128 .48391 -7.59375 -6.53125 ]
[.97128 .48391 7.59375 6.53125 ]
[ 0 0 0 0 ]
[ 1 .72218 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.62738 .06632 m
.62738 .06632 L
s
.62738 .06632 m
.67651 .06632 L
.69055 .08036 L
.71862 .05229 L
.74669 .08036 L
.77477 .05229 L
.80284 .08036 L
.83091 .05229 L
.85899 .08036 L
.87302 .06632 L
.92215 .06632 L
s
gsave
.77477 .11545 -70.4688 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.000 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
77.938 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.92215 .06632 m
.92215 .06632 L
s
.92215 .65586 m
.92215 .65586 L
s
.92215 .65586 m
.87302 .65586 L
.85899 .64182 L
.83091 .6699 L
.80284 .64182 L
.77477 .6699 L
.74669 .64182 L
.71862 .6699 L
.69055 .64182 L
.67651 .65586 L
.62738 .65586 L
s
gsave
.77477 .70499 -70.4688 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
69.000 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
77.938 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.62738 .65586 m
.62738 .65586 L
s
.03785 .65586 m
.03785 .57398 L
s
.03785 .57398 m
.03785 .52485 L
.05188 .51081 L
.02381 .48274 L
.05188 .45467 L
.02381 .42659 L
.05188 .39852 L
.02381 .37045 L
.05188 .34238 L
.03785 .32834 L
.03785 .27921 L
s
gsave
.08697 .42659 -70.4688 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
69.000 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
77.938 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.03785 .27921 m
.03785 .19733 L
s
.03785 .19733 m
.03785 .1482 L
s
.05013 .18505 m
.03785 .16048 L
.02556 .18505 L
s
gsave
.08697 .17277 -68.5938 -10.5312 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.0625 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(I) show
67.625 16.062 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.812 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
74.188 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.03785 .1482 m
.03785 .06632 L
s
.03785 .06632 m
.28349 .06632 L
s
.28349 .06632 m
.32033 .06632 L
s
.32033 .0827 m
.32033 .04995 L
s
.3449 .11545 m
.3449 .01719 L
s
.38174 .06632 m
.3449 .06632 L
s
gsave
.28349 .11545 -70.3125 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
69.000 13.125 moveto
(V) show
77.625 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.38174 .06632 m
.62738 .06632 L
s
.62738 .06632 m
.55816 .13554 L
s
.55816 .13554 m
.53211 .1616 L
s
.52053 .15002 m
.54369 .17318 L
s
.48 .14423 m
.54948 .21371 L
s
.48868 .20502 m
.51474 .17897 L
s
gsave
.52342 .10081 -70.3125 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
69.000 13.000 moveto
(V) show
77.625 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.48868 .20502 m
.41946 .27424 L
s
.41946 .27424 m
.38472 .30898 L
s
.40209 .27424 m
.39341 .3003 L
.41946 .29161 L
s
gsave
.36735 .25687 -68.5938 -10.5312 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.0625 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(I) show
67.625 16.062 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.812 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
74.188 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.38472 .30898 m
.3155 .3782 L
s
.3155 .3782 m
.28076 .41294 L
.26091 .41294 L
.26091 .45264 L
.22121 .45264 L
.22121 .49235 L
.18151 .49235 L
.18151 .53205 L
.14181 .53205 L
.14181 .5519 L
.10707 .58664 L
s
gsave
.24602 .51716 -70.4688 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(9) show
69.000 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
77.938 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.10707 .58664 m
.03785 .65586 L
s
.62738 .65586 m
.59054 .65586 L
s
.59054 .65586 m
.55369 .65586 L
s
.55369 .63948 m
.55369 .67223 L
s
.52913 .60673 m
.52913 .70499 L
s
.49228 .65586 m
.52913 .65586 L
s
gsave
.59054 .70499 -70.3125 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.125 moveto
(V) show
77.625 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.49228 .65586 m
.45543 .65586 L
s
.45543 .65586 m
.40631 .65586 L
s
.44315 .64358 m
.41859 .65586 L
.44315 .66814 L
s
gsave
.43087 .70499 -68.5938 -10.5312 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.0625 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(I) show
67.625 16.062 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.812 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
74.188 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.40631 .65586 m
.36946 .65586 L
s
.36946 .65586 m
.32033 .65586 L
.3063 .64182 L
.27822 .6699 L
.25015 .64182 L
.22208 .6699 L
.194 .64182 L
.16593 .6699 L
.13786 .64182 L
.12382 .65586 L
.07469 .65586 L
s
gsave
.22208 .70499 -70.4688 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
77.938 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.07469 .65586 m
.03785 .65586 L
s
.62738 .06632 m
.62738 .10317 L
s
.62738 .10317 m
.62738 .1523 L
.61335 .16633 L
.64142 .19441 L
.61335 .22248 L
.64142 .25055 L
.61335 .27863 L
.64142 .3067 L
.61335 .33477 L
.62738 .34881 L
.62738 .39794 L
s
gsave
.68634 .25055 -70.4688 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
69.000 13.125 moveto
%%IncludeResource: font Mathematica1-Bold
%%IncludeFont: Mathematica1-Bold
/Mathematica1-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(W) show
77.938 13.125 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.62738 .39794 m
.62738 .43478 L
s
.62738 .43478 m
.62738 .47163 L
s
.61101 .47163 m
.64376 .47163 L
s
.57825 .49619 m
.67651 .49619 L
s
.62738 .53304 m
.62738 .49619 L
s
gsave
.67651 .43478 -70.3125 -10.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
69.000 13.125 moveto
(V) show
77.625 13.125 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.62738 .53304 m
.62738 .56988 L
s
.62738 .56988 m
.62738 .61901 L
s
.6151 .58217 m
.62738 .60673 L
.63966 .58217 L
s
gsave
.67651 .59445 -68.5938 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(I) show
67.625 16.062 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.812 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
74.188 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.62738 .61901 m
.62738 .65586 L
s
.92215 .06632 m
.92215 .21371 L
s
.92215 .21371 m
.92215 .25055 L
s
.90577 .25055 m
.93853 .25055 L
s
.87302 .27512 m
.97128 .27512 L
s
.92215 .31196 m
.92215 .27512 L
s
gsave
.97619 .21371 -70.3125 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.000 13.000 moveto
(V) show
77.625 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
/Times-Bold findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.92215 .31196 m
.92215 .45935 L
s
.92215 .45935 m
.92215 .50847 L
s
.90987 .47163 m
.92215 .49619 L
.93443 .47163 L
s
gsave
.97128 .48391 -68.5938 -10.5312 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.0625 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 13.000 moveto
%%IncludeResource: font Times-Bold
%%IncludeFont: Times-Bold
%%BeginResource: font Times-Bold-MISO
%%BeginFont: Times-Bold-MISO
/Times-Bold /Times-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(I) show
67.625 15.938 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 10.812 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
74.188 13.000 moveto
%%IncludeResource: font Times-Bold-MISO
%%IncludeFont: Times-Bold-MISO
/Times-Bold-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.92215 .50847 m
.92215 .65586 L
s
0 0 m
1 0 L
1 .72218 L
0 .72218 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
   GeneratedCell->False,
   CellAutoOverwrite->False,
   ImageSize->{240.8125, 173.8125},
   ImageMargins->0,
   ImageCache->GraphicsData["CompressedBitmap", "\<\
eJztXQnQa0lVDu9f3v/emwWEAcbtjcouBilZnBmECSADDBhA2SQjDjARVDQC
KnFhiYrGBYgIBheCS1AJWpUqy5RLCo2lBjGKcQlqtCISl1saqGiZkmtV23v3
vflup/sm/2hZpCp57z+56T7ndPfpc06fc/rZd73ulXe/+q7Xverld910+2vu
qr3yVS9/7U1P++bXUNDRvQqFe/09fb/kpgL7PykU1Ad/fYx9yD8O/P+f4/8c
Ed0X/Yt/PuHT3/9/+P7HwfeX/hd/8ysA9gAAeyCAPT+sq19Owdh6SnfFYOmu
GOwFYV19gH+e2DDd1A2O7+7v+C6Q2h6AHQHYfTyf+wzP554Xhub7AewEwK73
fO7ens89NwzNXwKwiwB2redz13k+9xyBJmf+W9g3V9j/3sP+h7pCqF/xfO6a
kPYeyECPtJBLPdTwbOzN7PMCAauO/XWmv92b2KBWbgCwR+xP7JtSMLaqbwTP
nQKY74Q59AS8//mw4o388zgh6Oj/PxM8egxgvqv80FID7UwH4MYbZIdI7COW
7COfDy3v0bo9AEu+G8AuANiNDta5dtO8u/BnnQ+53wVgiNvp2VAAkpPBfPWa
zz4fcr4TwNA6RtxEE8pXIzyn0fkOAEPioRnW/VsBrA5gaD84QFevBzC0BRyg
qxdK2Hw8JOP5iv/1OeC5s/Pp/mn885hMWmUOLxSKpL+Ir5Fgsh6TEgOXOmRN
CFoTaFYcELFo1JSIFUi5PVGIzbpVg+8yRrP78nkiRud4PCNViVih2CBL3SWb
/wtSV98xxFsTuFshnewAKN4umTRqljQK3dlGYHdKVhZLxbtO5kxx3W4Jab4H
RHAz62osSs2xmkp02pFOWbh1juRnc7zSP0dKKNLuAjG9m3+ykV2TxXxGptMp
fc/IIlprRtjLFKFxu2qDRKRZNPxdWEs4XvQU1Zq8QrVH4kDyHif7ijcrEi2X
ZEnfUbRm7RS+Ioz0lyvOx0vSb9Y4UscKtVKN9KcRf+JMDlxKLiCMny4fnXWq
eozb0/WZbGfYMHNTvMukWmGwEhmtYItIMX+MQnwzJ+1aOclT2lSjMyBRbDSG
5aCheX+sPiucCP5a9OunesZFupvHhrHzZZpZC9IoWkTSnpZ0eNbzIakUChdk
T/X+XP/0VLEtKeBcHCbRkBRlD8XGUG1UbIzKktQLktRiY0w2UZ8/WunO7gda
RYaB4vKkpQdNcplyr1jUA9ifrS/oR8spRp+QWk/TSagUYjNI6JL0+VJrsh+3
T8i8V7OmU4VM1koxPqHjXre+K5FhFEtWY2mdzW/2PBVPFfV8lcxio4iYYVNM
P2Gil9FLWiWzUyA6kKklOH8tGRt26n4HMzFB42gsdyK+dPhr2q5I1p4qXliv
mAxqRcX58v6cn3YqBrMyX02a8+tJcrdpTVaSW5k7EZqWz+Cfx4mBbI1XSte0
xlDyndJdahG1aSz6Ym50pmtk5iHYYyQB0aTDZV2xWKbiZGiJk2voypPihIpv
NshigRRJZ7wgcRyRdkkSVuszsSx+dpHypG1k4oRK7mmfL9Vic1J4/AGGQGCj
h4BOhgSbqR5VMIxz77Woz6eo38YbvWkdyb7IZsJEmxBGtQHfjJR9Y+lyepDq
g6WZl+uJkFj1AVoLCBXhUz+jv2yZGUT7XI46dLDExJ53q0rSNkdGpl+Qg0Hi
OalZE3DJp0uLtIaLfINxxno0DKcrfiEfiBd9NpUUn6tGHuoNapdygLp9sj2W
dMZVegvJczbKdLHXlYiukOnG9GWPveDQGRcs0w2xXur3ZSZE0B58XwC7VXdP
d0C1CAo13r2almzfKlnyjH1no92vFTUXqXZYuDnPYLDxTYp3tttGky7bMrWO
Q8VCaiR2aigv5o8dkzFXsitcGm/i+AJd9zFTyui30bilf90YRWaM52aM1cyk
BGoM1B66mXb4c7X+AiqASE7ewj8vkc1yTOqlJPZjTSRjrum7UG4rBUgPQGIK
U4k2jEjhS8MGQCuV6znp1Ct6N+JdFpskSjDcS2F5sXx0OTRq3EW5zVqrhL+G
9aKlCnKz1uqO0bkUypnYJpAthrSAx0oGbdZrsooiailMyajfJfVqSSs6bKbP
FS7RgE81zexKd4vZm2nbYraY7YHMfoWExcuBWlRGg6fTcxTFVpf+isqLVLvW
nNUct+eUWMyG45RMJbN0n3Ifak/W0DpHHnWj4E/VviL7P7Z1Rra3qK7L7an+
uej6lKxTHJaDHijf1YzezAwzDJNrZLZJEhyglSg+23SeyaZrVGItxj1SLVrd
FSuk0xuQyXyld7LVfEIGvQ6p6XVfIq3emHUH3VfId6j5TUevVy1Yi/aEL9qF
tcSojq/H29YiFdNtXYC/hZzJtakmmXmimV6k2/yIK5w5tAzNdNpAv1Eh5UqV
MqpardLGKhWq7vU+Qvr1MoVXjjmY7tkV+lipSGrdmeb7ot8gxVKZ/qTKnqLv
CimV62w6QA8l8rQozZsaoFtTq1zvcrORELN5Ws/xNzNalFptzSE52ds5Jrvi
u7V0jBAr1shktSYjOgMUj4v1AUkoDkK7ONJT2alYIEcyOgF8rOQ5NQSE0Uu1
8lqtTpqtDhmMpyRax1K3Pdla9EzvVTyyXU/8LcRyToVvQ6Vj0W7NCAOmmioB
yxbk2LLEqFDVg7xLAUDub+RTVBOJe6C4TTGWPtpT7rOsFZILkk4Mxa/I7Kr8
TfXT0G1ImSNp1lOTQk/d1di2+sqWnX7KNu3ksIiNW6ztrT372wEGyBX8OAkb
N4UVXS6XaWPsky6uUonUhKVgvAUpRvQWsRFqdJJ3KzaGfKPMySc6D40XmSmn
o7XE4izh+pZ8Ei+x1frutN8GukeOfMUkyzi1XAh1bcSIV0xGzbIRB3UyFZua
MTq7tQT2A8rDQA1ebLfUXJ52zeqikmc4YyZzj+sbSlGsdqccK7lP5t0mXwvQ
QMcxiln2dq1027ZlTKg+54OWJSDoptXukcGgRxqVojEBqm0yEz8N5ZTS/piq
3WvWLE2MyuVyjfTGavQ2+25orwHdf66LQ6zLRpXvrSeyz0q5QtrCvSqn7Bl9
LKJ6dIfUaxW2MkmJrkv6G9JodclksXpCGEOquu2YbDYb+Y6/Hzx6FcACTw4+
CWA37d/sH3uy+vP27+pPAAwJic/fv6uPABjf6fk6ePD+HfwpgPkG/xygewVj
Ez+pQR9pPyF74lc90UTH6Q/ZH03ltSFxTNbRjHSoOFRbSrHSItPlijvvBp5o
opgMhOYPhqGpolHiWSexJVMjr/AbmajhCJWHged/KB862ogoaFd04Tc9OJWF
xg/nRCNlYTHn+m95oMH+emgYGtxFzpfoAxydDz07R+vsR3Z0zr+xz4ild12u
rlOhJNkmhkBQ7a8UP92uL5O+AMDQibbEU7itj+3hZm/l7FivlmQ6bHN/0JFU
XJg20KTaxzLi6007RwFzP+iJNNoP3rYL6ZME0vJfGaEA9HJqUlJOa3ctwPa3
98DWweLrJUb2ArcwVginzzwYwms3wr+zB8KOuSsQ3groRCF7Z77IT7eQH+2B
vGPVXye7ROJ0HwrmSeubUfC7oLlHA5hDYruwRfuT0ACuZGErX+KQpFRrkmbN
OLxsaYKYj1B37H1orJQsQOQokz4DdTU26+VU+94zMecC8ksAAg6VIhvf3TDl
g9k5zZdk1GvqfZb5EMQk2VpMCPkfyEYehTWh+ZED+VPd2IbMxiMyi2I4PVDT
aMogi8WhGOwQf38IfoKiTxEmbzkoJh/KZO1uTL7voJiMwU9QtCXC5HvzYWLF
0Yi3cIz/AfgJOidBmHxPGCaqWWYfd0op526ppU+ofg/8Fq0ehBKKIXagpHjO
vTiTIek0q9rPX663yWA4IauYwH0CHUs/an8uGZSE26RUrhgfRqVMiqUGmW+w
/EcRDF8EYIFT6M8BDD33hQCG1o0KWUVBhErG20GPV7JR+zMAQ0fUDwcwJFw0
93fE9gkStoISHZhOAQwdPiITCQlkhalHfNwliWwqvs+BLHJnoBMkZFKhPVAg
eyUkpEwqSjhUzoE6cvWgMwtkZSHd40yikR2SdZwOydoRanY5G3lflxjSqJGi
p2zDVKiSbyDWWTamvn7CqwCGtOnrJZtR8I5Cd1eckgPdCYDdBmDILBGC/jQr
vOVE9r0jdudSNnJ/5IkcMvguSb5lh4YcESs0RKucHoEvDow/7IkxsqmNiE1H
VyQjchWmvlEjjtFHKihCFzksbBVhy7VqghMMY/3jLxwYI1X1yQCGGKzcVbuO
9XMELzgwRirtUwEsexK7D9iNkRMcQHgxG2uk/j4NwJBcMG5Bc+qtdNw84XYO
NH8fwJ4OYEiyKpT8DqJDj8NPs5FGevwzAQxtXNp7uXUwfEISB8OBIWAOdN+p
h9NMMC2XGkP9HDqOehaAIWVCm0DwCHe1d8TVcTZ575KwuZWNgiIjkWqBMnuQ
mmcsvPT567E8f/3YvkfBDgpV9YiZiQKwgrboXi2jBW4Cv30OgF2RsyiVp6i0
kZxpPS8FPTlsrzb/vMQiH0RvlTYZj0dkOByS4aBPWsJIIS06uRFhz8scpq08
R0XYPmk0uahjY7om3apgcXscKenI99wKRa4zg4rkVwGYUohQrqSSCJZXRkqO
oIyVQCLfrYiM59qQaQzmmsh4QzZyS0ZhHy/IJHIr21LFNRwgJeSuMBrV/rh9
RCbWnjwik0v8mIcMq9iUWm+GZu6LAEzlAqaSONXedKAMjEDalUbjcdKmELXd
gq1xhAynrwYwYxJvZ3qqgLrQDIeXsO/uw/58UDaJQjHOPJLTWW1r+4RLZMMh
8xXRpp0UydxNEwLH8wdMz8J9qahGqQNv202P06Eus+7K5msWnIhi/RA92kOU
zJTU9ESDZPSmiAVV9KDo/J30XHIeKrEE0N5oUdBZU8p+UjtARsI4Iu6KzaBU
WqJqP0p5P1j0hPKMZITGv3UXhZedFEajBh/8wWKjjrGicSoclxKJQnwRkdfK
EUyl/yn6JilfVjIaGkah76Tvmh3HglT1VkKz2SbtRlVH8lrbE/IqIvq0ZeuZ
UrdHGPhOwnceKq5MXpPl1zAZNsFEe+at6ZTS8Lju/EQrX8Ji1FZCwpyUUHW/
M15mEv0SAFOyNSBvTFmDOcK388tdPRDxikylkjui9j87gkGJI4hWZYP4pGvR
Z7Tl2DNZJoZ4HHedn8CrnkSoxLDtDCgRcTROKao54qLfnpsIpK0gItSZHU4v
0hZ87njl/BQgNRtRoA6jtnN1jmSuzow/4RlP/I7dCGec0qIjLRSjiYjgsfiP
YqAbsvtXfsRdZ7Mo7xYd5iNEHAFWbpPCfTaL8uh9UXJEqLlRcp/N+lZ1u3N/
Lv0igKE4j5cCmCOADHX1C55dIfMpMNZUdIWjkO4GzwdG1IrmtyJ6vg48Ghg6
/D7cMtcU+HpCzAmMon5fCsaYwic8B70C/MIRlpTZAcf2gm72leC5wDihLvvk
Y/qN4NvAUJ+uxrEGvg2M1vl5APsWAAuMm0DVn1GyT2CEyM8C2LcCWGAszM94
NhuI7Xs9mw3kbcez2cCZ8B7PZgNn6097Nhu4on7Ks9nA9f+Tns0Gyq2f8Gw2
UOS+27PZwD2i7dmsY2dDytK7AAw169ibkTL4Y57NOrQLVHjiRz2bdehRqNkW
gKG8Wge2yPRFWKAUZgdvkZWJHkclVR0zAcVOofmICs86mkXYombf4Pmcg7fo
8TcBmGPxopmAmkX7lkPUoOWAmkX7lqNZtHhRs2jfChSMqFm0bzmaRRYHahbt
W45mUUApahbtW45mUb0/1CzatxzNoohc1CxqIjDtADWLpr6jWRTSjJr1pUA2
i2oKoSaQWAnEFj2OhGUgb9FkQjtB4ExAKwrtGIHzFomVt4c1i1bZmwEMbZuB
MuGNAIY2+UAJhurDvyOsWSRv0S6LNJ3A3QHpBO8EMEezaC9DGgxS9xzNop0X
6VvoohRHs0hP4DUVuAGN9HJHY0iXQTZ4YLMIR9QsMk4COYqaRaZU4PijZpHh
FzhbUbPITA1cW6jZTlizSBKgZt8b1iySW9w1d5mBkFMlT2Mp2PvDmkUiW2yR
7IBxnTo1MpFFy0FDhMV4xYqV9kcUbVnXWoi2yzai5mRp0iqrEmy+sV8HwBbt
29dpbONEMAY/oZVndtN2JUflYV+EVb7SZrUkM16gfUrmi4gfiit1y85XQu5N
h75j4ohjMhv2SKfTpX91u+yz122lwvQvk1qrQ4bT6BBRXk8B6CAOmFCBJenW
U2lRxequWu0OhiC90oSRrlWECmWSmIzF5jgd5lXIG+flS/1F9bmZkbpVWr0+
WBBZbl3j0OAw8buMuuoObiDlXcGs1Sq5cZaoRgkCv1xxX18eSHwy9IuH+vDX
rFOxYhP02jPxaCB9K9d8YHNLV7chpVqDNBsN0miwf2vs4PhITpFyrU46IzUM
+crOoswFxJ1ThVqC+QW7Hyac1FqpW8feKhIsI0vsG7J5hISIWjMrudrLrbEV
xgAlp/46PBQtlD3J8nuFREKMxR6U/rMrR+1V2XxCu8lliZeKpzYyg68uUzUx
GWQRjZq694Bar74SRgUcTtrlFK9H2RXVW6ai+q7MOAeTkIKgazeqXA86YQQ3
tphkb7U5a7OGMinNiFLDMAkF5Xkm6H19No+QtqfizFl9dbVqYrHQMhlE1bwd
DILRc2EMOoNRL2LB8OBshYFdCl4Ho+9OC3TwCSnb6eTjen9MutViFovoQrIW
2jaLMmLtwlh0MXl1AXuLDAGyHJp1bu9mocmIjgXnTvpXeRB2YkKSQzIiz97R
Vgkm4ai8MJHN6k13NKUmkp9qm5MowZGAfEcHU5CFahJFdQiipWlopuxTQTWU
KZY2aRZ5sUbarSbXRNrdIVlaGcsBqZUO5iCvgCp6tDERglqoUcYcabRjkzrE
5zmPDlRhvigwMEwxPLGXBH8Xa/1klG1YsiYKNHE4XVR6fvIiHlHg90TiGRpY
GMYBRuVSpWPo9rozTaLZpXMkhTrYgVxbJkOERagVE+zQuqo7ShHllWbbhEx9
HCXKErIpRolXwdFh6aTINeNwEKp5Jkut8r/4VnA/9tgHwC+0arOekWbKSdOf
rXQVfaPPJ25RcOWWOnBHPtNnAxgqZWisYeYeaDNea9lTrrXIaLoga0r/vrmj
KK7OwXqUE4rQN16xDZmPB6RZr+rFWGp/eN98UAfWaH2UPbFWGl+8MVHhqKi1
QzKhlFLUFXKHCYl/TDarFYmiiL/XMRGqA9wPnrtHb0ojYRVY6uWipX0c8Rk2
WXJZJk0FuFejNFPf7pXWaBevFd3TqVyqkIqcrPX+TGKAVKiv3BuDK2RbSyiS
9lBpyTEZy9Xema2lcQlVXpSWGjYWx3QspqTTatEVPCQLtZ8fG2Nc3HgmPAHQ
Pnk+gP0a+7w3A6EDOxShjGD3lbiIdCshuiONC7InUQor/0Q7LQopzr4S+4Ss
RFV2LcXZVidxQQ6AFwJYEC4u/LbTXy+SdIXYzXpF5tMRadWNtWwsNCUwoZMH
pcTyT3VBrPWF+LZQgLHwCradsnpCEimr1CCtFU0dhGJjpNuQeCKH3YsBbCee
2cUyL2XlncoX174sI4Xql1KTk/MAuVVRchj/VBfF2jg60duZuzY2Crge8VK1
pfXN63JwMgPLHPVRlRtQnRNU603S7nTJcDwly3UsBFzYdEyrkIV9MBO1Z5mG
2eKmJy+uz+bues0+TT6XmpFBq15dsGmhqlHeUcTRVCkw+5auN1E3BUMkWkGC
kV89qRRPCy/tv9yROWiZQ8nbouIETmjj4GWG7qdBd7AP/sQ1fl2TZV93rdjR
Mg4MVbsNbZzoQI5/3qnZ4YsEnSYroTixnSpiF+FFVKCpQviSfqRI3AZgv84+
v5iBUPz+jnlyY1hfqIAd0hT8ekXK2pPOvVekoT4RwFSKdbyOyGw2V2USPhiI
TEbWnEQGKedflonMaco3SE2RZoeqwGvlA8pZ98U3bsE291yZeMKkhEYOurdE
CcWYGv+TgW1FMh2/Q+YpR+c+RWB8SfWtvirMT2iF3gpg95bjyKpkdGulxFh2
xktF4Z5FYMKJdOcMSiKRp+AWADNGk67AIMfzCmmb47FdQQIFnyiBriepDm8B
GichEK/YZw7ybcXLHOioP5AE31UlpCs7t0tKw2J9WNClFAILsqA0y8BINCTd
1JUAy0mf1ColqvIXmVPFXB+6/12t6cTEHZj7bhJKdE23zl6oQVIqpmDH5nRY
nGuHXoIaSIXvBquCruzKR4p5XV6dc8POVrXfRYqanAfPgfPdVzdRRExT59Tm
jqE1IiLnwfC5E7F1oC4fofp8rZhGOOfh7TkTkT59aQzV6VJiJCodMXVyHq+e
MxHpU3tzm511neexsSLynYAGLmxERJF93peBrpeopw8djY6UCpVIHnrlrDxy
KBJSsKuSGLvAUGJFbPgxpTrBVJPJvHJVIAnc6HyJuUmyMF4MLLWiQobzJRka
LEv1fmo7CD8oPCcKVAlOdrNit1FNXuVdLJP2YCYRlsPmPtALjMH1xVIVULeu
O4RXXB2gq499utn/y82iKyb+Yf9mHwlgH9+/WXRLxXL/Zh8BYP+4f7Po4op/
2r9ZdB/gP+/fLLq84l/2b5ZfM8El4L/u39iDAAw1K8wTEUqxnM/JbMYi/2dk
Ea1hloujS3TXxL8BmLIlluOOjj5QWkKhVNNh9q8O6x5VrF4BmPqtVRnShHQV
a2QwHpOOtFYrrSHzHzgiuREmqLj0JzIxYe69ZAHOQrlFjLZk6lfW+nNXUDlC
5SYAQ3fqqtPOeDUng36fDMczZuqoA1ljRFRYPIIjahshcRXA0Fz0PRNV/oi0
X6E72xQCUUNV3tCcDUUtbWGwa/gCUUPl2z4hm7dg4osCPgHNPrFlz5mCxeq3
i1FnKyCoMzOnGoEBn6gq7icDScg+xN2qO6yPhUZdUi2lBIuodMmfcMT2IipQ
Ldy1xM2mouA+PnVe9CnP18Rk1mdZdppNINKoxu2/hyO9o3TwejE05cfZuzEO
FduoTu1/YERzHK6qSME4cS1miQyWcagoRT7r/0zBCvmw1CGR1JhrJi6qoEJu
lcy5qQ+WoZgjV/VGNm9hrinwOhE+1ekY9f5URgyuEh4ly48XOHmRY/q/2Gfu
s2IrPa3IvMJ6idluiUAskU/6U+yTg3Yc4aplP6ciLa0E1dpjHYIZuGkgb/N/
a87twEkns8VrMp9OyGg0IqPxhMVHFL4pDA/kL0bXfiEzZcf0e30YJgiGjoHP
HxMUC4CuoDt/TFBAxDQQk4zT6EBMULgIuu0QYeJ7howqVjhQQoE16G5IhJLv
Wa8jyBahhMKS/iIYJffJ7D2IUqApiyLG/vJ8ukIhdLPz6eoygH30fLq6BGB/
dT5doet9//p8uroIYH9zPl2h65Pn59MVqnf9twCGxvTq/t0jC+zv7rnukSny
EABDGi3SzxEMhQ2gPnxJROYh6tcXZ9Seg2XI3EiTwzagdPcMlu4+C8aDQvjW
ihy1voxKm6RZvfliirwLCUZhJ8PDHN/d4Pju/jm/u1kzD4kHX+bdmLP3vBTt
nIVb1vlDNZ1IhvkWi/eVCr7PPUZjhc5vfLmP1uk+WO3NDU4Rcp1kSIqCGiCP
nQ3p5GhIkRWxz3OP1oShC+Z9hwqJ2X2w2ocbiLvIt2EP2gWSMVRItUJaONKL
kE2zz3NFjemjwbe+Q5Wd2psPq324gbiLHDz2UD2cfYOsE2RGXNIsc1XHsmGo
Zf7cKxiI93Gr/l9Qy+H4cWvlgQwkzqvhvbxBRAShZBQQ3/mG8tyC+s1Jh0i9
LTwDfHVPTO0nakb5ylB0D/ShFxd6TiQOw6uS7wlxXdKM8tULbj8wBr4UiZzn
wh3gq3tCBXmqZpSv+opEw7koQSmYyM6Wt1QfVlM2iWq+BtAzcvbkwlAkO2+V
VGBf+dpR6ApvX+M3vVSz+kC4iBRAWE7B11Z+nSeaaKH42t6Sw5/y7Oqj2Y9/
/Jy+Eoco6ZsaRT44Gkjnz3gyhM/PNqmfTTbOn31IfiXOtEvszI3+VSqxz6Ip
Lam99XWrRheKItpq1tSIVFft2ZlZqImrEmZXMBWJmKJ8ULSYkelkQib0PZ3N
SbSORV1unZxsV/lRvaqMgOWgUQioeFt2NGmFHUNCLjt+axIUTFnOVJHS2+TP
17O+vq5QnYWWa20yjUR9GeVWypkH+DLBO5V+PjeXqeose3mlM0+bCC3Cq7S7
7biWMzU/dZXBDovSjmN++3g0btm1tUaROAZ/MODzFQ/UbT6nyp8+CWB4JKks
UT4P+jrShqduKX7vk5Eoma6uAJyYO6atoJ8SS2Ji54iFHLWElbK4HYxzmaSC
cYiuFyWLzrEXFT+othniv1K4XVQQ4q7AigZB9H+JVDtWUdnlQA9GeyKC+nNy
KDEGopyzXZGxVq+TWrVGarUaqVbKChm2dA6Rw/hMOSUzYo1Usp6q5lhqjtSw
wJpz2ePiSVlSKOyoBfsk+VA06fECSZVqnfTGC4H0tSRZx7shZcf+PBNXCdIR
Viiu9GXfzeFCtUB5xNMuD1mZWY2WM0TkWFc5aE83JJ51fAfqWhdBRzZB2uzY
VYVWFBK8RNIBqyxl6VBMkcNxp8KePqqWda07PZIYrOgc6QwXZkEGpp8+y4/1
Ju+4RoZDb9l1nQv5Ixt5feC2q7btUxUxQv5bs3llQsUCmVAVrP4ahcjS/JxK
xxPJIpkna1hUTgQLoRTZO9zc1dNtM1XRg1D8PB4jJjTxnZVuVdVLliDfTlRn
PKbrQO1InLbQFGBRjk3eNnucyI4rt8Y6VTK84vQOxpmr2DtblFOm3Yzx0QUc
d1e9VQVml9MBq7JnzUYrLzFfwnGCZ4wHJq6dvRvDZUFtT1Fqfyi3p/oW+oxM
4B2iFFfxFAUjb3ZgpBz4vgVxlXYdTbqqoJvRmq0Kt5RCtcgD0p2laPxaiXBy
Gy2zOe+sEK1YmJGH7MlCuzw9W2nMgrzFgZGJb/auoKu4uBy2dGyk4mLLbCeM
SM1F/3zrFBfTdRkqnZnm4sLo/oCLMBF6Bxf11RGbJRkNBiog7BYHMoqBAVV2
VYUhNlbjbj0xbcs9a9ckuRO+JReVgcfyRsbTpe6XE5OqAVBsDDVn0zO83Dac
zcjO3sHZ2wIxQZX3PYv3Plk2O6zbG1CFjK0FmIPAFEtXsvAgC1VXak86D95e
QDJfPDhhfMeec1smOqdZ6ChbNk8lYFV/hKwXZDRWQVYC+1G9kOiOhcLrVPJ4
ZqmUBUX9iYPwu21+s7FRAqpE2sMpiaIlGbZryggvtTTi/JUzt92L28HIUHvP
aI2i9LDFua36w6pOzWYmJmlrHJna+NxcKCZkhjVo+9AuGa78E8uB8aycys9a
PymdcibdK/U+I0i5lInBSRIDoVAb1u6ojXyrpl/JCzrTml0yHPRIvSz3sIMR
WU2yUwT4liQZCuFOSjkLT/+/Q7fvDrO+LROPEwuPeO8Kzrfofljhq2KSXuZJ
iPejV7L1TvXzYUfX5lWoNLpj5k7xLU3wLI2xOypcTMsrri7la6MKShfyVpR+
giJv1CW1su0tKtIp2yOLjTd5IilQavas9hqvksD/ujMxJ7KDz58CfitSI4RR
LdL3C4V7/Q83Po3s\
\>"],
   ImageRangeCache->{{{0, 480.625}, {346.625, 0}} -> {-0.128842, -0.225012, 
   0.0143403, 0.0143403}}], TraditionalForm]]]], "Text",
 CellChangeTimes->{{3.401283150695459*^9, 3.401283154396266*^9}},
 TextAlignment->Center,
 TextJustification->0]
}, Open  ]]
},
WindowToolbars->{},
WindowSize->{971, 722},
WindowMargins->{{2, Automatic}, {Automatic, 0}},
PrintingCopies->45,
PrintingPageRange->{1, Automatic},
ShowSelection->True,
DefaultNewCellStyle->"Input",
FontFamily->"Times",
Magnification->2.,
FrontEndVersion->"6.0 for Mac OS X x86 (32-bit) (June 19, 2007)",
StyleDefinitions->Notebook[{
   Cell[
    CellGroupData[{
      Cell["Style Definitions", "Title"], 
      Cell[
      "Modify the definitions below to change the default appearance of all \
cells in a given style.  Make modifications to any definition using commands \
in the Format menu.", "Text"], 
      Cell[
       CellGroupData[{
         Cell["Style Environment Names", "Section"], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, ScriptMinSize -> 
          9], 
         Cell[
          StyleData[All, "Presentation"], PageWidth -> WindowWidth, 
          ScriptMinSize -> 9], 
         Cell[
          StyleData[All, "SlideShow"], PageWidth -> WindowWidth, 
          ScrollingOptions -> {
           "PagewiseDisplay" -> True, "VerticalScrollRange" -> Fit}, 
          ShowCellBracket -> False, ScriptMinSize -> 9], 
         Cell[
          StyleData[All, "Printout"], PageWidth -> PaperWidth, ScriptMinSize -> 
          7, FontSize -> 10, 
          PrivateFontOptions -> {"FontType" -> "Outline"}]}, Open]], 
      Cell[
       CellGroupData[{
         Cell["Notebook Options", "Section"], 
         Cell[
         "The options defined for the style below will be used at the \
Notebook level.", "Text"], 
         Cell[
          StyleData["Notebook"], PageHeaders -> {{
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"], None, 
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"]}, {
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"], None, 
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"]}}, 
          PrintingOptions -> {
           "FirstPageFace" -> Right, "FirstPageHeader" -> False}, 
          StyleMenuListing -> None, Background -> 
          RGBColor[0.900008, 0.863996, 0.809995]]}, Open]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headings", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Title"], ShowCellBracket -> False, 
             CellMargins -> {{0, 0}, {0, 0}}, PageBreakBelow -> False, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, TextAlignment -> Center, TextJustification -> 0, 
             LineSpacing -> {1, 13}, 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}}, FontFamily -> "Helvetica", FontSize -> 34, 
             FontWeight -> "Bold", FontColor -> GrayLevel[1], Background -> 
             RGBColor[0.0500038, 0.100008, 0.2]], 
            Cell[
             StyleData["Title", "Presentation"], 
             CellFrameMargins -> {{14, 10}, {15, 15}}, FontSize -> 51], 
            Cell[
             StyleData["Title", "Printout"], CellMargins -> {{0, 0}, {0, 0}}, 
             FontSize -> 24, Background -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subtitle"], ShowCellBracket -> False, 
             CellMargins -> {{0, 0}, {0, 0}}, PageBreakBelow -> False, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, TextAlignment -> Center, TextJustification -> 0, 
             LineSpacing -> {1, 3}, ParagraphIndent -> -96, 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}}, FontFamily -> "Helvetica", FontSize -> 24, 
             FontColor -> GrayLevel[1], Background -> 
             RGBColor[0.250004, 0.400015, 0.6]], 
            Cell[
             StyleData["Subtitle", "Presentation"], 
             CellFrameMargins -> {{14, 10}, {14, 14}}, FontSize -> 27], 
            Cell[
             StyleData["Subtitle", "Printout"], 
             CellMargins -> {{0, 0}, {0, 0}}, ParagraphIndent -> -85, 
             FontSize -> 16]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubtitle"], ShowCellBracket -> False, 
             CellMargins -> {{0, 0}, {0, 0}}, PageBreakBelow -> False, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, TextAlignment -> Right, TextJustification -> 0, 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}}, FontFamily -> "Helvetica", FontSize -> 16, 
             FontSlant -> "Italic", Background -> 
             RGBColor[0.624994, 0.700008, 0.8]], 
            Cell[
             StyleData["Subsubtitle", "Presentation"], 
             CellMargins -> {{0, 0}, {0, 0}}, FontSize -> 24], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{0, 0}, {0, 0}}, FontSize -> 16]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellFrame -> {{0, 0}, {0, 1.5}}, 
             CellDingbat -> None, CellMargins -> {{12, Inherited}, {4, 24}}, 
             CellGroupingRules -> {"SectionGrouping", 30}, PageBreakBelow -> 
             False, CellFrameMargins -> {{0, 4}, {6, 2}}, CellFrameColor -> 
             RGBColor[0.0500038, 0.100008, 0.2], CellFrameLabelMargins -> 2, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, CounterIncrements -> "Section", 
             CounterAssignments -> {{"Subsection", 0}, {"Subsubsection", 0}}, 
             FontFamily -> "Helvetica", FontSize -> 18, FontWeight -> "Bold", 
             FontColor -> RGBColor[0.0500038, 0.100008, 0.2]], 
            Cell[
             StyleData["Section", "Presentation"], 
             CellFrame -> {{0, 0}, {0, 2}}, 
             CellMargins -> {{14, 10}, {6, 24}}, FontSize -> 27], 
            Cell[
             StyleData["Section", "Printout"], 
             CellMargins -> {{9, 0}, {2, 50}}, FontSize -> 14, FontTracking -> 
             "Plain", FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellMargins -> {{12, 10}, {25, 0}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, LineSpacing -> {1, 3}, ParagraphSpacing -> {0, 12},
              FontFamily -> "Helvetica"], 
            Cell[
             StyleData["Subsection", "Presentation"], 
             CellMargins -> {{14, 10}, {45, 4}}, FontSize -> 18], 
            Cell[
             StyleData["Subsection", "Printout"], 
             CellMargins -> {{9, 0}, {4, 40}}, FontSize -> 12]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsection"], CellMargins -> {{12, 10}, {5, 20}}, 
             CellFrameMargins -> {{0, 0}, {0, 2}}, CellFrameColor -> 
             RGBColor[0.100008, 0.2, 0.4], 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, LineSpacing -> {1, 0}, ParagraphSpacing -> {0, 12},
              FontFamily -> "Helvetica", FontSize -> 14, FontWeight -> "Bold",
              FontSlant -> "Italic", FontColor -> 
             RGBColor[0.100008, 0.2, 0.4]], 
            Cell[
             StyleData["Subsubsection", "Presentation"], 
             CellMargins -> {{14, 10}, {8, 20}}, 
             CellFrameMargins -> {{0, 0}, {0, 4}}, FontSize -> 22], 
            Cell[
             StyleData["Subsubsection", "Printout"], 
             CellMargins -> {{19, 0}, {4, 20}}, FontSize -> 13]}, Open]]}, 
        Open]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Body Text", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Text"], CellMargins -> {{12, 10}, {5, 5}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, LineSpacing -> {1, 3}, ParagraphSpacing -> {0, 12},
              FontFamily -> "Times"], 
            Cell[
             StyleData["Text", "Presentation"], 
             CellMargins -> {{14, 10}, {8, 10}}, FontSize -> 18], 
            Cell[
             StyleData["Text", "Printout"], CellMargins -> {{9, 0}, {4, 4}}, 
             Hyphenation -> True, ParagraphSpacing -> {0, 6}, FontSize -> 
             10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Commentary"], CellMargins -> {{52, 10}, {0, 10}}, 
             PageBreakBelow -> False, CellFrameMargins -> {{0, 0}, {0, 2}}, 
             CellFrameColor -> GrayLevel[1], LineSpacing -> {1, 0}, 
             ParagraphSpacing -> {0, 12}, FontFamily -> "Helvetica", FontSize -> 
             10, FontWeight -> "Plain", FontSlant -> "Plain"], 
            Cell[
             StyleData["Commentary", "Presentation"], 
             CellMargins -> {{72, 10}, {4, 14}}, FontSize -> 15], 
            Cell[
             StyleData["Commentary", "Printout"], 
             CellMargins -> {{9, 0}, {4, 4}}, Hyphenation -> True, 
             ParagraphSpacing -> {0, 6}, FontSize -> 10]}, Closed]]}, Open]], 
      
      Cell[
       CellGroupData[{
         Cell["Inline Formatting", "Section"], 
         Cell[
         "These styles are for modifying individual words or letters in a \
cell exclusive of the cell tag.", "Text"], 
         Cell[
          StyleData["RM"], StyleMenuListing -> None, FontWeight -> "Plain", 
          FontSlant -> "Plain"], 
         Cell[
          StyleData["BF"], StyleMenuListing -> None, FontWeight -> "Bold"], 
         Cell[
          StyleData["IT"], StyleMenuListing -> None, FontSlant -> "Italic"], 
         Cell[
          StyleData["TR"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["TI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["TB"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["TBI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["MR"], "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["MO"], "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["MB"], "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["MBO"], "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["SR"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["SO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["SB"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["SBO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SO10"], StyleMenuListing -> None, FontFamily -> 
             "Helvetica", FontSize -> 10, FontWeight -> "Plain", FontSlant -> 
             "Italic"], 
            Cell[
             StyleData["SO10", "Printout"], StyleMenuListing -> None, 
             FontFamily -> "Helvetica", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Inert"], StyleMenuListing -> None, Background -> 
             RGBColor[0.870588, 0.905882, 0.972549]], 
            Cell[
             StyleData["Inert", "Printout"], StyleMenuListing -> None, 
             Background -> GrayLevel[1]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Input/Output", "Section"], 
         Cell[
         "The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Input"], CellFrame -> 4, 
             CellMargins -> {{62, 10}, {0, 2}}, Evaluatable -> True, 
             CellGroupingRules -> "InputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             CellFrameColor -> RGBColor[0.8, 0.700008, 0.6], 
             DefaultFormatType -> DefaultInputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", FormatType -> InputForm, ShowStringCharacters -> True,
              NumberMarks -> True, 
             LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, FontWeight -> 
             "Bold", Background -> GrayLevel[1]], 
            Cell[
             StyleData["Input", "Presentation"], 
             CellFrame -> {{6, 6}, {0, 6}}, CellMargins -> {{72, 10}, {0, 2}},
              CellFrameMargins -> 12, FontSize -> 18], 
            Cell[
             StyleData["Input", "Printout"], CellMargins -> {{37, 0}, {6, 6}},
              LinebreakAdjustments -> {0.85, 2, 10, 1, 1}]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["InlineInput"], Evaluatable -> True, CellGroupingRules -> 
             "InputGrouping", CellHorizontalScrolling -> True, 
             PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             DefaultFormatType -> DefaultInputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, FormatType -> InputForm, 
             ShowStringCharacters -> True, NumberMarks -> True, 
             CounterIncrements -> "Input", FontWeight -> "Bold"], 
            Cell[
             StyleData["InlineInput", "Presentation"], 
             CellMargins -> {{10, 10}, {4, 4}}, FontSize -> 18]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Output"], CellFrame -> {{4, 4}, {4, 0}}, 
             CellMargins -> {{62, 10}, {12, 0}}, CellEditDuplicate -> True, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             CellFrameColor -> RGBColor[0.8, 0.700008, 0.6], 
             DefaultFormatType -> DefaultOutputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", FormatType -> InputForm, Background -> GrayLevel[1]], 
            
            Cell[
             StyleData["Output", "Presentation"], 
             CellFrame -> {{6, 6}, {6, 0}}, 
             CellMargins -> {{72, 10}, {20, 2}}, CellFrameMargins -> 12, 
             FontSize -> 18], 
            Cell[
             StyleData["Output", "Printout"], 
             CellMargins -> {{37, 0}, {6, 2}}]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["InputOnly"], CellFrame -> 4, 
             CellMargins -> {{62, 10}, {4, 2}}, Evaluatable -> True, 
             CellGroupingRules -> "NormalGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             CellFrameColor -> RGBColor[0.8, 0.700008, 0.6], 
             DefaultFormatType -> DefaultInputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", FormatType -> InputForm, ShowStringCharacters -> True,
              NumberMarks -> True, 
             LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, FontWeight -> 
             "Bold", Background -> GrayLevel[1]], 
            Cell[
             StyleData["InputOnly", "Presentation"], CellFrame -> 6, 
             CellMargins -> {{72, 10}, {5, 2}}, CellFrameMargins -> 12, 
             FontSize -> 18], 
            Cell[
             StyleData["InputOnly", "Printout"], 
             LinebreakAdjustments -> {0.85, 2, 10, 1, 1}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["OutputOnly"], CellFrame -> 4, 
             CellMargins -> {{62, 10}, {4, 2}}, CellEditDuplicate -> True, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             CellFrameColor -> RGBColor[0.8, 0.700008, 0.6], 
             DefaultFormatType -> DefaultOutputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", FormatType -> InputForm, Background -> GrayLevel[1]], 
            
            Cell[
             StyleData["OutputOnly", "Presentation"], CellFrame -> 6, 
             CellMargins -> {{72, 10}, {4, 4}}, CellFrameMargins -> 12, 
             FontSize -> 18], 
            Cell[
             StyleData["OutputOnly", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SymbolicExpression"], CellFrame -> 1, 
             CellMargins -> {{62, 10}, {4, 2}}, CellEditDuplicate -> True, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             CellFrameColor -> GrayLevel[0], DefaultFormatType -> 
             DefaultOutputFormatType, "TwoByteSyntaxCharacterAutoReplacement" -> 
             True, HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, FormatType -> 
             InputForm, FontFamily -> "Courier", FontWeight -> "Plain", 
             FontSlant -> "Plain", FontTracking -> "Plain", 
             FontVariations -> {
              "Outline" -> False, "Shadow" -> False, "Underline" -> False}, 
             Background -> GrayLevel[1]], 
            Cell[
             StyleData["SymbolicExpression", "Presentation"], CellFrame -> 2, 
             CellMargins -> {{72, 10}, {4, 4}}, CellFrameMargins -> 12, 
             FontSize -> 18], 
            Cell[
             StyleData["SymbolicExpression", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Message"], 
             CellMargins -> {{52, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             DefaultFormatType -> DefaultOutputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, FormatType -> 
             InputForm, StyleMenuListing -> None, FontColor -> 
             RGBColor[1, 0, 0]], 
            Cell[
             StyleData["Message", "Presentation"], 
             CellMargins -> {{72, 10}, {6, 6}}, FontSize -> 18], 
            Cell[
             StyleData["Message", "Printout"], 
             CellMargins -> {{30, Inherited}, {Inherited, Inherited}}, 
             FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Print"], 
             CellMargins -> {{52, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, ShowCellLabel -> 
             False, CellLabelMargins -> {{21, Inherited}, {
               Inherited, Inherited}}, DefaultFormatType -> 
             DefaultOutputFormatType, "TwoByteSyntaxCharacterAutoReplacement" -> 
             True, HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, FormatType -> 
             InputForm, StyleMenuListing -> None], 
            Cell[
             StyleData["Print", "Presentation"], 
             CellMargins -> {{72, 10}, {6, 6}}, FontSize -> 18], 
            Cell[
             StyleData["Print", "Printout"], 
             CellMargins -> {{30, Inherited}, {Inherited, Inherited}}]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Info"], 
             CellMargins -> {{52, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, ShowCellLabel -> 
             False, CellLabelMargins -> {{21, Inherited}, {
               Inherited, Inherited}}, DefaultFormatType -> 
             DefaultOutputFormatType, "TwoByteSyntaxCharacterAutoReplacement" -> 
             True, HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, FormatType -> 
             InputForm, StyleMenuListing -> None], 
            Cell[
             StyleData["Info", "Presentation"], 
             CellMargins -> {{72, 10}, {6, 6}}, FontSize -> 18], 
            Cell[
             StyleData["Info", "Printout"], 
             CellMargins -> {{30, Inherited}, {Inherited, Inherited}}]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Graphics"], CellFrame -> {{4, 4}, {4, 0}}, 
             CellMargins -> {{62, 10}, {0, 0}}, CellGroupingRules -> 
             "GraphicsGrouping", CellHorizontalScrolling -> True, 
             PageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             CellFrameColor -> RGBColor[0.8, 0.700008, 0.6], 
             DefaultFormatType -> DefaultOutputFormatType, FormatType -> 
             InputForm, ImageMargins -> {{43, Inherited}, {Inherited, 0}}, 
             StyleMenuListing -> None, Background -> GrayLevel[1]], 
            Cell[
             StyleData["Graphics", "Presentation"], 
             CellFrame -> {{6, 6}, {0, 0}}, CellMargins -> {{72, 10}, {0, 0}},
              CellFrameMargins -> 12, FontSize -> 18], 
            Cell[
             StyleData["Graphics", "Printout"], ImageSize -> {250, 250}, 
             ImageMargins -> {{28, Inherited}, {Inherited, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["ImportPict"], CellMargins -> {{52, 10}, {0, 0}}, 
             CellGroupingRules -> "GraphicsGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GeneratedCell -> True, 
             DefaultFormatType -> DefaultOutputFormatType, FormatType -> 
             InputForm, StyleMenuListing -> "ImportPict", Background -> None],
             
            Cell[
             StyleData["ImportPict", "Presentation"], 
             CellMargins -> {{72, 10}, {0, 0}}, FontSize -> 18], 
            Cell[
             StyleData["ImportPict", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["CellLabel"], StyleMenuListing -> None, FontFamily -> 
             "Helvetica", FontSize -> 10, FontWeight -> "Plain", FontSlant -> 
             "Italic", FontColor -> RGBColor[0.2, 0.2, 0.700008]], 
            Cell[
             StyleData["CellLabel", "Presentation"], FontSize -> 15], 
            Cell[
             StyleData["CellLabel", "Printout"], FontFamily -> "Courier", 
             FontSize -> 8, FontSlant -> "Italic", FontColor -> 
             GrayLevel[0]]}, Open]]}, Open]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Unique Items", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PullQuote"], CellFrame -> {{0, 0}, {0, 3}}, 
             CellMargins -> {{0, 250}, {15, 5}}, 
             CellFrameMargins -> {{20, 4}, {8, 6}}, LineSpacing -> {1, 1}, 
             ParagraphSpacing -> {0, 12}, FontFamily -> "Helvetica", FontSize -> 
             12, FontWeight -> "Bold", FontColor -> GrayLevel[1], Background -> 
             RGBColor[0.6, 0, 0.8]], 
            Cell[
             StyleData["PullQuote", "Presentation"], 
             CellFrame -> {{0, 0}, {0, 5}}, 
             CellMargins -> {{0, 250}, {25, 8}}, 
             CellFrameMargins -> {{30, 10}, {10, 10}}, FontSize -> 18], 
            Cell[
             StyleData["PullQuote", "Printout"], 
             CellMargins -> {{9, 0}, {4, 4}}, ParagraphSpacing -> {0, 6}, 
             FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["GrayBox"], CellFrame -> {{0, 0}, {0, 3}}, 
             CellMargins -> {{62, 36}, {10, 5}}, 
             CellFrameMargins -> {{8, 4}, {8, 4}}, LineSpacing -> {1, 3}, 
             ParagraphSpacing -> {0, 12}, FontFamily -> "Helvetica", FontSize -> 
             10, FontWeight -> "Plain", FontColor -> GrayLevel[0], Background -> 
             RGBColor[0.8, 0.700008, 0.6]], 
            Cell[
             StyleData["GrayBox", "Presentation"], 
             CellFrame -> {{0, 0}, {0, 5}}, 
             CellMargins -> {{90, 55}, {16, 5}}, 
             CellFrameMargins -> {{10, 10}, {12, 6}}, FontSize -> 15], 
            Cell[
             StyleData["GrayBox", "Printout"], 
             CellMargins -> {{62, 36}, {10, 5}}, Background -> 
             GrayLevel[0.8]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Picture"], CellFrame -> 4, 
             CellMargins -> {{52, 10}, {0, 0}}, CellGroupingRules -> 
             "GraphicsGrouping", CellHorizontalScrolling -> True, 
             PageBreakWithin -> False, CellFrameColor -> 
             RGBColor[0.8, 0.700008, 0.6], DefaultFormatType -> 
             DefaultOutputFormatType, FormatType -> InputForm, 
             StyleMenuListing -> None, Background -> GrayLevel[1]], 
            Cell[
             StyleData["Picture", "Presentation"], CellFrame -> 6, 
             CellMargins -> {{72, 10}, {0, 6}}, CellFrameMargins -> 12, 
             FontSize -> 18], 
            Cell[
             StyleData["Picture", "Printout"], ImageSize -> {250, 250}, 
             ImageMargins -> {{28, Inherited}, {Inherited, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PictureGroup"], CellFrame -> {{4, 4}, {0, 0}}, 
             CellMargins -> {{52, Inherited}, {0, 0}}, CellGroupingRules -> 
             "GraphicsGrouping", CellHorizontalScrolling -> True, 
             PageBreakWithin -> False, ShowCellLabel -> False, CellFrameColor -> 
             RGBColor[0.8, 0.700008, 0.6], 
             ImageMargins -> {{43, Inherited}, {Inherited, 0}}, 
             StyleMenuListing -> None, Background -> GrayLevel[1]], 
            Cell[
             StyleData["PictureGroup", "Presentation"], 
             CellFrame -> {{6, 6}, {0, 0}}, CellMargins -> {{72, 10}, {0, 0}},
              CellFrameMargins -> 12, FontSize -> 18], 
            Cell[
             StyleData["PictureGroup", "Printout"], ImageSize -> {250, 250}, 
             ImageMargins -> {{28, Inherited}, {Inherited, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["LineSpace"], CellMargins -> {{0, 0}, {0, 0}}, 
             CellElementSpacings -> {"CellMinHeight" -> 2}, FontSize -> 9], 
            Cell[
             StyleData["LineSpace", "Presentation"], 
             CellMargins -> {{0, 4}, {0, 0}}, FontSize -> 14]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Hyperlink Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Hyperlink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
               ButtonData}], 
            Cell[
             StyleData["Hyperlink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["Hyperlink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["Hyperlink", "SlideShow"]], 
            Cell[
             StyleData["Hyperlink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
         "The following styles are for linking automatically to the on-line \
help system.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["MainBookLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["MainBook", #]}]& )}], 
            Cell[
             StyleData["MainBookLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["MainBookLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["MainBookLink", "SlideShow"]], 
            Cell[
             StyleData["MainBookLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["AddOnsLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontColor -> RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["AddOns", #]}]& )}], 
            Cell[
             StyleData["AddOnsLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["AddOnsLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["AddOnsLink", "SlideShow"]], 
            Cell[
             StyleData["AddOnsLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["RefGuideLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontColor -> RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["RefGuide", #]}]& )}], 
            Cell[
             StyleData["RefGuideLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["RefGuideLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["RefGuideLink", "SlideShow"]], 
            Cell[
             StyleData["RefGuideLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["RefGuideLinkText"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["RefGuide", #]}]& )}], 
            Cell[
             StyleData["RefGuideLinkText", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["RefGuideLinkText", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["RefGuideLinkText", "SlideShow"]], 
            Cell[
             StyleData["RefGuideLinkText", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["GettingStartedLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["GettingStarted", #]}]& )}], 
            Cell[
             StyleData["GettingStartedLink", "Presentation"], FontSize -> 16],
             
            Cell[
             StyleData["GettingStartedLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["GettingStartedLink", "SlideShow"]], 
            Cell[
             StyleData["GettingStartedLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["DemosLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["Demos", #]}]& )}], 
            Cell[
             StyleData["DemosLink", "SlideShow"]], 
            Cell[
             StyleData["DemosLink", "Printout"], 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["TourLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["Tour", #]}]& )}], 
            Cell[
             StyleData["TourLink", "SlideShow"]], 
            Cell[
             StyleData["TourLink", "Printout"], 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["OtherInformationLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["OtherInformation", #]}]& )}], 
            Cell[
             StyleData["OtherInformationLink", "Presentation"], FontSize -> 
             16], 
            Cell[
             StyleData["OtherInformationLink", "Condensed"], FontSize -> 11], 
            
            Cell[
             StyleData["OtherInformationLink", "SlideShow"]], 
            Cell[
             StyleData["OtherInformationLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["MasterIndexLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["MasterIndex", #]}]& )}], 
            Cell[
             StyleData["MasterIndexLink", "SlideShow"]], 
            Cell[
             StyleData["MasterIndexLink", "Printout"], 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Palette Styles", "Section"], 
         Cell[
         "The cells below define styles that define standard ButtonFunctions, \
for use in palette buttons.", "Text"], 
         Cell[
          StyleData["Paste"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, After]}]& )}], 
         Cell[
          StyleData["Evaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["EvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionMove[
                FrontEnd`InputNotebook[], All, Cell, 1], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Slide Show Styles", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideShowNavigationBar"], Editable -> False, 
             CellFrame -> True, CellMargins -> {{0, 0}, {3, 3}}, 
             CellElementSpacings -> {"CellMinHeight" -> 0.8125}, 
             CellGroupingRules -> {"SectionGrouping", 30}, CellFrameMargins -> 
             False, CellFrameColor -> GrayLevel[1], CellFrameLabelMargins -> 
             False, TextAlignment -> Center, CounterIncrements -> 
             "SlideShowNavigationBar", StyleMenuListing -> None, FontSize -> 
             10, Magnification -> 1, Background -> GrayLevel[0.8], 
             GridBoxOptions -> {
              BaselinePosition -> Center, 
               GridBoxAlignment -> {
                "Columns" -> {
                  Center, Center, Center, Center, Center, Center, Right, {
                   Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
                 "RowsIndexed" -> {}}, 
               GridBoxItemSize -> {
                "Columns" -> {3.5, 3.5, 3.5, 3.5, 13, 5, {4}}, 
                 "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
                 "RowsIndexed" -> {}}, GridBoxSpacings -> {"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}}], 
            Cell[
             StyleData["SlideShowNavigationBar", "SlideShow"], Deletable -> 
             False, ShowCellBracket -> False, 
             CellMargins -> {{-1, -1}, {-1, -1}}, PageBreakAbove -> True, 
             CellFrameMargins -> {{1, 1}, {0, 0}}], 
            Cell[
             StyleData["SlideShowNavigationBar", "Printout"], 
             CellMargins -> {{18, 4}, {4, 4}}, LineSpacing -> {1, 3}, 
             FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideShowSection"], CellFrame -> {{0, 0}, {0, 0.5}}, 
             CellMargins -> {{0, 0}, {10, 0}}, 
             CellGroupingRules -> {"SectionGrouping", 40}, PageBreakBelow -> 
             False, CellFrameMargins -> {{12, 4}, {6, 12}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, CounterIncrements -> "Section", 
             CounterAssignments -> {{"Subsection", 0}, {"Subsubsection", 0}}, 
             StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 
             18, FontWeight -> "Plain", FontColor -> GrayLevel[1], Background -> 
             RGBColor[0.408011, 0.440726, 0.8]], 
            Cell[
             StyleData["SlideShowSection", "Presentation"], 
             CellFrameMargins -> {{18, 10}, {10, 18}}, FontSize -> 27], 
            Cell[
             StyleData["SlideShowSection", "SlideShow"], ShowCellBracket -> 
             False, PageBreakAbove -> True], 
            Cell[
             StyleData["SlideShowSection", "Printout"], 
             CellMargins -> {{18, 30}, {0, 30}}, CellFrameMargins -> 5, 
             FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideHyperlink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontSize -> 26, FontColor -> 
             GrayLevel[0.400015], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonMargins -> 0.5, 
               ButtonMinHeight -> 0.85, ButtonNote -> None}], 
            Cell[
             StyleData["SlideHyperlink", "Presentation"], 
             CellMargins -> {{10, 10}, {8, 12}}, FontSize -> 36], 
            Cell[
             StyleData["SlideHyperlink", "SlideShow"]], 
            Cell[
             StyleData["SlideHyperlink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideTOCLink"], 
             CellMargins -> {{24, Inherited}, {Inherited, Inherited}}, 
             StyleMenuListing -> None, ButtonStyleMenuListing -> Automatic, 
             FontFamily -> "Helvetica", 
             ButtonBoxOptions -> {
              Active -> True, ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonMargins -> 1.5, 
               ButtonNote -> ButtonData}], 
            Cell[
             StyleData["SlideTOCLink", "Presentation"], 
             CellMargins -> {{35, 10}, {6, 4}}, FontSize -> 18], 
            Cell[
             StyleData["SlideTOCLink", "SlideShow"]], 
            Cell[
             StyleData["SlideTOCLink", "Printout"], 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideTOC"], CellDingbat -> "\[Bullet]", 
             CellMargins -> {{18, Inherited}, {Inherited, Inherited}}, 
             StyleMenuListing -> None, FontFamily -> "Helvetica"], 
            Cell[
             StyleData["SlideTOC", "Presentation"], 
             CellMargins -> {{25, 10}, {6, 6}}, FontSize -> 18], 
            Cell[
             StyleData["SlideTOC", "SlideShow"], FontSize -> 14], 
            Cell[
             StyleData["SlideTOC", "Printout"], FontSize -> 10, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Open]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headers and Footers", "Section"], 
         Cell[
          StyleData["Header"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 9, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["Footer"], CellMargins -> {{0, 0}, {0, 4}}, 
          StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 6],
          
         Cell[
          StyleData["PageNumber"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 9, 
          FontWeight -> "Bold"]}, Open]], 
      Cell[
       CellGroupData[{
         Cell["FormatType Styles", "Section"], 
         Cell[
         "The cells below define styles that are mixed in with the styles of \
most cells.  If a cell's FormatType matches the name of one of the styles \
defined below, then that style is applied between the cell's style and its \
own options.", "Text"], 
         Cell[
          StyleData["CellExpression"], CellFrame -> 1, 
          CellMargins -> {{52, 10}, {4, 2}}, ShowCellLabel -> False, 
          CellLabelMargins -> {{23, Inherited}, {Inherited, Inherited}}, 
          ShowSpecialCharacters -> False, AllowInlineCells -> False, 
          StyleMenuListing -> None, FontFamily -> "Courier", FontSize -> 10, 
          FontColor -> GrayLevel[0], Background -> GrayLevel[1]]}, Open]]}, 
     Open]]}, Visible -> False, FrontEndVersion -> 
  "6.0 for Mac OS X x86 (32-bit) (June 19, 2007)", StyleDefinitions -> 
  "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 90, 4, 100, "Title"],
Cell[661, 27, 31, 0, 80, "Subtitle"],
Cell[695, 29, 48, 0, 64, "Subsubtitle"],
Cell[CellGroupData[{
Cell[768, 33, 31, 0, 99, "Section"],
Cell[802, 35, 481, 8, 164, "Text"],
Cell[1286, 45, 37, 0, 78, "Subsubsection"],
Cell[1326, 47, 187, 4, 74, "Text"],
Cell[1516, 53, 62, 1, 100, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1615, 59, 56, 0, 99, "Section"],
Cell[1674, 61, 125, 5, 44, "Text"],
Cell[1802, 68, 481, 20, 44, "Text"],
Cell[2286, 90, 365, 8, 104, "Text"],
Cell[2654, 100, 444, 15, 107, "Input"],
Cell[3101, 117, 444, 15, 107, "Input"],
Cell[3548, 134, 188, 6, 74, "Text"],
Cell[3739, 142, 13855, 497, 179, "Text"],
Cell[17597, 641, 222, 8, 74, "Text"],
Cell[17822, 651, 39042, 1340, 512, "Text"],
Cell[CellGroupData[{
Cell[56889, 1995, 1331, 38, 221, "Input"],
Cell[58223, 2035, 257, 7, 142, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[58529, 2048, 41, 0, 99, "Section"],
Cell[58573, 2050, 185, 5, 74, "Text"],
Cell[58761, 2057, 20457, 732, 327, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[79255, 2794, 57, 0, 99, "Section"],
Cell[79315, 2796, 257, 7, 74, "Text"],
Cell[79575, 2805, 446, 15, 107, "Input"],
Cell[80024, 2822, 446, 15, 107, "Input"],
Cell[80473, 2839, 195, 6, 74, "Text"],
Cell[80671, 2847, 24388, 811, 386, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[105096, 3663, 36, 0, 99, "Section"],
Cell[105135, 3665, 39634, 1364, 428, "Text"],
Cell[144772, 5031, 64, 0, 44, "Text"],
Cell[144839, 5033, 657, 28, 125, "Text"],
Cell[145499, 5063, 63, 0, 44, "Text"],
Cell[145565, 5065, 798, 31, 125, "Text"],
Cell[146366, 5098, 55, 0, 44, "Text"],
Cell[146424, 5100, 1020, 26, 257, "Input"],
Cell[147447, 5128, 194, 5, 74, "Text"],
Cell[147644, 5135, 46366, 1602, 394, "Text"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
