(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    159400,       3314]
NotebookOptionsPosition[     99364,       2048]
NotebookOutlinePosition[    157862,       3258]
CellTagsIndexPosition[    157819,       3255]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Exercise"
}], "Title"],

Cell["Gauss's Law", "Subtitle",
 CellChangeTimes->{{3.3984408145209703`*^9, 3.3984408216934547`*^9}}],

Cell["Phys 2426 - Blinn College", "Subsubtitle"],

Cell[CellGroupData[{

Cell["Introduction", "Section"],

Cell["\<\
This is an exercise to help with the visualization of Gauss's Law\
\>", "Text",
 CellChangeTimes->{{3.3984384894376173`*^9, 3.3984385032247543`*^9}},
 FontFamily->"Times"],

Cell["Load Package", "Subsubsection"],

Cell[BoxData[
 RowBox[{"<<", "GaussLaw`"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.3984384716996727`*^9, 3.3984384758875647`*^9}}]
}, {3}]],

Cell[CellGroupData[{

Cell["Uniform Spherical Shell", "Section",
 CellChangeTimes->{{3.398438527590519*^9, 3.39843854257592*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", "=", "1.35"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"With", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Q", "=", "1"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Qin", "=", 
           RowBox[{"Function", "[", 
            RowBox[{"r", ",", 
             RowBox[{"Piecewise", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"r", "<", "1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"Q", ",", 
                  RowBox[{"r", "\[GreaterEqual]", "1"}]}], "}"}]}], "}"}], 
              "]"}]}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"GraphicsRow", "[", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Graphics3D", "[", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"PartialSphere", "[", 
                  RowBox[{"1", ",", "\[Alpha]"}], "]"}], "}"}], ",", 
                RowBox[{"If", "[", 
                 RowBox[{"ShowGaussianSurface", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Opacity", "[", ".3", "]"}], ",", "Yellow", ",", 
                    RowBox[{"Sphere", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "r"}], 
                    "]"}]}], "}"}], ",", 
                  RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]", "}"}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"SphericalRegion", "\[Rule]", "True"}], ",", 
              RowBox[{"PlotRange", "\[Rule]", "a"}], ",", 
              RowBox[{"Lighting", "\[Rule]", "\"\<Neutral\>\""}], ",", 
              RowBox[{"Boxed", "\[Rule]", "False"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"GraphicsColumn", "[", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Plot", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Qin", "[", "r", "]"}], "/", 
                  SuperscriptBox["r", "2"]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"r", ",", "0", ",", "a"}], "}"}], ",", 
                 RowBox[{"AxesLabel", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"\"\<r\>\"", ",", "\"\<E\>\""}], "}"}]}], ",", 
                 RowBox[{"Epilog", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{"r", ",", 
                    RowBox[{
                    RowBox[{"Qin", "[", "r", "]"}], "/", 
                    SuperscriptBox["r", "2"]}]}], "}"}], "]"}], "}"}]}]}], 
                "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Plot", "[", 
                RowBox[{
                 RowBox[{"Qin", "[", "r", "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"r", ",", "0", ",", "a"}], "}"}], ",", 
                 RowBox[{"AxesLabel", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<r\>\"", ",", 
                    "\"\<\!\(\*SubscriptBox[\(Q\), \(inside\)]\)\>\""}], 
                   "}"}]}], ",", 
                 RowBox[{"Epilog", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{"r", ",", 
                    RowBox[{"Qin", "[", "r", "]"}]}], "}"}], "]"}], "}"}]}]}],
                 "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "ShowGaussianSurface", ",", "True", ",", 
         "\"\<Show Gaussian Surface\>\""}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", ",", ".3", ",", "\"\<Radius of Gaussian Surface, \!\(\*
StyleBox[\"r\",
FontSlant->\"Italic\"]\)\>\""}], "}"}], ",", "0", ",", "a"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Alpha]", ",", 
         RowBox[{"\[Pi]", "/", "2"}], ",", "\"\<Open/\\nClose\>\""}], "}"}], 
       ",", "0", ",", 
       RowBox[{"\[Pi]", "/", "2"}], ",", "VerticalSlider"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ControlPlacement", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Top", ",", "Top", ",", "Left"}], "}"}]}]}], "]"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.398189518843156*^9, 3.398189542328974*^9}, {
   3.398189703717575*^9, 3.398189707772398*^9}, {3.3981903999826603`*^9, 
   3.398190415155349*^9}, {3.3981906177277308`*^9, 3.398190618311503*^9}, {
   3.3981906970931187`*^9, 3.39819071841469*^9}, {3.398190796544886*^9, 
   3.39819084295564*^9}, {3.398190992236206*^9, 3.398190992949183*^9}, {
   3.3981912151864758`*^9, 3.3981912304031563`*^9}, 3.398191943166893*^9, {
   3.3981920407067623`*^9, 3.398192041154608*^9}, {3.398192224624048*^9, 
   3.398192246260215*^9}, {3.3981924232561083`*^9, 3.39819242383998*^9}, {
   3.3981924540690317`*^9, 3.398192458254427*^9}, {3.398193235867538*^9, 
   3.398193371371364*^9}, {3.398193402487297*^9, 3.3981934421094427`*^9}, {
   3.398193477651885*^9, 3.398193480011443*^9}, {3.398193526965308*^9, 
   3.398193529999423*^9}, {3.3981936281433487`*^9, 3.398193628714527*^9}, {
   3.398211458065336*^9, 3.398211474622287*^9}, {3.398211759958426*^9, 
   3.398211841603096*^9}, {3.398211932198592*^9, 3.39821199811235*^9}, {
   3.3982122498711042`*^9, 3.398212250439529*^9}, {3.3982122825200863`*^9, 
   3.3982122832305317`*^9}, {3.398212321751828*^9, 3.39821232243696*^9}, {
   3.3982136166901407`*^9, 3.398213618705285*^9}, {3.398213747994172*^9, 
   3.3982137700882807`*^9}, {3.398214014635215*^9, 3.39821408216568*^9}, {
   3.398214409975504*^9, 3.39821451400537*^9}, {3.3982145744984627`*^9, 
   3.398214601573984*^9}, {3.398215541496993*^9, 3.398215554806691*^9}, {
   3.398215593102791*^9, 3.398215612880127*^9}, {3.398215644528266*^9, 
   3.398215673168098*^9}, {3.3982157472252817`*^9, 3.3982157608722467`*^9}, {
   3.39821601089727*^9, 3.39821601352607*^9}, {3.398216065712262*^9, 
   3.398216246623929*^9}, {3.398216278263227*^9, 3.398216367156925*^9}, {
   3.3982164079789963`*^9, 3.398216422497486*^9}, {3.398216454314692*^9, 
   3.398216455392363*^9}, 3.398218036124213*^9, 3.398218066955845*^9, 
   3.398218101938945*^9, 3.398218288835478*^9, 3.398218797942094*^9, {
   3.398219276426056*^9, 3.3982192773200197`*^9}, 3.398274345487751*^9, {
   3.398274422952874*^9, 3.39827443152566*^9}, {3.398274462831785*^9, 
   3.398274463356922*^9}, {3.398280194684251*^9, 3.3982802182809277`*^9}, {
   3.398280264094393*^9, 3.398280280448176*^9}, {3.398280346353464*^9, 
   3.398280353568131*^9}, {3.398280395931859*^9, 3.3982803975772667`*^9}, {
   3.398280439767231*^9, 3.398280468894752*^9}, {3.398280513052574*^9, 
   3.398280547214974*^9}, {3.398280633144449*^9, 3.398280641389388*^9}, {
   3.398280725727826*^9, 3.398280747780417*^9}, {3.398280828130582*^9, 
   3.3982808428056173`*^9}, 3.398282889810143*^9, {3.398302895340375*^9, 
   3.398302987456831*^9}, {3.3983030949394903`*^9, 3.398303301143669*^9}, {
   3.3983033356485777`*^9, 3.398303372169351*^9}, {3.3983039384758987`*^9, 
   3.398303941241437*^9}, {3.398305935487784*^9, 3.398305936031345*^9}, {
   3.398305980235219*^9, 3.398305982343878*^9}, {3.398306033085659*^9, 
   3.398306086831963*^9}, {3.398306505418228*^9, 3.39830651061595*^9}, {
   3.398306559435111*^9, 3.398306605216528*^9}, {3.398306971902431*^9, 
   3.398307006896096*^9}, {3.398307219077366*^9, 3.3983072222002773`*^9}, {
   3.3983073104452677`*^9, 3.398307326328216*^9}, {3.398334534147934*^9, 
   3.398334551953299*^9}, {3.398334614705542*^9, 3.398334677501299*^9}, {
   3.3983347128121643`*^9, 3.3983347144097977`*^9}, {3.3983347562687197`*^9, 
   3.398334792002239*^9}, {3.398335006509493*^9, 3.39833510905122*^9}, {
   3.3983354020295553`*^9, 3.39833540412598*^9}, {3.3983355986913958`*^9, 
   3.398335612579646*^9}, {3.398335831982689*^9, 3.398335835441819*^9}, 
   3.398336409903235*^9, 3.398339501967845*^9, {3.398430962281394*^9, 
   3.3984309682333107`*^9}, {3.398431065630109*^9, 3.398431154013885*^9}, {
   3.398431280539672*^9, 3.398431308983382*^9}, {3.398431346632725*^9, 
   3.3984314700698423`*^9}, {3.398431617665907*^9, 3.3984316184502773`*^9}, {
   3.398431654735305*^9, 3.398431700349416*^9}, {3.398431757089072*^9, 
   3.398431765423291*^9}, 3.398438297848133*^9, {3.39843834359746*^9, 
   3.398438344233643*^9}, {3.398438830223899*^9, 3.3984388316955214`*^9}, 
   3.398438882612156*^9, 3.4012212767123632`*^9}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`r$$ = 
    1.19, $CellContext`ShowGaussianSurface$$ = 
    False, $CellContext`\[Alpha]$$ = 1.5707963267948966`, Typeset`show$$ = 
    True, Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`ShowGaussianSurface$$], True, 
       "Show Gaussian Surface"}, {True, False}}, {{
       Hold[$CellContext`r$$], 0.3, 
       "Radius of Gaussian Surface, \!\(\*\nStyleBox[\"r\",\n\
FontSlant->\"Italic\"]\)"}, 0, 1.35}, {{
       Hold[$CellContext`\[Alpha]$$], Rational[1, 2] Pi, "Open/\nClose"}, 0, 
      Rational[1, 2] Pi}}, Typeset`size$$ = {577., {140., 161.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`ShowGaussianSurface$395$$ = 
    False, $CellContext`r$396$$ = 0, $CellContext`\[Alpha]$397$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`r$$ = 
        0.3, $CellContext`ShowGaussianSurface$$ = 
        True, $CellContext`\[Alpha]$$ = Rational[1, 2] Pi}, 
      "ControllerVariables" :> {
        Hold[$CellContext`ShowGaussianSurface$$, \
$CellContext`ShowGaussianSurface$395$$, False], 
        Hold[$CellContext`r$$, $CellContext`r$396$$, 0], 
        Hold[$CellContext`\[Alpha]$$, $CellContext`\[Alpha]$397$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> With[{$CellContext`Q$ = 1}, 
        With[{$CellContext`Qin$ = Function[$CellContext`r$, 
            
            Piecewise[{{
              0, $CellContext`r$ < 1}, {$CellContext`Q$, $CellContext`r$ >= 
               1}}]]}, 
         GraphicsRow[{
           Graphics3D[{{
              $CellContext`PartialSphere[1, $CellContext`\[Alpha]$$]}, 
             If[$CellContext`ShowGaussianSurface$$, {
               Opacity[0.3], Yellow, 
               Sphere[{0, 0, 0}, $CellContext`r$$]}, {}]}, SphericalRegion -> 
            True, PlotRange -> 1.35, Lighting -> "Neutral", Boxed -> False], 
           GraphicsColumn[{
             
             Plot[$CellContext`Qin$[$CellContext`r$$]/$CellContext`r$$^2, \
{$CellContext`r$$, 0, 1.35}, AxesLabel -> {"r", "E"}, Epilog -> {
                
                Point[{$CellContext`r$$, \
$CellContext`Qin$[$CellContext`r$$]/$CellContext`r$$^2}]}], 
             Plot[
              $CellContext`Qin$[$CellContext`r$$], {$CellContext`r$$, 0, 
               1.35}, AxesLabel -> {
               "r", "\!\(\*SubscriptBox[\(Q\), \(inside\)]\)"}, Epilog -> {
                Point[{$CellContext`r$$, 
                  $CellContext`Qin$[$CellContext`r$$]}]}]}]}]]], 
      "Specifications" :> {{{$CellContext`ShowGaussianSurface$$, True, 
          "Show Gaussian Surface"}, {
         True, False}}, {{$CellContext`r$$, 0.3, 
          "Radius of Gaussian Surface, \!\(\*\nStyleBox[\"r\",\n\
FontSlant->\"Italic\"]\)"}, 0, 
         1.35}, {{$CellContext`\[Alpha]$$, Rational[1, 2] Pi, "Open/\nClose"},
          0, Rational[1, 2] Pi, ControlType -> VerticalSlider}}, 
      "Options" :> {ControlPlacement -> {Top, Top, Left}}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{743., {271.6875, 282.3125}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{3.40122178560082*^9, 3.4012218746863832`*^9}]
}, {2}]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Uniform Solid Sphere", "Section",
 CellChangeTimes->{{3.398438527590519*^9, 3.39843854257592*^9}, {
  3.3984387576343946`*^9, 3.398438764394828*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", "=", "1.35"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"With", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Q", "=", "1"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Qin", "=", 
           RowBox[{"Function", "[", 
            RowBox[{"r", ",", 
             RowBox[{"Piecewise", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Q", " ", 
                   SuperscriptBox["r", "3"]}], ",", 
                  RowBox[{"r", "<", "1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"Q", ",", 
                  RowBox[{"r", "\[GreaterEqual]", "1"}]}], "}"}]}], "}"}], 
              "]"}]}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"GraphicsRow", "[", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Graphics3D", "[", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"PartialSolidSphere", "[", 
                  RowBox[{"1", ",", "\[Alpha]"}], "]"}], "}"}], ",", 
                RowBox[{"If", "[", 
                 RowBox[{"ShowGaussianSurface", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Opacity", "[", ".3", "]"}], ",", "Yellow", ",", 
                    RowBox[{"Sphere", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "r"}], 
                    "]"}]}], "}"}], ",", 
                  RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]", "}"}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"SphericalRegion", "\[Rule]", "True"}], ",", 
              RowBox[{"PlotRange", "\[Rule]", "a"}], ",", 
              RowBox[{"Lighting", "\[Rule]", "\"\<Neutral\>\""}], ",", 
              RowBox[{"Boxed", "\[Rule]", "False"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"GraphicsColumn", "[", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Plot", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Qin", "[", "r", "]"}], "/", 
                  SuperscriptBox["r", "2"]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"r", ",", "0", ",", "a"}], "}"}], ",", 
                 RowBox[{"AxesLabel", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"\"\<r\>\"", ",", "\"\<E\>\""}], "}"}]}], ",", 
                 RowBox[{"Epilog", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{"r", ",", 
                    RowBox[{
                    RowBox[{"Qin", "[", "r", "]"}], "/", 
                    SuperscriptBox["r", "2"]}]}], "}"}], "]"}], "}"}]}]}], 
                "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Plot", "[", 
                RowBox[{
                 RowBox[{"Qin", "[", "r", "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"r", ",", "0", ",", "a"}], "}"}], ",", 
                 RowBox[{"AxesLabel", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<r\>\"", ",", 
                    "\"\<\!\(\*SubscriptBox[\(Q\), \(inside\)]\)\>\""}], 
                   "}"}]}], ",", 
                 RowBox[{"Epilog", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{"r", ",", 
                    RowBox[{"Qin", "[", "r", "]"}]}], "}"}], "]"}], "}"}]}]}],
                 "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "ShowGaussianSurface", ",", "True", ",", 
         "\"\<Show Gaussian Surface\>\""}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", ",", ".3", ",", "\"\<Radius of Gaussian Surface, \!\(\*
StyleBox[\"r\",
FontSlant->\"Italic\"]\)\>\""}], "}"}], ",", "0", ",", "a"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Alpha]", ",", 
         RowBox[{"\[Pi]", "/", "2"}], ",", "\"\<Open/\\nClose\>\""}], "}"}], 
       ",", "0", ",", 
       RowBox[{"\[Pi]", "/", "2"}], ",", "VerticalSlider"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ControlPlacement", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Top", ",", "Top", ",", "Left"}], "}"}]}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.398189518843156*^9, 3.398189542328974*^9}, {
   3.398189703717575*^9, 3.398189707772398*^9}, {3.3981903999826603`*^9, 
   3.398190415155349*^9}, {3.3981906177277308`*^9, 3.398190618311503*^9}, {
   3.3981906970931187`*^9, 3.39819071841469*^9}, {3.398190796544886*^9, 
   3.39819084295564*^9}, {3.398190992236206*^9, 3.398190992949183*^9}, {
   3.3981912151864758`*^9, 3.3981912304031563`*^9}, 3.398191943166893*^9, {
   3.3981920407067623`*^9, 3.398192041154608*^9}, {3.398192224624048*^9, 
   3.398192246260215*^9}, {3.3981924232561083`*^9, 3.39819242383998*^9}, {
   3.3981924540690317`*^9, 3.398192458254427*^9}, {3.398193235867538*^9, 
   3.398193371371364*^9}, {3.398193402487297*^9, 3.3981934421094427`*^9}, {
   3.398193477651885*^9, 3.398193480011443*^9}, {3.398193526965308*^9, 
   3.398193529999423*^9}, {3.3981936281433487`*^9, 3.398193628714527*^9}, {
   3.398211458065336*^9, 3.398211474622287*^9}, {3.398211759958426*^9, 
   3.398211841603096*^9}, {3.398211932198592*^9, 3.39821199811235*^9}, {
   3.3982122498711042`*^9, 3.398212250439529*^9}, {3.3982122825200863`*^9, 
   3.3982122832305317`*^9}, {3.398212321751828*^9, 3.39821232243696*^9}, {
   3.3982136166901407`*^9, 3.398213618705285*^9}, {3.398213747994172*^9, 
   3.3982137700882807`*^9}, {3.398214014635215*^9, 3.39821408216568*^9}, {
   3.398214409975504*^9, 3.39821451400537*^9}, {3.3982145744984627`*^9, 
   3.398214601573984*^9}, {3.398215541496993*^9, 3.398215554806691*^9}, {
   3.398215593102791*^9, 3.398215612880127*^9}, {3.398215644528266*^9, 
   3.398215673168098*^9}, {3.3982157472252817`*^9, 3.3982157608722467`*^9}, {
   3.39821601089727*^9, 3.39821601352607*^9}, {3.398216065712262*^9, 
   3.398216246623929*^9}, {3.398216278263227*^9, 3.398216367156925*^9}, {
   3.3982164079789963`*^9, 3.398216422497486*^9}, {3.398216454314692*^9, 
   3.398216455392363*^9}, 3.398218036124213*^9, 3.398218066955845*^9, 
   3.398218101938945*^9, 3.398218288835478*^9, 3.398218797942094*^9, {
   3.398219276426056*^9, 3.3982192773200197`*^9}, 3.398274345487751*^9, {
   3.398274422952874*^9, 3.39827443152566*^9}, {3.398274462831785*^9, 
   3.398274463356922*^9}, {3.398280194684251*^9, 3.3982802182809277`*^9}, {
   3.398280264094393*^9, 3.398280280448176*^9}, {3.398280346353464*^9, 
   3.398280353568131*^9}, {3.398280395931859*^9, 3.3982803975772667`*^9}, {
   3.398280439767231*^9, 3.398280468894752*^9}, {3.398280513052574*^9, 
   3.398280547214974*^9}, {3.398280633144449*^9, 3.398280641389388*^9}, {
   3.398280725727826*^9, 3.398280747780417*^9}, {3.398280828130582*^9, 
   3.3982808428056173`*^9}, 3.398282889810143*^9, {3.398302895340375*^9, 
   3.398302987456831*^9}, {3.3983030949394903`*^9, 3.398303301143669*^9}, {
   3.3983033356485777`*^9, 3.398303372169351*^9}, {3.3983039384758987`*^9, 
   3.398303941241437*^9}, {3.398305935487784*^9, 3.398305936031345*^9}, {
   3.398305980235219*^9, 3.398305982343878*^9}, {3.398306033085659*^9, 
   3.398306086831963*^9}, {3.398306505418228*^9, 3.39830651061595*^9}, {
   3.398306559435111*^9, 3.398306605216528*^9}, {3.398306971902431*^9, 
   3.398307006896096*^9}, {3.398307219077366*^9, 3.3983072222002773`*^9}, {
   3.3983073104452677`*^9, 3.398307326328216*^9}, {3.398334534147934*^9, 
   3.398334551953299*^9}, {3.398334614705542*^9, 3.398334677501299*^9}, {
   3.3983347128121643`*^9, 3.3983347144097977`*^9}, {3.3983347562687197`*^9, 
   3.398334792002239*^9}, {3.398335006509493*^9, 3.39833510905122*^9}, {
   3.3983354020295553`*^9, 3.39833540412598*^9}, {3.3983355986913958`*^9, 
   3.398335612579646*^9}, {3.398335831982689*^9, 3.398335835441819*^9}, 
   3.398336409903235*^9, 3.398339501967845*^9, {3.398430962281394*^9, 
   3.3984309682333107`*^9}, {3.398431065630109*^9, 3.398431154013885*^9}, {
   3.398431280539672*^9, 3.398431308983382*^9}, {3.398431346632725*^9, 
   3.3984314700698423`*^9}, {3.398431617665907*^9, 3.3984316184502773`*^9}, {
   3.398431654735305*^9, 3.398431700349416*^9}, {3.398431757089072*^9, 
   3.398431765423291*^9}, 3.398438297848133*^9, {3.39843834359746*^9, 
   3.398438344233643*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`r$$ = 
    0.438, $CellContext`ShowGaussianSurface$$ = 
    True, $CellContext`\[Alpha]$$ = 1.5707963267948966`, Typeset`show$$ = 
    True, Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`ShowGaussianSurface$$], True, 
       "Show Gaussian Surface"}, {True, False}}, {{
       Hold[$CellContext`r$$], 0.3, 
       "Radius of Gaussian Surface, \!\(\*\nStyleBox[\"r\",\n\
FontSlant->\"Italic\"]\)"}, 0, 1.35}, {{
       Hold[$CellContext`\[Alpha]$$], Rational[1, 2] Pi, "Open/\nClose"}, 0, 
      Rational[1, 2] Pi}}, Typeset`size$$ = {577., {140., 161.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`ShowGaussianSurface$1944$$ = 
    False, $CellContext`r$1945$$ = 0, $CellContext`\[Alpha]$1946$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`r$$ = 
        0.3, $CellContext`ShowGaussianSurface$$ = 
        True, $CellContext`\[Alpha]$$ = Rational[1, 2] Pi}, 
      "ControllerVariables" :> {
        Hold[$CellContext`ShowGaussianSurface$$, \
$CellContext`ShowGaussianSurface$1944$$, False], 
        Hold[$CellContext`r$$, $CellContext`r$1945$$, 0], 
        Hold[$CellContext`\[Alpha]$$, $CellContext`\[Alpha]$1946$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> With[{$CellContext`Q$ = 1}, 
        With[{$CellContext`Qin$ = Function[$CellContext`r$, 
            
            Piecewise[{{$CellContext`Q$ $CellContext`r$^3, $CellContext`r$ < 
               1}, {$CellContext`Q$, $CellContext`r$ >= 1}}]]}, 
         GraphicsRow[{
           Graphics3D[{{
              $CellContext`PartialSolidSphere[1, $CellContext`\[Alpha]$$]}, 
             If[$CellContext`ShowGaussianSurface$$, {
               Opacity[0.3], Yellow, 
               Sphere[{0, 0, 0}, $CellContext`r$$]}, {}]}, SphericalRegion -> 
            True, PlotRange -> 1.35, Lighting -> "Neutral", Boxed -> False], 
           GraphicsColumn[{
             
             Plot[$CellContext`Qin$[$CellContext`r$$]/$CellContext`r$$^2, \
{$CellContext`r$$, 0, 1.35}, AxesLabel -> {"r", "E"}, Epilog -> {
                
                Point[{$CellContext`r$$, \
$CellContext`Qin$[$CellContext`r$$]/$CellContext`r$$^2}]}], 
             Plot[
              $CellContext`Qin$[$CellContext`r$$], {$CellContext`r$$, 0, 
               1.35}, AxesLabel -> {
               "r", "\!\(\*SubscriptBox[\(Q\), \(inside\)]\)"}, Epilog -> {
                Point[{$CellContext`r$$, 
                  $CellContext`Qin$[$CellContext`r$$]}]}]}]}]]], 
      "Specifications" :> {{{$CellContext`ShowGaussianSurface$$, True, 
          "Show Gaussian Surface"}, {
         True, False}}, {{$CellContext`r$$, 0.3, 
          "Radius of Gaussian Surface, \!\(\*\nStyleBox[\"r\",\n\
FontSlant->\"Italic\"]\)"}, 0, 
         1.35}, {{$CellContext`\[Alpha]$$, Rational[1, 2] Pi, "Open/\nClose"},
          0, Rational[1, 2] Pi, ControlType -> VerticalSlider}}, 
      "Options" :> {ControlPlacement -> {Top, Top, Left}}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{743., {271.6875, 282.3125}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{3.401222018133832*^9}]
}, {2}]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Hollow Sphere", "Section",
 CellChangeTimes->{{3.398438527590519*^9, 3.398438575189782*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "=", "1.35"}], ",", 
     RowBox[{"R1", "=", ".6"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"With", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Q", "=", "1"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Qin", "=", 
           RowBox[{"Function", "[", 
            RowBox[{"r", ",", 
             RowBox[{"Piecewise", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"r", "\[LessEqual]", "R1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Q", " ", 
                   FractionBox[
                    RowBox[{
                    SuperscriptBox["r", "3"], "-", 
                    SuperscriptBox["R1", "3"]}], 
                    RowBox[{"1", "-", 
                    SuperscriptBox["R1", "3"]}]]}], ",", 
                  RowBox[{"R1", "<", "r", "<", "1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"Q", ",", 
                  RowBox[{"r", "\[GreaterEqual]", "1"}]}], "}"}]}], "}"}], 
              "]"}]}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"GraphicsRow", "[", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Graphics3D", "[", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"PartialSolidSphere", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{".6", ",", "1"}], "}"}], ",", "\[Alpha]"}], "]"}],
                  "}"}], ",", 
                RowBox[{"If", "[", 
                 RowBox[{"ShowGaussianSurface", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Opacity", "[", ".3", "]"}], ",", "Yellow", ",", 
                    RowBox[{"Sphere", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "r"}], 
                    "]"}]}], "}"}], ",", 
                  RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]", "}"}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"SphericalRegion", "\[Rule]", "True"}], ",", 
              RowBox[{"PlotRange", "\[Rule]", "a"}], ",", 
              RowBox[{"Lighting", "\[Rule]", "\"\<Neutral\>\""}], ",", 
              RowBox[{"Boxed", "\[Rule]", "False"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"GraphicsColumn", "[", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Plot", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Qin", "[", "r", "]"}], "/", 
                  SuperscriptBox["r", "2"]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"r", ",", "0", ",", "a"}], "}"}], ",", 
                 RowBox[{"AxesLabel", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"\"\<r\>\"", ",", "\"\<E\>\""}], "}"}]}], ",", 
                 RowBox[{"Epilog", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{"r", ",", 
                    RowBox[{
                    RowBox[{"Qin", "[", "r", "]"}], "/", 
                    SuperscriptBox["r", "2"]}]}], "}"}], "]"}], "}"}]}]}], 
                "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Plot", "[", 
                RowBox[{
                 RowBox[{"Qin", "[", "r", "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"r", ",", "0", ",", "a"}], "}"}], ",", 
                 RowBox[{"AxesLabel", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<r\>\"", ",", 
                    "\"\<\!\(\*SubscriptBox[\(Q\), \(inside\)]\)\>\""}], 
                   "}"}]}], ",", 
                 RowBox[{"Epilog", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{"r", ",", 
                    RowBox[{"Qin", "[", "r", "]"}]}], "}"}], "]"}], "}"}]}]}],
                 "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "ShowGaussianSurface", ",", "True", ",", 
         "\"\<Show Gaussian Surface\>\""}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", ",", ".3", ",", "\"\<Radius of Gaussian Surface, \!\(\*
StyleBox[\"r\",
FontSlant->\"Italic\"]\)\>\""}], "}"}], ",", "0.001", ",", "a"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Alpha]", ",", 
         RowBox[{"\[Pi]", "/", "2"}], ",", "\"\<Open/\\nClose\>\""}], "}"}], 
       ",", "0", ",", 
       RowBox[{"\[Pi]", "/", "2"}], ",", "VerticalSlider"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ControlPlacement", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Top", ",", "Top", ",", "Left"}], "}"}]}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.398189518843156*^9, 3.398189542328974*^9}, {
   3.398189703717575*^9, 3.398189707772398*^9}, {3.3981903999826603`*^9, 
   3.398190415155349*^9}, {3.3981906177277308`*^9, 3.398190618311503*^9}, {
   3.3981906970931187`*^9, 3.39819071841469*^9}, {3.398190796544886*^9, 
   3.39819084295564*^9}, {3.398190992236206*^9, 3.398190992949183*^9}, {
   3.3981912151864758`*^9, 3.3981912304031563`*^9}, 3.398191943166893*^9, {
   3.3981920407067623`*^9, 3.398192041154608*^9}, {3.398192224624048*^9, 
   3.398192246260215*^9}, {3.3981924232561083`*^9, 3.39819242383998*^9}, {
   3.3981924540690317`*^9, 3.398192458254427*^9}, {3.398193235867538*^9, 
   3.398193371371364*^9}, {3.398193402487297*^9, 3.3981934421094427`*^9}, {
   3.398193477651885*^9, 3.398193480011443*^9}, {3.398193526965308*^9, 
   3.398193529999423*^9}, {3.3981936281433487`*^9, 3.398193628714527*^9}, {
   3.398211458065336*^9, 3.398211474622287*^9}, {3.398211759958426*^9, 
   3.398211841603096*^9}, {3.398211932198592*^9, 3.39821199811235*^9}, {
   3.3982122498711042`*^9, 3.398212250439529*^9}, {3.3982122825200863`*^9, 
   3.3982122832305317`*^9}, {3.398212321751828*^9, 3.39821232243696*^9}, {
   3.3982136166901407`*^9, 3.398213618705285*^9}, {3.398213747994172*^9, 
   3.3982137700882807`*^9}, {3.398214014635215*^9, 3.39821408216568*^9}, {
   3.398214409975504*^9, 3.39821451400537*^9}, {3.3982145744984627`*^9, 
   3.398214601573984*^9}, {3.398215541496993*^9, 3.398215554806691*^9}, {
   3.398215593102791*^9, 3.398215612880127*^9}, {3.398215644528266*^9, 
   3.398215673168098*^9}, {3.3982157472252817`*^9, 3.3982157608722467`*^9}, {
   3.39821601089727*^9, 3.39821601352607*^9}, {3.398216065712262*^9, 
   3.398216246623929*^9}, {3.398216278263227*^9, 3.398216367156925*^9}, {
   3.3982164079789963`*^9, 3.398216422497486*^9}, {3.398216454314692*^9, 
   3.398216455392363*^9}, 3.398218036124213*^9, 3.398218066955845*^9, 
   3.398218101938945*^9, 3.398218288835478*^9, 3.398218797942094*^9, {
   3.398219276426056*^9, 3.3982192773200197`*^9}, 3.398274345487751*^9, {
   3.398274422952874*^9, 3.39827443152566*^9}, {3.398274462831785*^9, 
   3.398274463356922*^9}, {3.398280194684251*^9, 3.3982802182809277`*^9}, {
   3.398280264094393*^9, 3.398280280448176*^9}, {3.398280346353464*^9, 
   3.398280353568131*^9}, {3.398280395931859*^9, 3.3982803975772667`*^9}, {
   3.398280439767231*^9, 3.398280468894752*^9}, {3.398280513052574*^9, 
   3.398280547214974*^9}, {3.398280633144449*^9, 3.398280641389388*^9}, {
   3.398280725727826*^9, 3.398280747780417*^9}, {3.398280828130582*^9, 
   3.3982808428056173`*^9}, 3.398282889810143*^9, {3.398302895340375*^9, 
   3.398302987456831*^9}, {3.3983030949394903`*^9, 3.398303301143669*^9}, {
   3.3983033356485777`*^9, 3.398303372169351*^9}, {3.3983039384758987`*^9, 
   3.398303941241437*^9}, {3.398305935487784*^9, 3.398305936031345*^9}, {
   3.398305980235219*^9, 3.398305982343878*^9}, {3.398306033085659*^9, 
   3.398306086831963*^9}, {3.398306505418228*^9, 3.39830651061595*^9}, {
   3.398306559435111*^9, 3.398306605216528*^9}, {3.398306971902431*^9, 
   3.398307006896096*^9}, {3.398307219077366*^9, 3.3983072222002773`*^9}, {
   3.3983073104452677`*^9, 3.398307326328216*^9}, {3.398334534147934*^9, 
   3.398334551953299*^9}, {3.398334614705542*^9, 3.398334677501299*^9}, {
   3.3983347128121643`*^9, 3.3983347144097977`*^9}, {3.3983347562687197`*^9, 
   3.398334792002239*^9}, {3.398335006509493*^9, 3.39833510905122*^9}, {
   3.3983354020295553`*^9, 3.39833540412598*^9}, {3.3983355986913958`*^9, 
   3.398335612579646*^9}, {3.398335831982689*^9, 3.398335835441819*^9}, 
   3.398336409903235*^9, 3.398339501967845*^9, {3.398430962281394*^9, 
   3.3984309682333107`*^9}, {3.398431065630109*^9, 3.398431154013885*^9}, {
   3.398431280539672*^9, 3.398431308983382*^9}, {3.398431346632725*^9, 
   3.3984314700698423`*^9}, {3.398431617665907*^9, 3.3984316184502773`*^9}, {
   3.398431654735305*^9, 3.398431700349416*^9}, {3.398431757089072*^9, 
   3.398431765423291*^9}, 3.398438297848133*^9, {3.39843834359746*^9, 
   3.398438344233643*^9}, {3.3984389985287447`*^9, 3.3984391523068113`*^9}, {
   3.3984392009449787`*^9, 3.398439202547041*^9}, 3.3984399658373623`*^9}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`r$$ = 
    0.3, $CellContext`ShowGaussianSurface$$ = False, $CellContext`\[Alpha]$$ =
     1.5707963267948966`, Typeset`show$$ = True, Typeset`bookmarkList$$ = {}, 
    Typeset`bookmarkMode$$ = "Menu", Typeset`animator$$, Typeset`animvar$$ = 
    1, Typeset`name$$ = "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`ShowGaussianSurface$$], True, 
       "Show Gaussian Surface"}, {True, False}}, {{
       Hold[$CellContext`r$$], 0.3, 
       "Radius of Gaussian Surface, \!\(\*\nStyleBox[\"r\",\n\
FontSlant->\"Italic\"]\)"}, 0.001, 1.35}, {{
       Hold[$CellContext`\[Alpha]$$], Rational[1, 2] Pi, "Open/\nClose"}, 0, 
      Rational[1, 2] Pi}}, Typeset`size$$ = {577., {140., 161.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`ShowGaussianSurface$2148$$ = 
    False, $CellContext`r$2149$$ = 0, $CellContext`\[Alpha]$2150$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`r$$ = 
        0.3, $CellContext`ShowGaussianSurface$$ = 
        True, $CellContext`\[Alpha]$$ = Rational[1, 2] Pi}, 
      "ControllerVariables" :> {
        Hold[$CellContext`ShowGaussianSurface$$, \
$CellContext`ShowGaussianSurface$2148$$, False], 
        Hold[$CellContext`r$$, $CellContext`r$2149$$, 0], 
        Hold[$CellContext`\[Alpha]$$, $CellContext`\[Alpha]$2150$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> With[{$CellContext`Q$ = 1}, 
        With[{$CellContext`Qin$ = Function[$CellContext`r$, 
            
            Piecewise[{{
              0, $CellContext`r$ <= 
               0.6}, {$CellContext`Q$ (($CellContext`r$^3 - 0.6^3)/(1 - 
                0.6^3)), 0.6 < $CellContext`r$ < 
               1}, {$CellContext`Q$, $CellContext`r$ >= 1}}]]}, 
         GraphicsRow[{
           Graphics3D[{{
              $CellContext`PartialSolidSphere[{
               0.6, 1}, $CellContext`\[Alpha]$$]}, 
             If[$CellContext`ShowGaussianSurface$$, {
               Opacity[0.3], Yellow, 
               Sphere[{0, 0, 0}, $CellContext`r$$]}, {}]}, SphericalRegion -> 
            True, PlotRange -> 1.35, Lighting -> "Neutral", Boxed -> False], 
           GraphicsColumn[{
             
             Plot[$CellContext`Qin$[$CellContext`r$$]/$CellContext`r$$^2, \
{$CellContext`r$$, 0, 1.35}, AxesLabel -> {"r", "E"}, Epilog -> {
                
                Point[{$CellContext`r$$, \
$CellContext`Qin$[$CellContext`r$$]/$CellContext`r$$^2}]}], 
             Plot[
              $CellContext`Qin$[$CellContext`r$$], {$CellContext`r$$, 0, 
               1.35}, AxesLabel -> {
               "r", "\!\(\*SubscriptBox[\(Q\), \(inside\)]\)"}, Epilog -> {
                Point[{$CellContext`r$$, 
                  $CellContext`Qin$[$CellContext`r$$]}]}]}]}]]], 
      "Specifications" :> {{{$CellContext`ShowGaussianSurface$$, True, 
          "Show Gaussian Surface"}, {
         True, False}}, {{$CellContext`r$$, 0.3, 
          "Radius of Gaussian Surface, \!\(\*\nStyleBox[\"r\",\n\
FontSlant->\"Italic\"]\)"}, 0.001, 
         1.35}, {{$CellContext`\[Alpha]$$, Rational[1, 2] Pi, "Open/\nClose"},
          0, Rational[1, 2] Pi, ControlType -> VerticalSlider}}, 
      "Options" :> {ControlPlacement -> {Top, Top, Left}}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{743., {271.6875, 282.3125}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{3.401222038427802*^9}]
}, {2}]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Infinite Uniform Cylindrical Shell", "Section",
 CellChangeTimes->{{3.398438527590519*^9, 3.39843854257592*^9}, {
  3.3984392727511597`*^9, 3.398439281598071*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "=", "1.35"}], ",", 
     RowBox[{"L", "=", "10"}], ",", 
     RowBox[{"LG", "=", "2"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"With", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Q", "=", "1"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\[Lambda]in", "=", 
           RowBox[{"Function", "[", 
            RowBox[{"r", ",", 
             RowBox[{"Piecewise", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"r", "<", "1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"Q", ",", 
                  RowBox[{"r", "\[GreaterEqual]", "1"}]}], "}"}]}], "}"}], 
              "]"}]}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"GraphicsRow", "[", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Graphics3D", "[", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"PartialCylinder", "[", 
                  RowBox[{"1", ",", "L", ",", "\[Alpha]"}], "]"}], "}"}], ",",
                 
                RowBox[{"If", "[", 
                 RowBox[{"ShowGaussianSurface", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Opacity", "[", ".3", "]"}], ",", "Yellow", ",", 
                    RowBox[{"Cylinder", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "LG"}], "/", "2"}], ",", "0", ",", "0"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"LG", "/", "2"}], ",", "0", ",", "0"}], "}"}]}], 
                    "}"}], ",", "r"}], "]"}]}], "}"}], ",", 
                  RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]", "}"}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"SphericalRegion", "\[Rule]", "True"}], ",", 
              RowBox[{"Lighting", "\[Rule]", "\"\<Neutral\>\""}], ",", 
              RowBox[{"Boxed", "\[Rule]", "False"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"GraphicsColumn", "[", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Plot", "[", 
                RowBox[{
                 RowBox[{"2", " ", 
                  RowBox[{
                   RowBox[{"\[Lambda]in", "[", "r", "]"}], "/", "r"}]}], ",", 
                 
                 RowBox[{"{", 
                  RowBox[{"r", ",", "0", ",", "a"}], "}"}], ",", 
                 RowBox[{"AxesLabel", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"\"\<r\>\"", ",", "\"\<E\>\""}], "}"}]}], ",", 
                 RowBox[{"Epilog", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{"r", ",", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    RowBox[{"\[Lambda]in", "[", "r", "]"}], "/", "r"}]}]}], 
                    "}"}], "]"}], "}"}]}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Plot", "[", 
                RowBox[{
                 RowBox[{"\[Lambda]in", "[", "r", "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"r", ",", "0", ",", "a"}], "}"}], ",", 
                 RowBox[{"AxesLabel", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<r\>\"", ",", 
                    "\"\<\!\(\*SubscriptBox[\(Q\), \(inside\)]\)/\[ScriptL]\>\
\""}], "}"}]}], ",", 
                 RowBox[{"Epilog", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{"r", ",", 
                    RowBox[{"\[Lambda]in", "[", "r", "]"}]}], "}"}], "]"}], 
                   "}"}]}]}], "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "ShowGaussianSurface", ",", "True", ",", 
         "\"\<Show Gaussian Surface\>\""}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", ",", ".3", ",", "\"\<Radius of Gaussian Surface, \!\(\*
StyleBox[\"r\",
FontSlant->\"Italic\"]\)\>\""}], "}"}], ",", "0.001", ",", "a"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Alpha]", ",", 
         RowBox[{"\[Pi]", "/", "2"}], ",", "\"\<Open/\\nClose\>\""}], "}"}], 
       ",", "0", ",", 
       RowBox[{"\[Pi]", "/", "2"}], ",", "VerticalSlider"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ControlPlacement", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Top", ",", "Top", ",", "Left"}], "}"}]}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.398189518843156*^9, 3.398189542328974*^9}, {
   3.398189703717575*^9, 3.398189707772398*^9}, {3.3981903999826603`*^9, 
   3.398190415155349*^9}, {3.3981906177277308`*^9, 3.398190618311503*^9}, {
   3.3981906970931187`*^9, 3.39819071841469*^9}, {3.398190796544886*^9, 
   3.39819084295564*^9}, {3.398190992236206*^9, 3.398190992949183*^9}, {
   3.3981912151864758`*^9, 3.3981912304031563`*^9}, 3.398191943166893*^9, {
   3.3981920407067623`*^9, 3.398192041154608*^9}, {3.398192224624048*^9, 
   3.398192246260215*^9}, {3.3981924232561083`*^9, 3.39819242383998*^9}, {
   3.3981924540690317`*^9, 3.398192458254427*^9}, {3.398193235867538*^9, 
   3.398193371371364*^9}, {3.398193402487297*^9, 3.3981934421094427`*^9}, {
   3.398193477651885*^9, 3.398193480011443*^9}, {3.398193526965308*^9, 
   3.398193529999423*^9}, {3.3981936281433487`*^9, 3.398193628714527*^9}, {
   3.398211458065336*^9, 3.398211474622287*^9}, {3.398211759958426*^9, 
   3.398211841603096*^9}, {3.398211932198592*^9, 3.39821199811235*^9}, {
   3.3982122498711042`*^9, 3.398212250439529*^9}, {3.3982122825200863`*^9, 
   3.3982122832305317`*^9}, {3.398212321751828*^9, 3.39821232243696*^9}, {
   3.3982136166901407`*^9, 3.398213618705285*^9}, {3.398213747994172*^9, 
   3.3982137700882807`*^9}, {3.398214014635215*^9, 3.39821408216568*^9}, {
   3.398214409975504*^9, 3.39821451400537*^9}, {3.3982145744984627`*^9, 
   3.398214601573984*^9}, {3.398215541496993*^9, 3.398215554806691*^9}, {
   3.398215593102791*^9, 3.398215612880127*^9}, {3.398215644528266*^9, 
   3.398215673168098*^9}, {3.3982157472252817`*^9, 3.3982157608722467`*^9}, {
   3.39821601089727*^9, 3.39821601352607*^9}, {3.398216065712262*^9, 
   3.398216246623929*^9}, {3.398216278263227*^9, 3.398216367156925*^9}, {
   3.3982164079789963`*^9, 3.398216422497486*^9}, {3.398216454314692*^9, 
   3.398216455392363*^9}, 3.398218036124213*^9, 3.398218066955845*^9, 
   3.398218101938945*^9, 3.398218288835478*^9, 3.398218797942094*^9, {
   3.398219276426056*^9, 3.3982192773200197`*^9}, 3.398274345487751*^9, {
   3.398274422952874*^9, 3.39827443152566*^9}, {3.398274462831785*^9, 
   3.398274463356922*^9}, {3.398280194684251*^9, 3.3982802182809277`*^9}, {
   3.398280264094393*^9, 3.398280280448176*^9}, {3.398280346353464*^9, 
   3.398280353568131*^9}, {3.398280395931859*^9, 3.3982803975772667`*^9}, {
   3.398280439767231*^9, 3.398280468894752*^9}, {3.398280513052574*^9, 
   3.398280547214974*^9}, {3.398280633144449*^9, 3.398280641389388*^9}, {
   3.398280725727826*^9, 3.398280747780417*^9}, {3.398280828130582*^9, 
   3.3982808428056173`*^9}, 3.398282889810143*^9, {3.398302895340375*^9, 
   3.398302987456831*^9}, {3.3983030949394903`*^9, 3.398303301143669*^9}, {
   3.3983033356485777`*^9, 3.398303372169351*^9}, {3.3983039384758987`*^9, 
   3.398303941241437*^9}, {3.398305935487784*^9, 3.398305936031345*^9}, {
   3.398305980235219*^9, 3.398305982343878*^9}, {3.398306033085659*^9, 
   3.398306086831963*^9}, {3.398306505418228*^9, 3.39830651061595*^9}, {
   3.398306559435111*^9, 3.398306605216528*^9}, {3.398306971902431*^9, 
   3.398307006896096*^9}, {3.398307219077366*^9, 3.3983072222002773`*^9}, {
   3.3983073104452677`*^9, 3.398307326328216*^9}, {3.398334534147934*^9, 
   3.398334551953299*^9}, {3.398334614705542*^9, 3.398334677501299*^9}, {
   3.3983347128121643`*^9, 3.3983347144097977`*^9}, {3.3983347562687197`*^9, 
   3.398334792002239*^9}, {3.398335006509493*^9, 3.39833510905122*^9}, {
   3.3983354020295553`*^9, 3.39833540412598*^9}, {3.3983355986913958`*^9, 
   3.398335612579646*^9}, {3.398335831982689*^9, 3.398335835441819*^9}, 
   3.398336409903235*^9, 3.398339501967845*^9, {3.398430962281394*^9, 
   3.3984309682333107`*^9}, {3.398431065630109*^9, 3.398431154013885*^9}, {
   3.398431280539672*^9, 3.398431308983382*^9}, {3.398431346632725*^9, 
   3.3984314700698423`*^9}, {3.398431617665907*^9, 3.3984316184502773`*^9}, {
   3.398431654735305*^9, 3.398431700349416*^9}, {3.398431757089072*^9, 
   3.398431765423291*^9}, 3.398438297848133*^9, {3.39843834359746*^9, 
   3.398438344233643*^9}, {3.398438830223899*^9, 3.3984388316955214`*^9}, 
   3.398438882612156*^9, {3.398439289984541*^9, 3.39843934340968*^9}, {
   3.398439381019589*^9, 3.398439399824788*^9}, 3.398439432763167*^9, {
   3.398439496843636*^9, 3.398439500939981*^9}, {3.398439655133318*^9, 
   3.398439660782428*^9}, {3.398439717973565*^9, 3.3984397590585127`*^9}, {
   3.398439807151003*^9, 3.39843995817535*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`r$$ = 
    0.3, $CellContext`ShowGaussianSurface$$ = True, $CellContext`\[Alpha]$$ = 
    Rational[1, 2] Pi, Typeset`show$$ = True, Typeset`bookmarkList$$ = {}, 
    Typeset`bookmarkMode$$ = "Menu", Typeset`animator$$, Typeset`animvar$$ = 
    1, Typeset`name$$ = "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`ShowGaussianSurface$$], True, 
       "Show Gaussian Surface"}, {True, False}}, {{
       Hold[$CellContext`r$$], 0.3, 
       "Radius of Gaussian Surface, \!\(\*\nStyleBox[\"r\",\n\
FontSlant->\"Italic\"]\)"}, 0.001, 1.35}, {{
       Hold[$CellContext`\[Alpha]$$], Rational[1, 2] Pi, "Open/\nClose"}, 0, 
      Rational[1, 2] Pi}}, Typeset`size$$ = {577., {140., 161.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`ShowGaussianSurface$2406$$ = 
    False, $CellContext`r$2407$$ = 0, $CellContext`\[Alpha]$2408$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`r$$ = 
        0.3, $CellContext`ShowGaussianSurface$$ = 
        True, $CellContext`\[Alpha]$$ = Rational[1, 2] Pi}, 
      "ControllerVariables" :> {
        Hold[$CellContext`ShowGaussianSurface$$, \
$CellContext`ShowGaussianSurface$2406$$, False], 
        Hold[$CellContext`r$$, $CellContext`r$2407$$, 0], 
        Hold[$CellContext`\[Alpha]$$, $CellContext`\[Alpha]$2408$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> With[{$CellContext`Q$ = 1}, 
        With[{$CellContext`\[Lambda]in$ = Function[$CellContext`r$, 
            
            Piecewise[{{
              0, $CellContext`r$ < 1}, {$CellContext`Q$, $CellContext`r$ >= 
               1}}]]}, 
         GraphicsRow[{
           Graphics3D[{{
              $CellContext`PartialCylinder[1, 10, $CellContext`\[Alpha]$$]}, 
             If[$CellContext`ShowGaussianSurface$$, {
               Opacity[0.3], Yellow, 
               
               Cylinder[{{(-2)/2, 0, 0}, {
                 2/2, 0, 0}}, $CellContext`r$$]}, {}]}, SphericalRegion -> 
            True, Lighting -> "Neutral", Boxed -> False], 
           GraphicsColumn[{
             Plot[
             2 ($CellContext`\[Lambda]in$[$CellContext`r$$]/$CellContext`r$$),\
 {$CellContext`r$$, 0, 1.35}, AxesLabel -> {"r", "E"}, Epilog -> {
                
                Point[{$CellContext`r$$, 
                  2 ($CellContext`\[Lambda]in$[$CellContext`r$$]/$CellContext`\
r$$)}]}], 
             Plot[
              $CellContext`\[Lambda]in$[$CellContext`r$$], {$CellContext`r$$, 
               0, 1.35}, 
              AxesLabel -> {
               "r", "\!\(\*SubscriptBox[\(Q\), \(inside\)]\)/\[ScriptL]"}, 
              Epilog -> {
                Point[{$CellContext`r$$, 
                  $CellContext`\[Lambda]in$[$CellContext`r$$]}]}]}]}]]], 
      "Specifications" :> {{{$CellContext`ShowGaussianSurface$$, True, 
          "Show Gaussian Surface"}, {
         True, False}}, {{$CellContext`r$$, 0.3, 
          "Radius of Gaussian Surface, \!\(\*\nStyleBox[\"r\",\n\
FontSlant->\"Italic\"]\)"}, 0.001, 
         1.35}, {{$CellContext`\[Alpha]$$, Rational[1, 2] Pi, "Open/\nClose"},
          0, Rational[1, 2] Pi, ControlType -> VerticalSlider}}, 
      "Options" :> {ControlPlacement -> {Top, Top, Left}}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{743., {271.6875, 282.3125}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{3.401222068501812*^9}]
}, {2}]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Infinite Uniform Cylindrical Shell", "Section",
 CellChangeTimes->{{3.398438527590519*^9, 3.39843854257592*^9}, {
  3.3984392727511597`*^9, 3.398439281598071*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "=", "1.35"}], ",", 
     RowBox[{"L", "=", "10"}], ",", 
     RowBox[{"LG", "=", "2"}], ",", 
     RowBox[{"\[Lambda]0", "=", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"With", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Q", "=", "1"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\[Lambda]in", "=", 
           RowBox[{"Function", "[", 
            RowBox[{"r", ",", 
             RowBox[{"Piecewise", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"\[Lambda]0", " ", 
                   SuperscriptBox["r", "2"]}], ",", 
                  RowBox[{"r", "<", "1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Lambda]0", ",", 
                  RowBox[{"r", "\[GreaterEqual]", "1"}]}], "}"}]}], "}"}], 
              "]"}]}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"GraphicsRow", "[", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Graphics3D", "[", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"PartialSolidCylinder", "[", 
                  RowBox[{"1", ",", "L", ",", "\[Alpha]"}], "]"}], "}"}], ",",
                 
                RowBox[{"If", "[", 
                 RowBox[{"ShowGaussianSurface", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Opacity", "[", ".3", "]"}], ",", "Yellow", ",", 
                    RowBox[{"Cylinder", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "LG"}], "/", "2"}], ",", "0", ",", "0"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"LG", "/", "2"}], ",", "0", ",", "0"}], "}"}]}], 
                    "}"}], ",", "r"}], "]"}]}], "}"}], ",", 
                  RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]", "}"}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"SphericalRegion", "\[Rule]", "True"}], ",", 
              RowBox[{"Lighting", "\[Rule]", "\"\<Neutral\>\""}], ",", 
              RowBox[{"Boxed", "\[Rule]", "False"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"GraphicsColumn", "[", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Plot", "[", 
                RowBox[{
                 RowBox[{"2", " ", 
                  RowBox[{
                   RowBox[{"\[Lambda]in", "[", "r", "]"}], "/", "r"}]}], ",", 
                 
                 RowBox[{"{", 
                  RowBox[{"r", ",", "0", ",", "a"}], "}"}], ",", 
                 RowBox[{"AxesLabel", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"\"\<r\>\"", ",", "\"\<E\>\""}], "}"}]}], ",", 
                 RowBox[{"Epilog", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{"r", ",", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    RowBox[{"\[Lambda]in", "[", "r", "]"}], "/", "r"}]}]}], 
                    "}"}], "]"}], "}"}]}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Plot", "[", 
                RowBox[{
                 RowBox[{"\[Lambda]in", "[", "r", "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"r", ",", "0", ",", "a"}], "}"}], ",", 
                 RowBox[{"AxesLabel", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<r\>\"", ",", 
                    "\"\<\!\(\*SubscriptBox[\(Q\), \(inside\)]\)/\[ScriptL]\>\
\""}], "}"}]}], ",", 
                 RowBox[{"Epilog", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{"r", ",", 
                    RowBox[{"\[Lambda]in", "[", "r", "]"}]}], "}"}], "]"}], 
                   "}"}]}]}], "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "ShowGaussianSurface", ",", "True", ",", 
         "\"\<Show Gaussian Surface\>\""}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", ",", ".3", ",", "\"\<Radius of Gaussian Surface, \!\(\*
StyleBox[\"r\",
FontSlant->\"Italic\"]\)\>\""}], "}"}], ",", "0.001", ",", "a"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Alpha]", ",", 
         RowBox[{"\[Pi]", "/", "2"}], ",", "\"\<Open/\\nClose\>\""}], "}"}], 
       ",", "0", ",", 
       RowBox[{"\[Pi]", "/", "2"}], ",", "VerticalSlider"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ControlPlacement", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Top", ",", "Top", ",", "Left"}], "}"}]}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.398189518843156*^9, 3.398189542328974*^9}, {
   3.398189703717575*^9, 3.398189707772398*^9}, {3.3981903999826603`*^9, 
   3.398190415155349*^9}, {3.3981906177277308`*^9, 3.398190618311503*^9}, {
   3.3981906970931187`*^9, 3.39819071841469*^9}, {3.398190796544886*^9, 
   3.39819084295564*^9}, {3.398190992236206*^9, 3.398190992949183*^9}, {
   3.3981912151864758`*^9, 3.3981912304031563`*^9}, 3.398191943166893*^9, {
   3.3981920407067623`*^9, 3.398192041154608*^9}, {3.398192224624048*^9, 
   3.398192246260215*^9}, {3.3981924232561083`*^9, 3.39819242383998*^9}, {
   3.3981924540690317`*^9, 3.398192458254427*^9}, {3.398193235867538*^9, 
   3.398193371371364*^9}, {3.398193402487297*^9, 3.3981934421094427`*^9}, {
   3.398193477651885*^9, 3.398193480011443*^9}, {3.398193526965308*^9, 
   3.398193529999423*^9}, {3.3981936281433487`*^9, 3.398193628714527*^9}, {
   3.398211458065336*^9, 3.398211474622287*^9}, {3.398211759958426*^9, 
   3.398211841603096*^9}, {3.398211932198592*^9, 3.39821199811235*^9}, {
   3.3982122498711042`*^9, 3.398212250439529*^9}, {3.3982122825200863`*^9, 
   3.3982122832305317`*^9}, {3.398212321751828*^9, 3.39821232243696*^9}, {
   3.3982136166901407`*^9, 3.398213618705285*^9}, {3.398213747994172*^9, 
   3.3982137700882807`*^9}, {3.398214014635215*^9, 3.39821408216568*^9}, {
   3.398214409975504*^9, 3.39821451400537*^9}, {3.3982145744984627`*^9, 
   3.398214601573984*^9}, {3.398215541496993*^9, 3.398215554806691*^9}, {
   3.398215593102791*^9, 3.398215612880127*^9}, {3.398215644528266*^9, 
   3.398215673168098*^9}, {3.3982157472252817`*^9, 3.3982157608722467`*^9}, {
   3.39821601089727*^9, 3.39821601352607*^9}, {3.398216065712262*^9, 
   3.398216246623929*^9}, {3.398216278263227*^9, 3.398216367156925*^9}, {
   3.3982164079789963`*^9, 3.398216422497486*^9}, {3.398216454314692*^9, 
   3.398216455392363*^9}, 3.398218036124213*^9, 3.398218066955845*^9, 
   3.398218101938945*^9, 3.398218288835478*^9, 3.398218797942094*^9, {
   3.398219276426056*^9, 3.3982192773200197`*^9}, 3.398274345487751*^9, {
   3.398274422952874*^9, 3.39827443152566*^9}, {3.398274462831785*^9, 
   3.398274463356922*^9}, {3.398280194684251*^9, 3.3982802182809277`*^9}, {
   3.398280264094393*^9, 3.398280280448176*^9}, {3.398280346353464*^9, 
   3.398280353568131*^9}, {3.398280395931859*^9, 3.3982803975772667`*^9}, {
   3.398280439767231*^9, 3.398280468894752*^9}, {3.398280513052574*^9, 
   3.398280547214974*^9}, {3.398280633144449*^9, 3.398280641389388*^9}, {
   3.398280725727826*^9, 3.398280747780417*^9}, {3.398280828130582*^9, 
   3.3982808428056173`*^9}, 3.398282889810143*^9, {3.398302895340375*^9, 
   3.398302987456831*^9}, {3.3983030949394903`*^9, 3.398303301143669*^9}, {
   3.3983033356485777`*^9, 3.398303372169351*^9}, {3.3983039384758987`*^9, 
   3.398303941241437*^9}, {3.398305935487784*^9, 3.398305936031345*^9}, {
   3.398305980235219*^9, 3.398305982343878*^9}, {3.398306033085659*^9, 
   3.398306086831963*^9}, {3.398306505418228*^9, 3.39830651061595*^9}, {
   3.398306559435111*^9, 3.398306605216528*^9}, {3.398306971902431*^9, 
   3.398307006896096*^9}, {3.398307219077366*^9, 3.3983072222002773`*^9}, {
   3.3983073104452677`*^9, 3.398307326328216*^9}, {3.398334534147934*^9, 
   3.398334551953299*^9}, {3.398334614705542*^9, 3.398334677501299*^9}, {
   3.3983347128121643`*^9, 3.3983347144097977`*^9}, {3.3983347562687197`*^9, 
   3.398334792002239*^9}, {3.398335006509493*^9, 3.39833510905122*^9}, {
   3.3983354020295553`*^9, 3.39833540412598*^9}, {3.3983355986913958`*^9, 
   3.398335612579646*^9}, {3.398335831982689*^9, 3.398335835441819*^9}, 
   3.398336409903235*^9, 3.398339501967845*^9, {3.398430962281394*^9, 
   3.3984309682333107`*^9}, {3.398431065630109*^9, 3.398431154013885*^9}, {
   3.398431280539672*^9, 3.398431308983382*^9}, {3.398431346632725*^9, 
   3.3984314700698423`*^9}, {3.398431617665907*^9, 3.3984316184502773`*^9}, {
   3.398431654735305*^9, 3.398431700349416*^9}, {3.398431757089072*^9, 
   3.398431765423291*^9}, 3.398438297848133*^9, {3.39843834359746*^9, 
   3.398438344233643*^9}, {3.398438830223899*^9, 3.3984388316955214`*^9}, 
   3.398438882612156*^9, {3.398439289984541*^9, 3.39843934340968*^9}, {
   3.398439381019589*^9, 3.398439399824788*^9}, 3.398439432763167*^9, {
   3.398439496843636*^9, 3.398439500939981*^9}, {3.398439655133318*^9, 
   3.398439660782428*^9}, {3.398439717973565*^9, 3.3984397590585127`*^9}, {
   3.398439807151003*^9, 3.39843995817535*^9}, {3.3984400443193607`*^9, 
   3.398440045443228*^9}, {3.398440091937502*^9, 3.398440181111796*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`r$$ = 
    0.3, $CellContext`ShowGaussianSurface$$ = True, $CellContext`\[Alpha]$$ = 
    Rational[1, 2] Pi, Typeset`show$$ = True, Typeset`bookmarkList$$ = {}, 
    Typeset`bookmarkMode$$ = "Menu", Typeset`animator$$, Typeset`animvar$$ = 
    1, Typeset`name$$ = "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`ShowGaussianSurface$$], True, 
       "Show Gaussian Surface"}, {True, False}}, {{
       Hold[$CellContext`r$$], 0.3, 
       "Radius of Gaussian Surface, \!\(\*\nStyleBox[\"r\",\n\
FontSlant->\"Italic\"]\)"}, 0.001, 1.35}, {{
       Hold[$CellContext`\[Alpha]$$], Rational[1, 2] Pi, "Open/\nClose"}, 0, 
      Rational[1, 2] Pi}}, Typeset`size$$ = {577., {140., 161.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`ShowGaussianSurface$2590$$ = 
    False, $CellContext`r$2591$$ = 0, $CellContext`\[Alpha]$2592$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`r$$ = 
        0.3, $CellContext`ShowGaussianSurface$$ = 
        True, $CellContext`\[Alpha]$$ = Rational[1, 2] Pi}, 
      "ControllerVariables" :> {
        Hold[$CellContext`ShowGaussianSurface$$, \
$CellContext`ShowGaussianSurface$2590$$, False], 
        Hold[$CellContext`r$$, $CellContext`r$2591$$, 0], 
        Hold[$CellContext`\[Alpha]$$, $CellContext`\[Alpha]$2592$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> With[{$CellContext`Q$ = 1}, 
        With[{$CellContext`\[Lambda]in$ = Function[$CellContext`r$, 
            
            Piecewise[{{1 $CellContext`r$^2, $CellContext`r$ < 1}, {
              1, $CellContext`r$ >= 1}}]]}, 
         GraphicsRow[{
           Graphics3D[{{
              $CellContext`PartialSolidCylinder[
              1, 10, $CellContext`\[Alpha]$$]}, 
             If[$CellContext`ShowGaussianSurface$$, {
               Opacity[0.3], Yellow, 
               
               Cylinder[{{(-2)/2, 0, 0}, {
                 2/2, 0, 0}}, $CellContext`r$$]}, {}]}, SphericalRegion -> 
            True, Lighting -> "Neutral", Boxed -> False], 
           GraphicsColumn[{
             Plot[
             2 ($CellContext`\[Lambda]in$[$CellContext`r$$]/$CellContext`r$$),\
 {$CellContext`r$$, 0, 1.35}, AxesLabel -> {"r", "E"}, Epilog -> {
                
                Point[{$CellContext`r$$, 
                  2 ($CellContext`\[Lambda]in$[$CellContext`r$$]/$CellContext`\
r$$)}]}], 
             Plot[
              $CellContext`\[Lambda]in$[$CellContext`r$$], {$CellContext`r$$, 
               0, 1.35}, 
              AxesLabel -> {
               "r", "\!\(\*SubscriptBox[\(Q\), \(inside\)]\)/\[ScriptL]"}, 
              Epilog -> {
                Point[{$CellContext`r$$, 
                  $CellContext`\[Lambda]in$[$CellContext`r$$]}]}]}]}]]], 
      "Specifications" :> {{{$CellContext`ShowGaussianSurface$$, True, 
          "Show Gaussian Surface"}, {
         True, False}}, {{$CellContext`r$$, 0.3, 
          "Radius of Gaussian Surface, \!\(\*\nStyleBox[\"r\",\n\
FontSlant->\"Italic\"]\)"}, 0.001, 
         1.35}, {{$CellContext`\[Alpha]$$, Rational[1, 2] Pi, "Open/\nClose"},
          0, Rational[1, 2] Pi, ControlType -> VerticalSlider}}, 
      "Options" :> {ControlPlacement -> {Top, Top, Left}}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{743., {271.6875, 282.3125}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{3.401222091791395*^9}]
}, {2}]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Solid Conducting Sphere", "Section",
 CellChangeTimes->{{3.398438527590519*^9, 3.39843854257592*^9}, {
  3.3984402568026323`*^9, 3.398440264377028*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", "=", "1.35"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"With", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Q", "=", "1"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Qin", "=", 
           RowBox[{"Function", "[", 
            RowBox[{"r", ",", 
             RowBox[{"Piecewise", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"r", "<", "1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"Q", ",", 
                  RowBox[{"r", "\[GreaterEqual]", "1"}]}], "}"}]}], "}"}], 
              "]"}]}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"GraphicsRow", "[", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Graphics3D", "[", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"PartialSolidSphere", "[", 
                  RowBox[{"1", ",", "\[Alpha]", ",", "ConductorOptions"}], 
                  "]"}], "}"}], ",", 
                RowBox[{"If", "[", 
                 RowBox[{"ShowGaussianSurface", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Opacity", "[", ".3", "]"}], ",", "Yellow", ",", 
                    RowBox[{"Sphere", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "r"}], 
                    "]"}]}], "}"}], ",", 
                  RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]", "}"}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"SphericalRegion", "\[Rule]", "True"}], ",", 
              RowBox[{"PlotRange", "\[Rule]", "a"}], ",", 
              RowBox[{"Lighting", "\[Rule]", "\"\<Neutral\>\""}], ",", 
              RowBox[{"Boxed", "\[Rule]", "False"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"GraphicsColumn", "[", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Plot", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Qin", "[", "r", "]"}], "/", 
                  SuperscriptBox["r", "2"]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"r", ",", "0", ",", "a"}], "}"}], ",", 
                 RowBox[{"AxesLabel", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"\"\<r\>\"", ",", "\"\<E\>\""}], "}"}]}], ",", 
                 RowBox[{"Epilog", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{"r", ",", 
                    RowBox[{
                    RowBox[{"Qin", "[", "r", "]"}], "/", 
                    SuperscriptBox["r", "2"]}]}], "}"}], "]"}], "}"}]}]}], 
                "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Plot", "[", 
                RowBox[{
                 RowBox[{"Qin", "[", "r", "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"r", ",", "0", ",", "a"}], "}"}], ",", 
                 RowBox[{"AxesLabel", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<r\>\"", ",", 
                    "\"\<\!\(\*SubscriptBox[\(Q\), \(inside\)]\)\>\""}], 
                   "}"}]}], ",", 
                 RowBox[{"Epilog", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{"r", ",", 
                    RowBox[{"Qin", "[", "r", "]"}]}], "}"}], "]"}], "}"}]}]}],
                 "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "ShowGaussianSurface", ",", "True", ",", 
         "\"\<Show Gaussian Surface\>\""}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", ",", ".3", ",", "\"\<Radius of Gaussian Surface, \!\(\*
StyleBox[\"r\",
FontSlant->\"Italic\"]\)\>\""}], "}"}], ",", "0", ",", "a"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Alpha]", ",", 
         RowBox[{"\[Pi]", "/", "2"}], ",", "\"\<Open/\\nClose\>\""}], "}"}], 
       ",", "0", ",", 
       RowBox[{"\[Pi]", "/", "2"}], ",", "VerticalSlider"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ControlPlacement", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Top", ",", "Top", ",", "Left"}], "}"}]}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.398189518843156*^9, 3.398189542328974*^9}, {
   3.398189703717575*^9, 3.398189707772398*^9}, {3.3981903999826603`*^9, 
   3.398190415155349*^9}, {3.3981906177277308`*^9, 3.398190618311503*^9}, {
   3.3981906970931187`*^9, 3.39819071841469*^9}, {3.398190796544886*^9, 
   3.39819084295564*^9}, {3.398190992236206*^9, 3.398190992949183*^9}, {
   3.3981912151864758`*^9, 3.3981912304031563`*^9}, 3.398191943166893*^9, {
   3.3981920407067623`*^9, 3.398192041154608*^9}, {3.398192224624048*^9, 
   3.398192246260215*^9}, {3.3981924232561083`*^9, 3.39819242383998*^9}, {
   3.3981924540690317`*^9, 3.398192458254427*^9}, {3.398193235867538*^9, 
   3.398193371371364*^9}, {3.398193402487297*^9, 3.3981934421094427`*^9}, {
   3.398193477651885*^9, 3.398193480011443*^9}, {3.398193526965308*^9, 
   3.398193529999423*^9}, {3.3981936281433487`*^9, 3.398193628714527*^9}, {
   3.398211458065336*^9, 3.398211474622287*^9}, {3.398211759958426*^9, 
   3.398211841603096*^9}, {3.398211932198592*^9, 3.39821199811235*^9}, {
   3.3982122498711042`*^9, 3.398212250439529*^9}, {3.3982122825200863`*^9, 
   3.3982122832305317`*^9}, {3.398212321751828*^9, 3.39821232243696*^9}, {
   3.3982136166901407`*^9, 3.398213618705285*^9}, {3.398213747994172*^9, 
   3.3982137700882807`*^9}, {3.398214014635215*^9, 3.39821408216568*^9}, {
   3.398214409975504*^9, 3.39821451400537*^9}, {3.3982145744984627`*^9, 
   3.398214601573984*^9}, {3.398215541496993*^9, 3.398215554806691*^9}, {
   3.398215593102791*^9, 3.398215612880127*^9}, {3.398215644528266*^9, 
   3.398215673168098*^9}, {3.3982157472252817`*^9, 3.3982157608722467`*^9}, {
   3.39821601089727*^9, 3.39821601352607*^9}, {3.398216065712262*^9, 
   3.398216246623929*^9}, {3.398216278263227*^9, 3.398216367156925*^9}, {
   3.3982164079789963`*^9, 3.398216422497486*^9}, {3.398216454314692*^9, 
   3.398216455392363*^9}, 3.398218036124213*^9, 3.398218066955845*^9, 
   3.398218101938945*^9, 3.398218288835478*^9, 3.398218797942094*^9, {
   3.398219276426056*^9, 3.3982192773200197`*^9}, 3.398274345487751*^9, {
   3.398274422952874*^9, 3.39827443152566*^9}, {3.398274462831785*^9, 
   3.398274463356922*^9}, {3.398280194684251*^9, 3.3982802182809277`*^9}, {
   3.398280264094393*^9, 3.398280280448176*^9}, {3.398280346353464*^9, 
   3.398280353568131*^9}, {3.398280395931859*^9, 3.3982803975772667`*^9}, {
   3.398280439767231*^9, 3.398280468894752*^9}, {3.398280513052574*^9, 
   3.398280547214974*^9}, {3.398280633144449*^9, 3.398280641389388*^9}, {
   3.398280725727826*^9, 3.398280747780417*^9}, {3.398280828130582*^9, 
   3.3982808428056173`*^9}, 3.398282889810143*^9, {3.398302895340375*^9, 
   3.398302987456831*^9}, {3.3983030949394903`*^9, 3.398303301143669*^9}, {
   3.3983033356485777`*^9, 3.398303372169351*^9}, {3.3983039384758987`*^9, 
   3.398303941241437*^9}, {3.398305935487784*^9, 3.398305936031345*^9}, {
   3.398305980235219*^9, 3.398305982343878*^9}, {3.398306033085659*^9, 
   3.398306086831963*^9}, {3.398306505418228*^9, 3.39830651061595*^9}, {
   3.398306559435111*^9, 3.398306605216528*^9}, {3.398306971902431*^9, 
   3.398307006896096*^9}, {3.398307219077366*^9, 3.3983072222002773`*^9}, {
   3.3983073104452677`*^9, 3.398307326328216*^9}, {3.398334534147934*^9, 
   3.398334551953299*^9}, {3.398334614705542*^9, 3.398334677501299*^9}, {
   3.3983347128121643`*^9, 3.3983347144097977`*^9}, {3.3983347562687197`*^9, 
   3.398334792002239*^9}, {3.398335006509493*^9, 3.39833510905122*^9}, {
   3.3983354020295553`*^9, 3.39833540412598*^9}, {3.3983355986913958`*^9, 
   3.398335612579646*^9}, {3.398335831982689*^9, 3.398335835441819*^9}, 
   3.398336409903235*^9, 3.398339501967845*^9, {3.398430962281394*^9, 
   3.3984309682333107`*^9}, {3.398431065630109*^9, 3.398431154013885*^9}, {
   3.398431280539672*^9, 3.398431308983382*^9}, {3.398431346632725*^9, 
   3.3984314700698423`*^9}, {3.398431617665907*^9, 3.3984316184502773`*^9}, {
   3.398431654735305*^9, 3.398431700349416*^9}, {3.398431757089072*^9, 
   3.398431765423291*^9}, 3.398438297848133*^9, {3.39843834359746*^9, 
   3.398438344233643*^9}, {3.398438830223899*^9, 3.3984388316955214`*^9}, 
   3.398438882612156*^9, {3.398440271435088*^9, 3.398440272546385*^9}, {
   3.3984403094278173`*^9, 3.398440310264394*^9}, {3.398440464108995*^9, 
   3.398440497564444*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`r$$ = 
    0.677, $CellContext`ShowGaussianSurface$$ = 
    True, $CellContext`\[Alpha]$$ = 1.5707963267948966`, Typeset`show$$ = 
    True, Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`ShowGaussianSurface$$], True, 
       "Show Gaussian Surface"}, {True, False}}, {{
       Hold[$CellContext`r$$], 0.3, 
       "Radius of Gaussian Surface, \!\(\*\nStyleBox[\"r\",\n\
FontSlant->\"Italic\"]\)"}, 0, 1.35}, {{
       Hold[$CellContext`\[Alpha]$$], Rational[1, 2] Pi, "Open/\nClose"}, 0, 
      Rational[1, 2] Pi}}, Typeset`size$$ = {577., {140., 161.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`ShowGaussianSurface$2813$$ = 
    False, $CellContext`r$2814$$ = 0, $CellContext`\[Alpha]$2815$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`r$$ = 
        0.3, $CellContext`ShowGaussianSurface$$ = 
        True, $CellContext`\[Alpha]$$ = Rational[1, 2] Pi}, 
      "ControllerVariables" :> {
        Hold[$CellContext`ShowGaussianSurface$$, \
$CellContext`ShowGaussianSurface$2813$$, False], 
        Hold[$CellContext`r$$, $CellContext`r$2814$$, 0], 
        Hold[$CellContext`\[Alpha]$$, $CellContext`\[Alpha]$2815$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> With[{$CellContext`Q$ = 1}, 
        With[{$CellContext`Qin$ = Function[$CellContext`r$, 
            
            Piecewise[{{
              0, $CellContext`r$ < 1}, {$CellContext`Q$, $CellContext`r$ >= 
               1}}]]}, 
         GraphicsRow[{
           Graphics3D[{{
              $CellContext`PartialSolidSphere[
              1, $CellContext`\[Alpha]$$, $CellContext`ConductorOptions]}, 
             If[$CellContext`ShowGaussianSurface$$, {
               Opacity[0.3], Yellow, 
               Sphere[{0, 0, 0}, $CellContext`r$$]}, {}]}, SphericalRegion -> 
            True, PlotRange -> 1.35, Lighting -> "Neutral", Boxed -> False], 
           GraphicsColumn[{
             
             Plot[$CellContext`Qin$[$CellContext`r$$]/$CellContext`r$$^2, \
{$CellContext`r$$, 0, 1.35}, AxesLabel -> {"r", "E"}, Epilog -> {
                
                Point[{$CellContext`r$$, \
$CellContext`Qin$[$CellContext`r$$]/$CellContext`r$$^2}]}], 
             Plot[
              $CellContext`Qin$[$CellContext`r$$], {$CellContext`r$$, 0, 
               1.35}, AxesLabel -> {
               "r", "\!\(\*SubscriptBox[\(Q\), \(inside\)]\)"}, Epilog -> {
                Point[{$CellContext`r$$, 
                  $CellContext`Qin$[$CellContext`r$$]}]}]}]}]]], 
      "Specifications" :> {{{$CellContext`ShowGaussianSurface$$, True, 
          "Show Gaussian Surface"}, {
         True, False}}, {{$CellContext`r$$, 0.3, 
          "Radius of Gaussian Surface, \!\(\*\nStyleBox[\"r\",\n\
FontSlant->\"Italic\"]\)"}, 0, 
         1.35}, {{$CellContext`\[Alpha]$$, Rational[1, 2] Pi, "Open/\nClose"},
          0, Rational[1, 2] Pi, ControlType -> VerticalSlider}}, 
      "Options" :> {ControlPlacement -> {Top, Top, Left}}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{743., {271.6875, 282.3125}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{3.401222114738902*^9}]
}, {2}]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Hollow Sphere with Point Charge at Center", "Section",
 CellChangeTimes->{{3.398438527590519*^9, 3.398438575189782*^9}, {
  3.401274140372918*^9, 3.4012741506656713`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "=", "1.35"}], ",", 
     RowBox[{"R1", "=", ".6"}], ",", 
     RowBox[{"Q1", "=", 
      RowBox[{"-", "1"}]}], ",", 
     RowBox[{"Q2", "=", "4"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"With", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Q", "=", "1"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Qin", "=", 
           RowBox[{"Function", "[", 
            RowBox[{"r", ",", 
             RowBox[{"Piecewise", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"Q1", ",", 
                  RowBox[{"r", "\[LessEqual]", "R1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"R1", "<", "r", "<", "1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Q1", "+", "Q2"}], ",", 
                  RowBox[{"r", "\[GreaterEqual]", "1"}]}], "}"}]}], "}"}], 
              "]"}]}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"GraphicsRow", "[", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Graphics3D", "[", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"BlueGray", ",", 
                  RowBox[{"Sphere", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", ".05"}], 
                   "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{"PartialSolidSphere", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{".6", ",", "1"}], "}"}], ",", "\[Alpha]", ",", 
                   "ConductorOptions"}], "]"}], "}"}], ",", 
                RowBox[{"If", "[", 
                 RowBox[{"ShowGaussianSurface", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Opacity", "[", ".3", "]"}], ",", "Yellow", ",", 
                    RowBox[{"Sphere", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "r"}], 
                    "]"}]}], "}"}], ",", 
                  RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]", "}"}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"SphericalRegion", "\[Rule]", "True"}], ",", 
              RowBox[{"PlotRange", "\[Rule]", "a"}], ",", 
              RowBox[{"Lighting", "\[Rule]", "\"\<Neutral\>\""}], ",", 
              RowBox[{"Boxed", "\[Rule]", "False"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"GraphicsColumn", "[", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Plot", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Qin", "[", "r", "]"}], "/", 
                  SuperscriptBox["r", "2"]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"r", ",", "0", ",", "a"}], "}"}], ",", 
                 RowBox[{"AxesLabel", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"\"\<r\>\"", ",", "\"\<E\>\""}], "}"}]}], ",", 
                 RowBox[{"PlotRange", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "8"}], ",", "5"}], "}"}]}], ",", 
                 RowBox[{"Epilog", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{"r", ",", 
                    RowBox[{
                    RowBox[{"Qin", "[", "r", "]"}], "/", 
                    SuperscriptBox["r", "2"]}]}], "}"}], "]"}], "}"}]}]}], 
                "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Plot", "[", 
                RowBox[{
                 RowBox[{"Qin", "[", "r", "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"r", ",", "0", ",", "a"}], "}"}], ",", 
                 RowBox[{"AxesLabel", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<r\>\"", ",", 
                    "\"\<\!\(\*SubscriptBox[\(Q\), \(inside\)]\)\>\""}], 
                   "}"}]}], ",", 
                 RowBox[{"Epilog", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{"r", ",", 
                    RowBox[{"Qin", "[", "r", "]"}]}], "}"}], "]"}], "}"}]}]}],
                 "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "ShowGaussianSurface", ",", "True", ",", 
         "\"\<Show Gaussian Surface\>\""}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", ",", ".3", ",", "\"\<Radius of Gaussian Surface, \!\(\*
StyleBox[\"r\",
FontSlant->\"Italic\"]\)\>\""}], "}"}], ",", "0.02", ",", "a"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Alpha]", ",", 
         RowBox[{"\[Pi]", "/", "2"}], ",", "\"\<Open/\\nClose\>\""}], "}"}], 
       ",", "0", ",", 
       RowBox[{"\[Pi]", "/", "2"}], ",", "VerticalSlider"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ControlPlacement", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Top", ",", "Top", ",", "Left"}], "}"}]}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.398189518843156*^9, 3.398189542328974*^9}, {
   3.398189703717575*^9, 3.398189707772398*^9}, {3.3981903999826603`*^9, 
   3.398190415155349*^9}, {3.3981906177277308`*^9, 3.398190618311503*^9}, {
   3.3981906970931187`*^9, 3.39819071841469*^9}, {3.398190796544886*^9, 
   3.39819084295564*^9}, {3.398190992236206*^9, 3.398190992949183*^9}, {
   3.3981912151864758`*^9, 3.3981912304031563`*^9}, 3.398191943166893*^9, {
   3.3981920407067623`*^9, 3.398192041154608*^9}, {3.398192224624048*^9, 
   3.398192246260215*^9}, {3.3981924232561083`*^9, 3.39819242383998*^9}, {
   3.3981924540690317`*^9, 3.398192458254427*^9}, {3.398193235867538*^9, 
   3.398193371371364*^9}, {3.398193402487297*^9, 3.3981934421094427`*^9}, {
   3.398193477651885*^9, 3.398193480011443*^9}, {3.398193526965308*^9, 
   3.398193529999423*^9}, {3.3981936281433487`*^9, 3.398193628714527*^9}, {
   3.398211458065336*^9, 3.398211474622287*^9}, {3.398211759958426*^9, 
   3.398211841603096*^9}, {3.398211932198592*^9, 3.39821199811235*^9}, {
   3.3982122498711042`*^9, 3.398212250439529*^9}, {3.3982122825200863`*^9, 
   3.3982122832305317`*^9}, {3.398212321751828*^9, 3.39821232243696*^9}, {
   3.3982136166901407`*^9, 3.398213618705285*^9}, {3.398213747994172*^9, 
   3.3982137700882807`*^9}, {3.398214014635215*^9, 3.39821408216568*^9}, {
   3.398214409975504*^9, 3.39821451400537*^9}, {3.3982145744984627`*^9, 
   3.398214601573984*^9}, {3.398215541496993*^9, 3.398215554806691*^9}, {
   3.398215593102791*^9, 3.398215612880127*^9}, {3.398215644528266*^9, 
   3.398215673168098*^9}, {3.3982157472252817`*^9, 3.3982157608722467`*^9}, {
   3.39821601089727*^9, 3.39821601352607*^9}, {3.398216065712262*^9, 
   3.398216246623929*^9}, {3.398216278263227*^9, 3.398216367156925*^9}, {
   3.3982164079789963`*^9, 3.398216422497486*^9}, {3.398216454314692*^9, 
   3.398216455392363*^9}, 3.398218036124213*^9, 3.398218066955845*^9, 
   3.398218101938945*^9, 3.398218288835478*^9, 3.398218797942094*^9, {
   3.398219276426056*^9, 3.3982192773200197`*^9}, 3.398274345487751*^9, {
   3.398274422952874*^9, 3.39827443152566*^9}, {3.398274462831785*^9, 
   3.398274463356922*^9}, {3.398280194684251*^9, 3.3982802182809277`*^9}, {
   3.398280264094393*^9, 3.398280280448176*^9}, {3.398280346353464*^9, 
   3.398280353568131*^9}, {3.398280395931859*^9, 3.3982803975772667`*^9}, {
   3.398280439767231*^9, 3.398280468894752*^9}, {3.398280513052574*^9, 
   3.398280547214974*^9}, {3.398280633144449*^9, 3.398280641389388*^9}, {
   3.398280725727826*^9, 3.398280747780417*^9}, {3.398280828130582*^9, 
   3.3982808428056173`*^9}, 3.398282889810143*^9, {3.398302895340375*^9, 
   3.398302987456831*^9}, {3.3983030949394903`*^9, 3.398303301143669*^9}, {
   3.3983033356485777`*^9, 3.398303372169351*^9}, {3.3983039384758987`*^9, 
   3.398303941241437*^9}, {3.398305935487784*^9, 3.398305936031345*^9}, {
   3.398305980235219*^9, 3.398305982343878*^9}, {3.398306033085659*^9, 
   3.398306086831963*^9}, {3.398306505418228*^9, 3.39830651061595*^9}, {
   3.398306559435111*^9, 3.398306605216528*^9}, {3.398306971902431*^9, 
   3.398307006896096*^9}, {3.398307219077366*^9, 3.3983072222002773`*^9}, {
   3.3983073104452677`*^9, 3.398307326328216*^9}, {3.398334534147934*^9, 
   3.398334551953299*^9}, {3.398334614705542*^9, 3.398334677501299*^9}, {
   3.3983347128121643`*^9, 3.3983347144097977`*^9}, {3.3983347562687197`*^9, 
   3.398334792002239*^9}, {3.398335006509493*^9, 3.39833510905122*^9}, {
   3.3983354020295553`*^9, 3.39833540412598*^9}, {3.3983355986913958`*^9, 
   3.398335612579646*^9}, {3.398335831982689*^9, 3.398335835441819*^9}, 
   3.398336409903235*^9, 3.398339501967845*^9, {3.398430962281394*^9, 
   3.3984309682333107`*^9}, {3.398431065630109*^9, 3.398431154013885*^9}, {
   3.398431280539672*^9, 3.398431308983382*^9}, {3.398431346632725*^9, 
   3.3984314700698423`*^9}, {3.398431617665907*^9, 3.3984316184502773`*^9}, {
   3.398431654735305*^9, 3.398431700349416*^9}, {3.398431757089072*^9, 
   3.398431765423291*^9}, 3.398438297848133*^9, {3.39843834359746*^9, 
   3.398438344233643*^9}, {3.3984389985287447`*^9, 3.3984391523068113`*^9}, {
   3.3984392009449787`*^9, 3.398439202547041*^9}, 3.3984399658373623`*^9, {
   3.398440410880786*^9, 3.398440415814859*^9}, {3.3984405155609703`*^9, 
   3.398440713601717*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`r$$ = 
    0.9390000000000001, $CellContext`ShowGaussianSurface$$ = 
    True, $CellContext`\[Alpha]$$ = Rational[1, 2] Pi, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`ShowGaussianSurface$$], True, 
       "Show Gaussian Surface"}, {True, False}}, {{
       Hold[$CellContext`r$$], 0.3, 
       "Radius of Gaussian Surface, \!\(\*\nStyleBox[\"r\",\n\
FontSlant->\"Italic\"]\)"}, 0.02, 1.35}, {{
       Hold[$CellContext`\[Alpha]$$], Rational[1, 2] Pi, "Open/\nClose"}, 0, 
      Rational[1, 2] Pi}}, Typeset`size$$ = {577., {140., 161.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`ShowGaussianSurface$3011$$ = 
    False, $CellContext`r$3012$$ = 0, $CellContext`\[Alpha]$3013$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`r$$ = 
        0.3, $CellContext`ShowGaussianSurface$$ = 
        True, $CellContext`\[Alpha]$$ = Rational[1, 2] Pi}, 
      "ControllerVariables" :> {
        Hold[$CellContext`ShowGaussianSurface$$, \
$CellContext`ShowGaussianSurface$3011$$, False], 
        Hold[$CellContext`r$$, $CellContext`r$3012$$, 0], 
        Hold[$CellContext`\[Alpha]$$, $CellContext`\[Alpha]$3013$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> With[{$CellContext`Q$ = 1}, 
        With[{$CellContext`Qin$ = Function[$CellContext`r$, 
            
            Piecewise[{{-1, $CellContext`r$ <= 0.6}, {
              0, 0.6 < $CellContext`r$ < 1}, {-1 + 4, $CellContext`r$ >= 
               1}}]]}, 
         GraphicsRow[{
           Graphics3D[{{$CellContext`BlueGray, 
              Sphere[{0, 0, 0}, 0.05]}, {
              $CellContext`PartialSolidSphere[{
               0.6, 1}, $CellContext`\[Alpha]$$, \
$CellContext`ConductorOptions]}, 
             If[$CellContext`ShowGaussianSurface$$, {
               Opacity[0.3], Yellow, 
               Sphere[{0, 0, 0}, $CellContext`r$$]}, {}]}, SphericalRegion -> 
            True, PlotRange -> 1.35, Lighting -> "Neutral", Boxed -> False], 
           GraphicsColumn[{
             
             Plot[$CellContext`Qin$[$CellContext`r$$]/$CellContext`r$$^2, \
{$CellContext`r$$, 0, 1.35}, AxesLabel -> {"r", "E"}, PlotRange -> {-8, 5}, 
              Epilog -> {
                
                Point[{$CellContext`r$$, \
$CellContext`Qin$[$CellContext`r$$]/$CellContext`r$$^2}]}], 
             Plot[
              $CellContext`Qin$[$CellContext`r$$], {$CellContext`r$$, 0, 
               1.35}, AxesLabel -> {
               "r", "\!\(\*SubscriptBox[\(Q\), \(inside\)]\)"}, Epilog -> {
                Point[{$CellContext`r$$, 
                  $CellContext`Qin$[$CellContext`r$$]}]}]}]}]]], 
      "Specifications" :> {{{$CellContext`ShowGaussianSurface$$, True, 
          "Show Gaussian Surface"}, {
         True, False}}, {{$CellContext`r$$, 0.3, 
          "Radius of Gaussian Surface, \!\(\*\nStyleBox[\"r\",\n\
FontSlant->\"Italic\"]\)"}, 0.02, 
         1.35}, {{$CellContext`\[Alpha]$$, Rational[1, 2] Pi, "Open/\nClose"},
          0, Rational[1, 2] Pi, ControlType -> VerticalSlider}}, 
      "Options" :> {ControlPlacement -> {Top, Top, Left}}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{743., {271.6875, 282.3125}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{3.401222145080365*^9}]
}, {2}]]
}, Open  ]]
},
AutoGeneratedPackage->None,
WindowToolbars->{},
InitializationCellEvaluation->True,
WindowSize->{986, 724},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingCopies->45,
PrintingPageRange->{1, Automatic},
ShowSelection->True,
DefaultNewCellStyle->"Input",
FontFamily->"Times",
Magnification->2.,
FrontEndVersion->"6.0 for Mac OS X x86 (32-bit) (June 19, 2007)",
StyleDefinitions->Notebook[{
   Cell[
    CellGroupData[{
      Cell["Style Definitions", "Title"], 
      Cell[
      "Modify the definitions below to change the default appearance of all \
cells in a given style.  Make modifications to any definition using commands \
in the Format menu.", "Text"], 
      Cell[
       CellGroupData[{
         Cell["Style Environment Names", "Section"], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, ScriptMinSize -> 
          9], 
         Cell[
          StyleData[All, "Presentation"], PageWidth -> WindowWidth, 
          ScriptMinSize -> 9], 
         Cell[
          StyleData[All, "SlideShow"], PageWidth -> WindowWidth, 
          ScrollingOptions -> {
           "PagewiseDisplay" -> True, "VerticalScrollRange" -> Fit}, 
          ShowCellBracket -> False, ScriptMinSize -> 9], 
         Cell[
          StyleData[All, "Printout"], PageWidth -> PaperWidth, ScriptMinSize -> 
          7, FontSize -> 10, 
          PrivateFontOptions -> {"FontType" -> "Outline"}]}, Open]], 
      Cell[
       CellGroupData[{
         Cell["Notebook Options", "Section"], 
         Cell[
         "The options defined for the style below will be used at the \
Notebook level.", "Text"], 
         Cell[
          StyleData["Notebook"], PageHeaders -> {{
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"], None, 
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"]}, {
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"], None, 
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"]}}, 
          PrintingOptions -> {
           "FirstPageFace" -> Right, "FirstPageHeader" -> False}, 
          StyleMenuListing -> None, Background -> 
          RGBColor[0.900008, 0.863996, 0.809995]]}, Open]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headings", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Title"], ShowCellBracket -> False, 
             CellMargins -> {{0, 0}, {0, 0}}, PageBreakBelow -> False, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, TextAlignment -> Center, TextJustification -> 0, 
             LineSpacing -> {1, 13}, 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}}, FontFamily -> "Helvetica", FontSize -> 34, 
             FontWeight -> "Bold", FontColor -> GrayLevel[1], Background -> 
             RGBColor[0.0500038, 0.100008, 0.2]], 
            Cell[
             StyleData["Title", "Presentation"], 
             CellFrameMargins -> {{14, 10}, {15, 15}}, FontSize -> 51], 
            Cell[
             StyleData["Title", "Printout"], CellMargins -> {{0, 0}, {0, 0}}, 
             FontSize -> 24, Background -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subtitle"], ShowCellBracket -> False, 
             CellMargins -> {{0, 0}, {0, 0}}, PageBreakBelow -> False, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, TextAlignment -> Center, TextJustification -> 0, 
             LineSpacing -> {1, 3}, ParagraphIndent -> -96, 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}}, FontFamily -> "Helvetica", FontSize -> 24, 
             FontColor -> GrayLevel[1], Background -> 
             RGBColor[0.250004, 0.400015, 0.6]], 
            Cell[
             StyleData["Subtitle", "Presentation"], 
             CellFrameMargins -> {{14, 10}, {14, 14}}, FontSize -> 27], 
            Cell[
             StyleData["Subtitle", "Printout"], 
             CellMargins -> {{0, 0}, {0, 0}}, ParagraphIndent -> -85, 
             FontSize -> 16]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubtitle"], ShowCellBracket -> False, 
             CellMargins -> {{0, 0}, {0, 0}}, PageBreakBelow -> False, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, TextAlignment -> Right, TextJustification -> 0, 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}}, FontFamily -> "Helvetica", FontSize -> 16, 
             FontSlant -> "Italic", Background -> 
             RGBColor[0.624994, 0.700008, 0.8]], 
            Cell[
             StyleData["Subsubtitle", "Presentation"], 
             CellMargins -> {{0, 0}, {0, 0}}, FontSize -> 24], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{0, 0}, {0, 0}}, FontSize -> 16]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellFrame -> {{0, 0}, {0, 1.5}}, 
             CellDingbat -> None, CellMargins -> {{12, Inherited}, {4, 24}}, 
             CellGroupingRules -> {"SectionGrouping", 30}, PageBreakBelow -> 
             False, CellFrameMargins -> {{0, 4}, {6, 2}}, CellFrameColor -> 
             RGBColor[0.0500038, 0.100008, 0.2], CellFrameLabelMargins -> 2, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, CounterIncrements -> "Section", 
             CounterAssignments -> {{"Subsection", 0}, {"Subsubsection", 0}}, 
             FontFamily -> "Helvetica", FontSize -> 18, FontWeight -> "Bold", 
             FontColor -> RGBColor[0.0500038, 0.100008, 0.2]], 
            Cell[
             StyleData["Section", "Presentation"], 
             CellFrame -> {{0, 0}, {0, 2}}, 
             CellMargins -> {{14, 10}, {6, 24}}, FontSize -> 27], 
            Cell[
             StyleData["Section", "Printout"], 
             CellMargins -> {{9, 0}, {2, 50}}, FontSize -> 14, FontTracking -> 
             "Plain", FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellMargins -> {{12, 10}, {25, 0}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, LineSpacing -> {1, 3}, ParagraphSpacing -> {0, 12},
              FontFamily -> "Helvetica"], 
            Cell[
             StyleData["Subsection", "Presentation"], 
             CellMargins -> {{14, 10}, {45, 4}}, FontSize -> 18], 
            Cell[
             StyleData["Subsection", "Printout"], 
             CellMargins -> {{9, 0}, {4, 40}}, FontSize -> 12]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsection"], CellMargins -> {{12, 10}, {5, 20}}, 
             CellFrameMargins -> {{0, 0}, {0, 2}}, CellFrameColor -> 
             RGBColor[0.100008, 0.2, 0.4], 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, LineSpacing -> {1, 0}, ParagraphSpacing -> {0, 12},
              FontFamily -> "Helvetica", FontSize -> 14, FontWeight -> "Bold",
              FontSlant -> "Italic", FontColor -> 
             RGBColor[0.100008, 0.2, 0.4]], 
            Cell[
             StyleData["Subsubsection", "Presentation"], 
             CellMargins -> {{14, 10}, {8, 20}}, 
             CellFrameMargins -> {{0, 0}, {0, 4}}, FontSize -> 22], 
            Cell[
             StyleData["Subsubsection", "Printout"], 
             CellMargins -> {{19, 0}, {4, 20}}, FontSize -> 13]}, Open]]}, 
        Open]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Body Text", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Text"], CellMargins -> {{12, 10}, {5, 5}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, LineSpacing -> {1, 3}, ParagraphSpacing -> {0, 12},
              FontFamily -> "Times"], 
            Cell[
             StyleData["Text", "Presentation"], 
             CellMargins -> {{14, 10}, {8, 10}}, FontSize -> 18], 
            Cell[
             StyleData["Text", "Printout"], CellMargins -> {{9, 0}, {4, 4}}, 
             Hyphenation -> True, ParagraphSpacing -> {0, 6}, FontSize -> 
             10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Commentary"], CellMargins -> {{52, 10}, {0, 10}}, 
             PageBreakBelow -> False, CellFrameMargins -> {{0, 0}, {0, 2}}, 
             CellFrameColor -> GrayLevel[1], LineSpacing -> {1, 0}, 
             ParagraphSpacing -> {0, 12}, FontFamily -> "Helvetica", FontSize -> 
             10, FontWeight -> "Plain", FontSlant -> "Plain"], 
            Cell[
             StyleData["Commentary", "Presentation"], 
             CellMargins -> {{72, 10}, {4, 14}}, FontSize -> 15], 
            Cell[
             StyleData["Commentary", "Printout"], 
             CellMargins -> {{9, 0}, {4, 4}}, Hyphenation -> True, 
             ParagraphSpacing -> {0, 6}, FontSize -> 10]}, Closed]]}, Open]], 
      
      Cell[
       CellGroupData[{
         Cell["Inline Formatting", "Section"], 
         Cell[
         "These styles are for modifying individual words or letters in a \
cell exclusive of the cell tag.", "Text"], 
         Cell[
          StyleData["RM"], StyleMenuListing -> None, FontWeight -> "Plain", 
          FontSlant -> "Plain"], 
         Cell[
          StyleData["BF"], StyleMenuListing -> None, FontWeight -> "Bold"], 
         Cell[
          StyleData["IT"], StyleMenuListing -> None, FontSlant -> "Italic"], 
         Cell[
          StyleData["TR"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["TI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["TB"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["TBI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["MR"], "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["MO"], "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["MB"], "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["MBO"], "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["SR"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["SO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["SB"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["SBO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SO10"], StyleMenuListing -> None, FontFamily -> 
             "Helvetica", FontSize -> 10, FontWeight -> "Plain", FontSlant -> 
             "Italic"], 
            Cell[
             StyleData["SO10", "Printout"], StyleMenuListing -> None, 
             FontFamily -> "Helvetica", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Inert"], StyleMenuListing -> None, Background -> 
             RGBColor[0.870588, 0.905882, 0.972549]], 
            Cell[
             StyleData["Inert", "Printout"], StyleMenuListing -> None, 
             Background -> GrayLevel[1]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Input/Output", "Section"], 
         Cell[
         "The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Input"], CellFrame -> 4, 
             CellMargins -> {{62, 10}, {0, 2}}, Evaluatable -> True, 
             CellGroupingRules -> "InputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             CellFrameColor -> RGBColor[0.8, 0.700008, 0.6], 
             DefaultFormatType -> DefaultInputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", FormatType -> InputForm, ShowStringCharacters -> True,
              NumberMarks -> True, 
             LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, FontWeight -> 
             "Bold", Background -> GrayLevel[1]], 
            Cell[
             StyleData["Input", "Presentation"], 
             CellFrame -> {{6, 6}, {0, 6}}, CellMargins -> {{72, 10}, {0, 2}},
              CellFrameMargins -> 12, FontSize -> 18], 
            Cell[
             StyleData["Input", "Printout"], CellMargins -> {{37, 0}, {6, 6}},
              LinebreakAdjustments -> {0.85, 2, 10, 1, 1}]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["InlineInput"], Evaluatable -> True, CellGroupingRules -> 
             "InputGrouping", CellHorizontalScrolling -> True, 
             PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             DefaultFormatType -> DefaultInputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, FormatType -> InputForm, 
             ShowStringCharacters -> True, NumberMarks -> True, 
             CounterIncrements -> "Input", FontWeight -> "Bold"], 
            Cell[
             StyleData["InlineInput", "Presentation"], 
             CellMargins -> {{10, 10}, {4, 4}}, FontSize -> 18]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Output"], CellFrame -> {{4, 4}, {4, 0}}, 
             CellMargins -> {{62, 10}, {12, 0}}, CellEditDuplicate -> True, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             CellFrameColor -> RGBColor[0.8, 0.700008, 0.6], 
             DefaultFormatType -> DefaultOutputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", FormatType -> InputForm, Background -> GrayLevel[1]], 
            
            Cell[
             StyleData["Output", "Presentation"], 
             CellFrame -> {{6, 6}, {6, 0}}, 
             CellMargins -> {{72, 10}, {20, 2}}, CellFrameMargins -> 12, 
             FontSize -> 18], 
            Cell[
             StyleData["Output", "Printout"], 
             CellMargins -> {{37, 0}, {6, 2}}]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["InputOnly"], CellFrame -> 4, 
             CellMargins -> {{62, 10}, {4, 2}}, Evaluatable -> True, 
             CellGroupingRules -> "NormalGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             CellFrameColor -> RGBColor[0.8, 0.700008, 0.6], 
             DefaultFormatType -> DefaultInputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", FormatType -> InputForm, ShowStringCharacters -> True,
              NumberMarks -> True, 
             LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, FontWeight -> 
             "Bold", Background -> GrayLevel[1]], 
            Cell[
             StyleData["InputOnly", "Presentation"], CellFrame -> 6, 
             CellMargins -> {{72, 10}, {5, 2}}, CellFrameMargins -> 12, 
             FontSize -> 18], 
            Cell[
             StyleData["InputOnly", "Printout"], 
             LinebreakAdjustments -> {0.85, 2, 10, 1, 1}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["OutputOnly"], CellFrame -> 4, 
             CellMargins -> {{62, 10}, {4, 2}}, CellEditDuplicate -> True, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             CellFrameColor -> RGBColor[0.8, 0.700008, 0.6], 
             DefaultFormatType -> DefaultOutputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", FormatType -> InputForm, Background -> GrayLevel[1]], 
            
            Cell[
             StyleData["OutputOnly", "Presentation"], CellFrame -> 6, 
             CellMargins -> {{72, 10}, {4, 4}}, CellFrameMargins -> 12, 
             FontSize -> 18], 
            Cell[
             StyleData["OutputOnly", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SymbolicExpression"], CellFrame -> 1, 
             CellMargins -> {{62, 10}, {4, 2}}, CellEditDuplicate -> True, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             CellFrameColor -> GrayLevel[0], DefaultFormatType -> 
             DefaultOutputFormatType, "TwoByteSyntaxCharacterAutoReplacement" -> 
             True, HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, FormatType -> 
             InputForm, FontFamily -> "Courier", FontWeight -> "Plain", 
             FontSlant -> "Plain", FontTracking -> "Plain", 
             FontVariations -> {
              "Outline" -> False, "Shadow" -> False, "Underline" -> False}, 
             Background -> GrayLevel[1]], 
            Cell[
             StyleData["SymbolicExpression", "Presentation"], CellFrame -> 2, 
             CellMargins -> {{72, 10}, {4, 4}}, CellFrameMargins -> 12, 
             FontSize -> 18], 
            Cell[
             StyleData["SymbolicExpression", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Message"], 
             CellMargins -> {{52, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             CellLabelMargins -> {{21, Inherited}, {Inherited, Inherited}}, 
             DefaultFormatType -> DefaultOutputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, FormatType -> 
             InputForm, StyleMenuListing -> None, FontColor -> 
             RGBColor[1, 0, 0]], 
            Cell[
             StyleData["Message", "Presentation"], 
             CellMargins -> {{72, 10}, {6, 6}}, FontSize -> 18], 
            Cell[
             StyleData["Message", "Printout"], 
             CellMargins -> {{30, Inherited}, {Inherited, Inherited}}, 
             FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Print"], 
             CellMargins -> {{52, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, ShowCellLabel -> 
             False, CellLabelMargins -> {{21, Inherited}, {
               Inherited, Inherited}}, DefaultFormatType -> 
             DefaultOutputFormatType, "TwoByteSyntaxCharacterAutoReplacement" -> 
             True, HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, FormatType -> 
             InputForm, StyleMenuListing -> None], 
            Cell[
             StyleData["Print", "Presentation"], 
             CellMargins -> {{72, 10}, {6, 6}}, FontSize -> 18], 
            Cell[
             StyleData["Print", "Printout"], 
             CellMargins -> {{30, Inherited}, {Inherited, Inherited}}]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Info"], 
             CellMargins -> {{52, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, ShowCellLabel -> 
             False, CellLabelMargins -> {{21, Inherited}, {
               Inherited, Inherited}}, DefaultFormatType -> 
             DefaultOutputFormatType, "TwoByteSyntaxCharacterAutoReplacement" -> 
             True, HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, FormatType -> 
             InputForm, StyleMenuListing -> None], 
            Cell[
             StyleData["Info", "Presentation"], 
             CellMargins -> {{72, 10}, {6, 6}}, FontSize -> 18], 
            Cell[
             StyleData["Info", "Printout"], 
             CellMargins -> {{30, Inherited}, {Inherited, Inherited}}]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Graphics"], CellFrame -> {{4, 4}, {4, 0}}, 
             CellMargins -> {{62, 10}, {0, 0}}, CellGroupingRules -> 
             "GraphicsGrouping", CellHorizontalScrolling -> True, 
             PageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             CellFrameColor -> RGBColor[0.8, 0.700008, 0.6], 
             DefaultFormatType -> DefaultOutputFormatType, FormatType -> 
             InputForm, ImageMargins -> {{43, Inherited}, {Inherited, 0}}, 
             StyleMenuListing -> None, Background -> GrayLevel[1]], 
            Cell[
             StyleData["Graphics", "Presentation"], 
             CellFrame -> {{6, 6}, {0, 0}}, CellMargins -> {{72, 10}, {0, 0}},
              CellFrameMargins -> 12, FontSize -> 18], 
            Cell[
             StyleData["Graphics", "Printout"], ImageSize -> {250, 250}, 
             ImageMargins -> {{28, Inherited}, {Inherited, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["ImportPict"], CellMargins -> {{52, 10}, {0, 0}}, 
             CellGroupingRules -> "GraphicsGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GeneratedCell -> True, 
             DefaultFormatType -> DefaultOutputFormatType, FormatType -> 
             InputForm, StyleMenuListing -> "ImportPict", Background -> None],
             
            Cell[
             StyleData["ImportPict", "Presentation"], 
             CellMargins -> {{72, 10}, {0, 0}}, FontSize -> 18], 
            Cell[
             StyleData["ImportPict", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["CellLabel"], StyleMenuListing -> None, FontFamily -> 
             "Helvetica", FontSize -> 10, FontWeight -> "Plain", FontSlant -> 
             "Italic", FontColor -> RGBColor[0.2, 0.2, 0.700008]], 
            Cell[
             StyleData["CellLabel", "Presentation"], FontSize -> 15], 
            Cell[
             StyleData["CellLabel", "Printout"], FontFamily -> "Courier", 
             FontSize -> 8, FontSlant -> "Italic", FontColor -> 
             GrayLevel[0]]}, Open]]}, Open]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Unique Items", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PullQuote"], CellFrame -> {{0, 0}, {0, 3}}, 
             CellMargins -> {{0, 250}, {15, 5}}, 
             CellFrameMargins -> {{20, 4}, {8, 6}}, LineSpacing -> {1, 1}, 
             ParagraphSpacing -> {0, 12}, FontFamily -> "Helvetica", FontSize -> 
             12, FontWeight -> "Bold", FontColor -> GrayLevel[1], Background -> 
             RGBColor[0.6, 0, 0.8]], 
            Cell[
             StyleData["PullQuote", "Presentation"], 
             CellFrame -> {{0, 0}, {0, 5}}, 
             CellMargins -> {{0, 250}, {25, 8}}, 
             CellFrameMargins -> {{30, 10}, {10, 10}}, FontSize -> 18], 
            Cell[
             StyleData["PullQuote", "Printout"], 
             CellMargins -> {{9, 0}, {4, 4}}, ParagraphSpacing -> {0, 6}, 
             FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["GrayBox"], CellFrame -> {{0, 0}, {0, 3}}, 
             CellMargins -> {{62, 36}, {10, 5}}, 
             CellFrameMargins -> {{8, 4}, {8, 4}}, LineSpacing -> {1, 3}, 
             ParagraphSpacing -> {0, 12}, FontFamily -> "Helvetica", FontSize -> 
             10, FontWeight -> "Plain", FontColor -> GrayLevel[0], Background -> 
             RGBColor[0.8, 0.700008, 0.6]], 
            Cell[
             StyleData["GrayBox", "Presentation"], 
             CellFrame -> {{0, 0}, {0, 5}}, 
             CellMargins -> {{90, 55}, {16, 5}}, 
             CellFrameMargins -> {{10, 10}, {12, 6}}, FontSize -> 15], 
            Cell[
             StyleData["GrayBox", "Printout"], 
             CellMargins -> {{62, 36}, {10, 5}}, Background -> 
             GrayLevel[0.8]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Picture"], CellFrame -> 4, 
             CellMargins -> {{52, 10}, {0, 0}}, CellGroupingRules -> 
             "GraphicsGrouping", CellHorizontalScrolling -> True, 
             PageBreakWithin -> False, CellFrameColor -> 
             RGBColor[0.8, 0.700008, 0.6], DefaultFormatType -> 
             DefaultOutputFormatType, FormatType -> InputForm, 
             StyleMenuListing -> None, Background -> GrayLevel[1]], 
            Cell[
             StyleData["Picture", "Presentation"], CellFrame -> 6, 
             CellMargins -> {{72, 10}, {0, 6}}, CellFrameMargins -> 12, 
             FontSize -> 18], 
            Cell[
             StyleData["Picture", "Printout"], ImageSize -> {250, 250}, 
             ImageMargins -> {{28, Inherited}, {Inherited, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PictureGroup"], CellFrame -> {{4, 4}, {0, 0}}, 
             CellMargins -> {{52, Inherited}, {0, 0}}, CellGroupingRules -> 
             "GraphicsGrouping", CellHorizontalScrolling -> True, 
             PageBreakWithin -> False, ShowCellLabel -> False, CellFrameColor -> 
             RGBColor[0.8, 0.700008, 0.6], 
             ImageMargins -> {{43, Inherited}, {Inherited, 0}}, 
             StyleMenuListing -> None, Background -> GrayLevel[1]], 
            Cell[
             StyleData["PictureGroup", "Presentation"], 
             CellFrame -> {{6, 6}, {0, 0}}, CellMargins -> {{72, 10}, {0, 0}},
              CellFrameMargins -> 12, FontSize -> 18], 
            Cell[
             StyleData["PictureGroup", "Printout"], ImageSize -> {250, 250}, 
             ImageMargins -> {{28, Inherited}, {Inherited, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["LineSpace"], CellMargins -> {{0, 0}, {0, 0}}, 
             CellElementSpacings -> {"CellMinHeight" -> 2}, FontSize -> 9], 
            Cell[
             StyleData["LineSpace", "Presentation"], 
             CellMargins -> {{0, 4}, {0, 0}}, FontSize -> 14]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Hyperlink Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Hyperlink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
               ButtonData}], 
            Cell[
             StyleData["Hyperlink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["Hyperlink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["Hyperlink", "SlideShow"]], 
            Cell[
             StyleData["Hyperlink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
         "The following styles are for linking automatically to the on-line \
help system.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["MainBookLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["MainBook", #]}]& )}], 
            Cell[
             StyleData["MainBookLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["MainBookLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["MainBookLink", "SlideShow"]], 
            Cell[
             StyleData["MainBookLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["AddOnsLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontColor -> RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["AddOns", #]}]& )}], 
            Cell[
             StyleData["AddOnsLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["AddOnsLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["AddOnsLink", "SlideShow"]], 
            Cell[
             StyleData["AddOnsLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["RefGuideLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontColor -> RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["RefGuide", #]}]& )}], 
            Cell[
             StyleData["RefGuideLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["RefGuideLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["RefGuideLink", "SlideShow"]], 
            Cell[
             StyleData["RefGuideLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["RefGuideLinkText"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["RefGuide", #]}]& )}], 
            Cell[
             StyleData["RefGuideLinkText", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["RefGuideLinkText", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["RefGuideLinkText", "SlideShow"]], 
            Cell[
             StyleData["RefGuideLinkText", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["GettingStartedLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["GettingStarted", #]}]& )}], 
            Cell[
             StyleData["GettingStartedLink", "Presentation"], FontSize -> 16],
             
            Cell[
             StyleData["GettingStartedLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["GettingStartedLink", "SlideShow"]], 
            Cell[
             StyleData["GettingStartedLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["DemosLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["Demos", #]}]& )}], 
            Cell[
             StyleData["DemosLink", "SlideShow"]], 
            Cell[
             StyleData["DemosLink", "Printout"], 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["TourLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["Tour", #]}]& )}], 
            Cell[
             StyleData["TourLink", "SlideShow"]], 
            Cell[
             StyleData["TourLink", "Printout"], 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["OtherInformationLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["OtherInformation", #]}]& )}], 
            Cell[
             StyleData["OtherInformationLink", "Presentation"], FontSize -> 
             16], 
            Cell[
             StyleData["OtherInformationLink", "Condensed"], FontSize -> 11], 
            
            Cell[
             StyleData["OtherInformationLink", "SlideShow"]], 
            Cell[
             StyleData["OtherInformationLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["MasterIndexLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFrame -> "None", 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["MasterIndex", #]}]& )}], 
            Cell[
             StyleData["MasterIndexLink", "SlideShow"]], 
            Cell[
             StyleData["MasterIndexLink", "Printout"], 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Palette Styles", "Section"], 
         Cell[
         "The cells below define styles that define standard ButtonFunctions, \
for use in palette buttons.", "Text"], 
         Cell[
          StyleData["Paste"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, After]}]& )}], 
         Cell[
          StyleData["Evaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["EvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionMove[
                FrontEnd`InputNotebook[], All, Cell, 1], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Slide Show Styles", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideShowNavigationBar"], Editable -> False, 
             CellFrame -> True, CellMargins -> {{0, 0}, {3, 3}}, 
             CellElementSpacings -> {"CellMinHeight" -> 0.8125}, 
             CellGroupingRules -> {"SectionGrouping", 30}, CellFrameMargins -> 
             False, CellFrameColor -> GrayLevel[1], CellFrameLabelMargins -> 
             False, TextAlignment -> Center, CounterIncrements -> 
             "SlideShowNavigationBar", StyleMenuListing -> None, FontSize -> 
             10, Magnification -> 1, Background -> GrayLevel[0.8], 
             GridBoxOptions -> {
              BaselinePosition -> Center, 
               GridBoxAlignment -> {
                "Columns" -> {
                  Center, Center, Center, Center, Center, Center, Right, {
                   Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
                 "RowsIndexed" -> {}}, 
               GridBoxItemSize -> {
                "Columns" -> {3.5, 3.5, 3.5, 3.5, 13, 5, {4}}, 
                 "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
                 "RowsIndexed" -> {}}, GridBoxSpacings -> {"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}}], 
            Cell[
             StyleData["SlideShowNavigationBar", "SlideShow"], Deletable -> 
             False, ShowCellBracket -> False, 
             CellMargins -> {{-1, -1}, {-1, -1}}, PageBreakAbove -> True, 
             CellFrameMargins -> {{1, 1}, {0, 0}}], 
            Cell[
             StyleData["SlideShowNavigationBar", "Printout"], 
             CellMargins -> {{18, 4}, {4, 4}}, LineSpacing -> {1, 3}, 
             FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideShowSection"], CellFrame -> {{0, 0}, {0, 0.5}}, 
             CellMargins -> {{0, 0}, {10, 0}}, 
             CellGroupingRules -> {"SectionGrouping", 40}, PageBreakBelow -> 
             False, CellFrameMargins -> {{12, 4}, {6, 12}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, CounterIncrements -> "Section", 
             CounterAssignments -> {{"Subsection", 0}, {"Subsubsection", 0}}, 
             StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 
             18, FontWeight -> "Plain", FontColor -> GrayLevel[1], Background -> 
             RGBColor[0.408011, 0.440726, 0.8]], 
            Cell[
             StyleData["SlideShowSection", "Presentation"], 
             CellFrameMargins -> {{18, 10}, {10, 18}}, FontSize -> 27], 
            Cell[
             StyleData["SlideShowSection", "SlideShow"], ShowCellBracket -> 
             False, PageBreakAbove -> True], 
            Cell[
             StyleData["SlideShowSection", "Printout"], 
             CellMargins -> {{18, 30}, {0, 30}}, CellFrameMargins -> 5, 
             FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideHyperlink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontSize -> 26, FontColor -> 
             GrayLevel[0.400015], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonMargins -> 0.5, 
               ButtonMinHeight -> 0.85, ButtonNote -> None}], 
            Cell[
             StyleData["SlideHyperlink", "Presentation"], 
             CellMargins -> {{10, 10}, {8, 12}}, FontSize -> 36], 
            Cell[
             StyleData["SlideHyperlink", "SlideShow"]], 
            Cell[
             StyleData["SlideHyperlink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideTOCLink"], 
             CellMargins -> {{24, Inherited}, {Inherited, Inherited}}, 
             StyleMenuListing -> None, ButtonStyleMenuListing -> Automatic, 
             FontFamily -> "Helvetica", 
             ButtonBoxOptions -> {
              Active -> True, ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonMargins -> 1.5, 
               ButtonNote -> ButtonData}], 
            Cell[
             StyleData["SlideTOCLink", "Presentation"], 
             CellMargins -> {{35, 10}, {6, 4}}, FontSize -> 18], 
            Cell[
             StyleData["SlideTOCLink", "SlideShow"]], 
            Cell[
             StyleData["SlideTOCLink", "Printout"], 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideTOC"], CellDingbat -> "\[Bullet]", 
             CellMargins -> {{18, Inherited}, {Inherited, Inherited}}, 
             StyleMenuListing -> None, FontFamily -> "Helvetica"], 
            Cell[
             StyleData["SlideTOC", "Presentation"], 
             CellMargins -> {{25, 10}, {6, 6}}, FontSize -> 18], 
            Cell[
             StyleData["SlideTOC", "SlideShow"], FontSize -> 14], 
            Cell[
             StyleData["SlideTOC", "Printout"], FontSize -> 10, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Open]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headers and Footers", "Section"], 
         Cell[
          StyleData["Header"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 9, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["Footer"], CellMargins -> {{0, 0}, {0, 4}}, 
          StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 6],
          
         Cell[
          StyleData["PageNumber"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 9, 
          FontWeight -> "Bold"]}, Open]], 
      Cell[
       CellGroupData[{
         Cell["FormatType Styles", "Section"], 
         Cell[
         "The cells below define styles that are mixed in with the styles of \
most cells.  If a cell's FormatType matches the name of one of the styles \
defined below, then that style is applied between the cell's style and its \
own options.", "Text"], 
         Cell[
          StyleData["CellExpression"], CellFrame -> 1, 
          CellMargins -> {{52, 10}, {4, 2}}, ShowCellLabel -> False, 
          CellLabelMargins -> {{23, Inherited}, {Inherited, Inherited}}, 
          ShowSpecialCharacters -> False, AllowInlineCells -> False, 
          StyleMenuListing -> None, FontFamily -> "Courier", FontSize -> 10, 
          FontColor -> GrayLevel[0], Background -> GrayLevel[1]]}, Open]]}, 
     Open]]}, Visible -> False, FrontEndVersion -> 
  "6.0 for Mac OS X x86 (32-bit) (June 19, 2007)", StyleDefinitions -> 
  "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 90, 4, 100, "Title"],
Cell[661, 27, 101, 1, 80, "Subtitle"],
Cell[765, 30, 48, 0, 64, "Subsubtitle"],
Cell[CellGroupData[{
Cell[838, 34, 31, 0, 97, "Section"],
Cell[872, 36, 181, 4, 42, "Text"],
Cell[1056, 42, 37, 0, 78, "Subsubsection"],
Cell[1096, 44, 150, 3, 74, "Input",
 InitializationCell->True]
}, {3}]],
Cell[CellGroupData[{
Cell[1280, 52, 107, 1, 99, "Section"],
Cell[CellGroupData[{
Cell[1412, 57, 9321, 180, 944, "Input"],
Cell[10736, 239, 3885, 78, 621, "Output"]
}, {2}]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14667, 323, 155, 2, 99, "Section"],
Cell[CellGroupData[{
Cell[14847, 329, 9285, 181, 910, "Input"],
Cell[24135, 512, 3890, 77, 621, "Output"]
}, {2}]]
}, Open  ]],
Cell[CellGroupData[{
Cell[28071, 595, 98, 1, 99, "Section"],
Cell[CellGroupData[{
Cell[28194, 600, 9923, 195, 1141, "Input"],
Cell[38120, 797, 4022, 80, 621, "Output"]
}, {2}]]
}, Open  ]],
Cell[CellGroupData[{
Cell[42188, 883, 169, 2, 99, "Section"],
Cell[CellGroupData[{
Cell[42382, 889, 10042, 197, 880, "Input"],
Cell[52427, 1088, 4014, 82, 621, "Output"]
}, {2}]]
}, Open  ]],
Cell[CellGroupData[{
Cell[56487, 1176, 169, 2, 99, "Section"],
Cell[CellGroupData[{
Cell[56681, 1182, 10288, 201, 885, "Input"],
Cell[66972, 1385, 4022, 82, 621, "Output"]
}, {2}]]
}, Open  ]],
Cell[CellGroupData[{
Cell[71040, 1473, 158, 2, 99, "Section"],
Cell[CellGroupData[{
Cell[71223, 1479, 9471, 183, 936, "Input"],
Cell[80697, 1664, 3919, 79, 621, "Output"]
}, {2}]]
}, Open  ]],
Cell[CellGroupData[{
Cell[84662, 1749, 177, 2, 99, "Section"],
Cell[CellGroupData[{
Cell[84864, 1755, 10397, 205, 1029, "Input"],
Cell[95264, 1962, 4075, 82, 621, "Output"]
}, {2}]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
